﻿; Module/File:     Button_AddImage.pb
; Function:        Add stock-image to pb-Button with alignment - Linux gtk2/gtk3
; Author:          Omi
; Date:            Oct. 14, 2014
; Version:         0.3, updt. utf8-handling, activate images in Buttons, gtk-handling
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gtk_button_set_image(*button.GtkButton, *image.GtkWidget);       gtk2.6+
	gtk_button_set_image_position(*button.GtkButton, position)
	gtk_button_set_label(*button.GtkButton, label.p-utf8)
	gtk_image_clear(*image.GtkWidget)
	gtk_button_set_alignment(*button.GtkButton, xalign.f, yalign.f)
	gtk_image_new_from_stock(stock_id.p-utf8, size);                 gtk3.1-
; 	gtk_image_new_from_icon_name(stock_id.p-utf8, size);           gtk2.6+ instead 'gtk_image_new_from_stock'
; 	gtk_image_new_from_file(filename.p-utf8)
	g_object_set(*object.GObject, property_name.p-utf8, *data, v= 0)
EndImport

#MainWin= 0

Enumeration
	#myButton1
	#myButton2
	#myButton3
	#myButton4
	#myButton5
EndEnumeration

Global.i gEvent, gQuit
Global *image1, *image2, *image3, *image4


Procedure ButtonImages_Activate(Show)
	g_object_set(gtk_settings_get_default_(), "gtk-button-images", Show, #Null)
EndProcedure

Procedure ButtonGadget_AddImage(Gadget, *Pic, Label.s, Alignment)
	gtk_button_set_image(GadgetID(Gadget), *Pic)
	gtk_button_set_label(GadgetID(Gadget), Label)
	gtk_button_set_image_position(GadgetID(Gadget), Alignment)
EndProcedure


If OpenWindow(#MainWin, #PB_Ignore, #PB_Ignore, 250, 250, "Button with stock image", #PB_Window_ScreenCentered)
	
	;if icons aren't shown, uncomment the following line ...
	; ButtonImages_Activate(#True)
	
	;use stock-images ...
	;gtk2 - gtk3.1
	*image1= gtk_image_new_from_stock("gtk-go-back", #GTK_ICON_SIZE_MENU)
	*image2= gtk_image_new_from_stock("gtk-find", #GTK_ICON_SIZE_MENU)
	*image3= gtk_image_new_from_stock("gtk-goto-first", #GTK_ICON_SIZE_MENU)
	*image4= gtk_image_new_from_stock("gtk-stop", #GTK_ICON_SIZE_MENU)
	;gtk2.6 up ...
; 	*image1= gtk_image_new_from_icon_name("go-previous", #GTK_ICON_SIZE_MENU)
; 	*image2= gtk_image_new_from_icon_name("edit-find", #GTK_ICON_SIZE_MENU)
; 	*image3= gtk_image_new_from_icon_name("go-first", #GTK_ICON_SIZE_MENU)
; 	*image4= gtk_image_new_from_icon_name("process-stop", #GTK_ICON_SIZE_MENU)
	
	ButtonGadget(#myButton1, 5, 5, 240, 30, "   Button with image", #PB_Button_Toggle)
	 ButtonGadget_AddImage(#myButton1, *image1, "1. Button with image", #GTK_POS_LEFT)
	ButtonGadget(#myButton2, 5, 40, 240, 30, "   Button with image")
	 ButtonGadget_AddImage(#myButton2, *image2, "2. Button with image", #GTK_POS_RIGHT)
	ButtonGadget(#myButton3, 5, 75, 240, 50, "   Button with image")
	 ButtonGadget_AddImage(#myButton3, *image3, "3. Button with image", #GTK_POS_TOP)
	ButtonGadget(#myButton4, 5, 130, 240, 50, "   Button with image")
	 ButtonGadget_AddImage(#myButton4, *image4, "4. Button with image", #GTK_POS_BOTTOM)
	ButtonGadget(#myButton5, 5, 185, 240, 50, "Button with alignment", #PB_Button_Right)
	
	gtk_button_set_alignment(GadgetID(#myButton5), 1.0, 1.0)
	
Else
	End
EndIf

Repeat
	gEvent= WaitWindowEvent()
	If EventWindow() = #MainWin
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
		EndSelect
	EndIf
Until gQuit

;free image-memory...
gtk_image_clear(*image1)
gtk_image_clear(*image2)
gtk_image_clear(*image3)
gtk_image_clear(*image4)

End
; IDE Options = PureBasic 5.31 (Linux - x86)
; CursorPosition = 16
; Folding = -
; EnableUnicode
; EnableXP
; CurrentDirectory = /home/charly-xubuntu/Programming/PureBasic/purebasic/