﻿; Module/File:     Button_AddImage3.pb
; Function:        Add embedded image to pb-Button with alignment, needs decoder - Linux
; Author:          Omi
; Date:            May. 22, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

UsePNGImageDecoder()

ImportC ""
	gtk_button_set_image(*button.GtkButton, *image.GtkWidget);       gtk2.6+
	gtk_button_set_image_position(*button.GtkButton, position)
	gtk_button_set_label(*button.GtkButton, label.p-utf8)
	gtk_image_clear(*image.GtkWidget)
	gtk_button_set_alignment(*button.GtkButton, xalign.f, yalign.f)
	g_object_set(*object.GObject, property_name.p-utf8, *data, v= 0)
EndImport

#Win_Main= 0

Enumeration
	#myButton1
	#myButton2
	#myButton3
	#myButton4
	#myButton5
EndEnumeration

Enumeration
	#Img1
	#Img2
	#Img3
	#Img4
EndEnumeration

Global.i gEvent, gQuit
Global   *image1, *image2, *image3, *image4


Procedure ButtonImages_Activate(Show)
	g_object_set(gtk_settings_get_default_(), "gtk-button-images", Show, #Null)
EndProcedure

Procedure ButtonGadget_AddImage(Gadget, *Pic, Label.s, Alignment)
	gtk_button_set_image(GadgetID(Gadget), *Pic)
	gtk_button_set_label(GadgetID(Gadget), Label)
	gtk_button_set_image_position(GadgetID(Gadget), Alignment)
EndProcedure


If OpenWindow(#Win_Main, #PB_Ignore, #PB_Ignore, 250, 250, "Button with embedded image")
	
	;if icons are not shown, uncomment the following line ...
	; ButtonImages_Activate(#True)
	
	If CatchImage(#Img1, ?Img1) : *image1= gtk_image_new_from_pixbuf_(ImageID(#Img1)) : EndIf
	If CatchImage(#Img2, ?Img2) : *image2= gtk_image_new_from_pixbuf_(ImageID(#Img2)) : EndIf
	If CatchImage(#Img3, ?Img3) : *image3= gtk_image_new_from_pixbuf_(ImageID(#Img3)) : EndIf
	If CatchImage(#Img4, ?Img4) : *image4= gtk_image_new_from_pixbuf_(ImageID(#Img4)) : EndIf
	
	ButtonGadget(#myButton1, 5, 5, 240, 30, "   Button with image", #PB_Button_Toggle)
	 ButtonGadget_AddImage(#myButton1, *image1, "1. Button with image", #GTK_POS_LEFT)
	ButtonGadget(#myButton2, 5, 40, 240, 30, "   Button with image")
	 ButtonGadget_AddImage(#myButton2, *image2, "2. Button with image", #GTK_POS_RIGHT)
	ButtonGadget(#myButton3, 5, 75, 240, 50, "   Button with image")
	 ButtonGadget_AddImage(#myButton3, *image3, "3. Button with image", #GTK_POS_TOP)
	ButtonGadget(#myButton4, 5, 130, 240, 50, "   Button with image")
	 ButtonGadget_AddImage(#myButton4, *image4, "4. Button with image", #GTK_POS_BOTTOM)
	ButtonGadget(#myButton5, 5, 185, 240, 50, "Button with alignment", #PB_Button_Right)
	
	gtk_button_set_alignment(GadgetID(#myButton5), 1.0, 1.0)
	
Else
	End
EndIf

Repeat
	gEvent= WaitWindowEvent()
	
	If EventWindow() = #Win_Main
		
		Select gEvent
				
			Case #PB_Event_CloseWindow
				gQuit= #True
				
		EndSelect
		
	EndIf
Until gQuit

;free image-memory...
gtk_image_clear(*image1)
gtk_image_clear(*image2)
gtk_image_clear(*image3)
gtk_image_clear(*image4)

DataSection
	IncludePath "/usr/share/icons/default.kde4/16x16/actions/"
	Img1:  : IncludeBinary "arrow-left.png"
	Img2:  : IncludeBinary "edit-find.png"
	Img3:  : IncludeBinary "arrow-right.png"
	Img4:  : IncludeBinary "arrow-down.png"
EndDataSection
; IDE Options = PureBasic 5.31 (Linux - x86)
; CursorPosition = 8
; Folding = -
; EnableUnicode
; EnableXP