﻿; Module/File:     Button_AddVolumeButton.pb
; Function:        Add 'volume-button'-widget - Linux
; Author:          Omi
; Date:            Nov. 16, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	g_signal_connect(*instance, detailed_signal.p-ascii, *c_handler, *data, destroy= 0, flags= 0) As "g_signal_connect_data"
	gtk_volume_button_new()
	gtk_scale_button_get_value.d(*widget.GtkWidget)
	gtk_scale_button_set_value(*widget.GtkWidget, value.d)
EndImport

; Object constants
#MainWin= 0
#Txt1   = 0
#Txt2   = 1

#WinX   = 300
#WinY   = 200
#WinW   = 250
#WinH   = 200

Global.i gEvent, gQuit
Global *volumebutton1.GtkWidget

ProcedureC Callback_VolumeButtonChanged(*widget.GtkWidget, user_data)
	If *widget = *volumebutton1
		SetGadgetText(#Txt2, StrD(gtk_scale_button_get_value(*widget), 3))
	EndIf
EndProcedure

Procedure.i VolumeButtonGadget(Gadget, x, y, w, h, startvalue.d)
	Protected.i Container       = ContainerGadget(Gadget, x, y, w, h, #PB_Container_BorderLess)
	Protected.GtkWidget *vbutton= gtk_volume_button_new()
	If Gadget <> #PB_Any : Container= Gadget : EndIf
	gtk_scale_button_set_value(*vbutton, startvalue)
	gtk_container_add_(GadgetID(Container), *vbutton)
	gtk_widget_show_(*vbutton)
	CloseGadgetList()
	ProcedureReturn *vbutton
EndProcedure

If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "Add VolumeButton", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	TextGadget(#Txt1, 5, 20, 100, 22, "Volume-Scale:")
	TextGadget(#Txt2, 160, 20, 40, 22, "")
	*volumebutton1= VolumeButtonGadget(#PB_Any, 110, 10, 40, 40, 0.5)
	
	g_signal_connect(*volumebutton1, "value-changed", @Callback_VolumeButtonChanged(), 0)
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True

		EndSelect
		
	Until gQuit
EndIf
; IDE Options = PureBasic 5.31 (Linux - x86)
; CursorPosition = 47
; FirstLine = 20
; Folding = -
; EnableUnicode
; EnableXP