﻿; Module/File:     Button_AsStockIcon.pb
; Function:        Button: Make pure Icon with button-funtions - Linux
; Author:          Omi
; Date:            Oct. 14, 2014
; Version:         0.3, updt. utf8-handling, activate images in Buttons
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gtk_button_set_image(*button.GtkButton, *image.GtkWidget);       gtk2.6+
	gtk_button_set_image_position(*button.GtkButton, position)
	gtk_image_clear(*image.GtkWidget)
	gtk_image_new_from_stock(stock_id.p-utf8, size);                 gtk3.1-
; 	gtk_image_new_from_icon_name(stock_id.p-utf8, size);           gtk2.6+ instead 'gtk_image_new_from_stock'
	gtk_image_new_from_file(filename.p-utf8)
	g_object_set(*object.GObject, property_name.p-utf8, *data, v= 0)
	;gtk_button_set_alignment(*button.GtkButton, xalign.f, yalign.f)
EndImport

#MainWin= 0

Enumeration
	#myButton1
	#myButton2
	#myButton3
EndEnumeration

Global.i gEvent, gQuit
Global *image1, *image2, *image3

Procedure GetStockIcons()
; ----- loading icons! Set your own image-adresses ...
; 	*image1= gtk_image_new_from_file("/usr/share/icons/default.kde4/16x16/apps/fontforge.png")
; 	*image2= gtk_image_new_from_file("/usr/share/icons/default.kde4/16x16/actions/format-text-bold.png")
; 	*image3= gtk_image_new_from_file("/usr/share/icons/default.kde4/16x16/actions/format-text-italic.png")

; ----- use stock-images with gtk2...
	*image1= gtk_image_new_from_stock("gtk-select-font", #GTK_ICON_SIZE_MENU)
	*image2= gtk_image_new_from_stock("gtk-bold", #GTK_ICON_SIZE_MENU)
	*image3= gtk_image_new_from_stock("gtk-italic", #GTK_ICON_SIZE_MENU)
; ----- use stock-images with gtk2.6 up ...
; 	*image1= gtk_image_new_from_icon_name("document-properties", #GTK_ICON_SIZE_MENU)
; 	*image2= gtk_image_new_from_icon_name("format-text-bold", #GTK_ICON_SIZE_MENU)
; 	*image3= gtk_image_new_from_icon_name("format-text-italic", #GTK_ICON_SIZE_MENU)
EndProcedure

Procedure ButtonImages_SystemActivate(Show)
	g_object_set(gtk_settings_get_default_(), "gtk-button-images", Show, #Null)
EndProcedure

Procedure ButtonGadget_ToIcon(Gadget, *Pic, Alignment)
	gtk_button_set_image(GadgetID(Gadget), *Pic)
	gtk_button_set_image_position(GadgetID(Gadget), Alignment)
EndProcedure

If OpenWindow(#MainWin, #PB_Ignore, #PB_Ignore, 250, 250, "Linux-Icon as Button", #PB_Window_ScreenCentered)
	
	GetStockIcons()
	
	;if icons are not shown, uncomment the following line ...
	; ButtonImages_SystemActivate(#True)
	
	ButtonGadget(#myButton1, 5, 2, 28, 28, "")
	 ButtonGadget_ToIcon(#myButton1, *image1, #GTK_POS_LEFT)
	ButtonGadget(#myButton2, 35, 2, 28, 28, "", #PB_Button_Toggle)
	 ButtonGadget_ToIcon(#myButton2, *image2, #GTK_POS_LEFT)
	ButtonGadget(#myButton3, 65, 2, 28, 28, "", #PB_Button_Toggle)
	 ButtonGadget_ToIcon(#myButton3, *image3, #GTK_POS_LEFT)
	
	
	Repeat
		gEvent= WaitWindowEvent()
		If EventWindow() = #MainWin
			Select gEvent
				Case #PB_Event_CloseWindow
					gQuit= #True
			EndSelect
		EndIf
	Until gQuit
	
	; ----- free image-memory...
	gtk_image_clear(*image1)
	gtk_image_clear(*image2)
	gtk_image_clear(*image3)
EndIf

End
; IDE Options = PureBasic 5.31 (Linux - x86)
; CursorPosition = 10
; Folding = -
; EnableUnicode
; EnableXP
; CurrentDirectory = /home/charly-xubuntu/Programming/PureBasic/purebasic/