﻿; Module/File:     Button_FontButton.pb
; Function:        Add FontButton with font chooser - Linux gtk2.4+
; Author:          Omi
; Date:            Dec. 06, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gtk_font_button_new_with_font(fontname.p-utf8)
	g_signal_connect(*instance, detailed_signal.p-ascii, *c_handler, *data, destroy= 0, flags= 0) As "g_signal_connect_data"
EndImport

; Object constants
#MainWin= 0

#Text1  = 0

#WinX   = 300
#WinY   = 200
#WinW   = 300
#WinH   = 100

Global.i gEvent, gQuit
Global gFont


ProcedureC Callback_FontSet(*widget.GtkWidget, user_data)
	If *widget = gFont
		Debug PeekS(gtk_font_button_get_font_name_(*widget), -1, #PB_UTF8)
		Debug "style in name: " + Str(gtk_font_button_get_show_style_(*widget))
		Debug "size in name : " + Str(gtk_font_button_get_show_size_(*widget))
	EndIf
EndProcedure

Procedure.i FontButtonGadget(Gadget, x, y, w, h, fontname.s= "")
	Protected.i Container= ContainerGadget(Gadget, x, y, w, h, #PB_Container_Flat)
	Protected *fButton
	If fontname = ""
		*fButton= gtk_font_button_new_()
	Else
		*fButton= gtk_font_button_new_with_font(fontname)
	EndIf

	If Gadget <> #PB_Any : Container= Gadget : EndIf
	gtk_container_add_(GadgetID(Container), *fButton)
	gtk_widget_show_(*fButton)
	CloseGadgetList()
	ProcedureReturn *fButton
EndProcedure

If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "Add ColorButton", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	TextGadget(#Text1, 5, 10, 100, 22, "change font: ")
	gFont= FontButtonGadget(#PB_Any, 95, 5, 200, 32);, "monospace 10");    uncomment for preset e.g. monospace w. height= 10
	
	g_signal_connect(gFont, "font-set", @Callback_FontSet(), 0)
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True

		EndSelect
		
	Until gQuit
EndIf
; IDE Options = PureBasic 5.31 (Linux - x86)
; CursorPosition = 46
; FirstLine = 25
; Folding = -
; EnableUnicode
; EnableXP