﻿; Module/File:     Button_GtkArrowClickable.pb
; Function:        Add switchable gtk-arrow - Linux
; Author:          Omi
; Date:            Nov. 16, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	g_signal_connect(*instance, detailed_signal.p-ascii, *c_handler, *data, destroy= 0, flags= 0) As "g_signal_connect_data"
EndImport

; Object constants
#MainWin= 0
#Txt1   = 0
#Txt2   = 1
#Txt3   = 2
#Txt4   = 3

#WinX   = 0
#WinY   = 0
#WinW   = 200
#WinH   = 200

Global.i gEvent, gQuit
Global.GtkWidget *gArrow1, *gArrow2, *gArrow3, *gArrow4

ProcedureC Callback_ArrowPressed(*widget.GtkWidget, *signal)
	Protected *color.GdkColor
	If PeekI(*signal) = #GDK_BUTTON_PRESS
		If *widget = *gArrow1
			Debug "arrow down clicked"
		ElseIf *widget = *gArrow2
			Debug "arrow up clicked"
		ElseIf *widget = *gArrow3
			Debug "arrow left clicked"
		ElseIf *widget = *gArrow4
			Debug "arrow right clicked"
		EndIf
	EndIf
EndProcedure

Procedure.i ArrowGadget(Gadget, x, y, w, h, type)
	Protected.i Container     = ContainerGadget(Gadget, x, y, w, h, #PB_Container_Flat); blank? #PB_Container_BorderLess
	Protected *arrow.GtkWidget= gtk_arrow_new_(type, #GTK_SHADOW_ETCHED_OUT)
	If Gadget <> #PB_Any : Container= Gadget : EndIf
	gtk_container_add_(GadgetID(Container), *arrow)
	Protected *EventBox       = gtk_widget_get_parent_(*arrow);                   get widget-EventBox
	gtk_widget_add_events_(*EventBox, #GDK_BUTTON_PRESS_MASK);                    add click event
	g_signal_connect(*EventBox, "button-press-event", @Callback_ArrowPressed(), *arrow, #Null, #G_CONNECT_SWAPPED)
	gtk_widget_show_(*arrow)
	CloseGadgetList()
	ProcedureReturn *arrow
EndProcedure

If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "Add switchable gtk-arrow ", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	TextGadget(#Txt1, 5, 10, 140, 22, "clickable arrow down")
	TextGadget(#Txt2, 5, 35, 140, 22, "clickable arrow up")
	TextGadget(#Txt3, 5, 60, 140, 22, "clickable arrow left")
	TextGadget(#Txt4, 5, 85, 140, 22, "clickable arrow right")

	*gArrow1= ArrowGadget(#PB_Any, 150, 10, 20, 20, #GTK_ARROW_DOWN)
	*gArrow2= ArrowGadget(#PB_Any, 150, 35, 20, 20, #GTK_ARROW_UP)
	*gArrow3= ArrowGadget(#PB_Any, 150, 60, 20, 20, #GTK_ARROW_LEFT)
	*gArrow4= ArrowGadget(#PB_Any, 150, 85, 20, 20, #GTK_ARROW_RIGHT)
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True

		EndSelect
		
	Until gQuit
EndIf
; IDE Options = PureBasic 5.31 (Linux - x86)
; CursorPosition = 8
; Folding = -
; EnableUnicode
; EnableXP