﻿; Module/File:     Gadget_ButtonRepeatTimeout.pb
; Function:        Changes timeout for repeat-buttons - Linux gtk2
; Author:          Omi
; Date:            Jun. 16, 2015
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------


EnableExplicit

ImportC ""
	gtk_adjustment_new(value.d, lower.d, upper.d, step_increment.d, page_increment.d, page_size.d)
	gtk_spin_button_new(*adjustment.GtkAdjustment, climb_rate.d, digits.i)
	g_object_set(*object.GObject, property_name.p-utf8, *data, v= 0)
	g_object_get(*object.GObject, property_name.p-utf8, *data, v= 0)
EndImport

; Object constants
#MainWin= 0
#BT     = 0

Global.i gEvent, gQuit
Global.i gRptTime;                                                   necessary to save old value
Global.GtkWidget *SButton1, *gSettings

;API-SpinWidget only for demonstration ...
Procedure SpinButtonGadget(Gadget, x, y, w, h, value.d, lower.d, upper.d, step_inc.d, page_inc.d, digits)
	Protected.i Container              = ContainerGadget(Gadget, x, y, w, h, #PB_Container_BorderLess)
	Protected *adjustment.GtkAdjustment= gtk_adjustment_new(value, lower, upper, step_inc, page_inc, #Null)
	Protected *sbutton.GtkWidget       = gtk_spin_button_new(*adjustment, 1.0, digits)
	If Gadget <> #PB_Any : Container= Gadget : EndIf
	gtk_spin_button_set_numeric_(*sbutton, #True)
	gtk_widget_set_size_request_(*sbutton, GadgetWidth(Container)- 4, -1)
	gtk_container_add_(GadgetID(Container), *sbutton)
	gtk_widget_show_(*sbutton)
	CloseGadgetList()
	ProcedureReturn *sbutton
EndProcedure

If OpenWindow(#MainWin, 300, 200, 350, 150, "Button repeat timeout", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	ButtonGadget(#BT, 5, 5, 340, 26, "Push for slow button repeat ON (fixed in gtk3)", #PB_Button_Toggle)
	TextGadget(#PB_Any, 5, 54, 230, 22, "Scroll with Button On and OFF ...")
	*SButton1= SpinButtonGadget(#PB_Any, 240, 50, 60, 30, 50, 0, 100, 2, 10, 0)
	
	*gSettings= gtk_settings_get_default_();                           necessary
	g_object_get(*gSettings, "gtk-timeout-repeat", @gRptTime);         save current timeout value
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
				
			Case #PB_Event_Gadget
				If EventGadget()= #BT
					If GetGadgetState(#BT)
						g_object_set(*gSettings, "gtk-timeout-repeat", 100);               set 'slower' value
					Else
						g_object_set(*gSettings, "gtk-timeout-repeat", gRptTime);          set default value
					EndIf
				EndIf
				
		EndSelect
		
	Until gQuit
EndIf
; IDE Options = PureBasic 5.31 (Linux - x86)
; CursorPosition = 8
; Folding = -
; EnableUnicode
; EnableXP