﻿; Module/File:     Button_ShowIconsOnSys.pb
; Function:        General activate display of button-images - Linux
; Author:          Omi
; Date:            Oct. 16 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gtk_button_set_image(*button.GtkButton, *image.GtkWidget);       gtk2.6+
	gtk_button_set_image_position(*button.GtkButton, position)
	gtk_button_set_label(*button.GtkButton, label.p-utf8)
	gtk_image_clear(*image.GtkWidget)
	gtk_image_new_from_stock(stock_id.p-utf8, size);                 gtk3.1-
; 	gtk_image_new_from_icon_name(stock_id.p-utf8, size);           gtk2.6+ instead 'gtk_image_new_from_stock'
	gtk_image_new_from_file(filename.p-utf8)
	g_object_set(*object.GObject, property_name.p-utf8, *data, v= 0)
EndImport

#MainWin= 0

Enumeration
	#myButton1
	#myButton2
	#myButton3
	#myButton4
EndEnumeration

Global.i gEvent, gQuit
Global *image1, *image2, *image3

;***
Procedure ButtonImages_SystemActivate(Show)
	g_object_set(gtk_settings_get_default_(), "gtk-button-images", Show, #Null)
EndProcedure
;***

; for demonstration ...
Procedure ButtonGadget_AddImage(Gadget, *Pic, Label.s, Alignment)
	gtk_button_set_image(GadgetID(Gadget), *Pic)
	gtk_button_set_label(GadgetID(Gadget), Label)
	gtk_button_set_image_position(GadgetID(Gadget), Alignment)
EndProcedure


If OpenWindow(#MainWin, #PB_Ignore, #PB_Ignore, 250, 250, "Enable images on buttons")
	;use stock-images ...
	*image1= gtk_image_new_from_stock("gtk-go-back", #GTK_ICON_SIZE_MENU);  #GTK_ICON_SIZE_BUTTON
	*image2= gtk_image_new_from_stock("gtk-find", #GTK_ICON_SIZE_MENU)
	*image3= gtk_image_new_from_stock("gtk-goto-first", #GTK_ICON_SIZE_MENU)
	
	ButtonGadget(#myButton1, 5, 5, 200, 30, "   Button with image", #PB_Button_Toggle)
	 ButtonGadget_AddImage(#myButton1, *image1, "1. Button with image", #GTK_POS_LEFT)
	ButtonGadget(#myButton2, 5, 40, 200, 30, "   Button with image")
	 ButtonGadget_AddImage(#myButton2, *image2, "2. Button with image", #GTK_POS_RIGHT)
	ButtonGadget(#myButton3, 5, 75, 200, 50, "   Button with image")
	 ButtonGadget_AddImage(#myButton3, *image3, "3. Button with image", #GTK_POS_TOP)
	 
	ButtonGadget(#myButton4, 5, 150, 240, 28, "Show Button-Icons", #PB_Button_Toggle)
	SetGadgetState(#myButton4, #True)
	ButtonImages_SystemActivate(#True)
	
	Repeat
		gEvent= WaitWindowEvent()
		If EventWindow() = #MainWin
			Select gEvent
				Case #PB_Event_CloseWindow
					gQuit= #True
					
				Case #PB_Event_Gadget
					If EventGadget() = #myButton4
						ButtonImages_SystemActivate(GetGadgetState(#myButton4))
					EndIf
			EndSelect
		EndIf
	Until gQuit
	
	; ----- free image-memory...
	gtk_image_clear(*image1)
	gtk_image_clear(*image2)
	gtk_image_clear(*image3)
EndIf

End
; IDE Options = PureBasic 5.31 (Linux - x86)
; CursorPosition = 10
; Folding = -
; EnableUnicode
; EnableXP