﻿; Module/File:     Button_Toggle_readonly.pb
; Function:        Set an Toggle-Button(Image)Gadget as readonly (not user changeable) - Linux
; Author:          Omi
; Date:            Feb. 20, 2016 ☑
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.4x
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	g_signal_connect(*instance, detailed_signal.p-utf8, *c_handler, *pdata, destroy= 0, flags= 0) As "g_signal_connect_data"
	gtk_icon_theme_load_icon(*icon_theme.GtkIconTheme, icon_name.p-utf8, size, flags, *error.GError)
EndImport

; Object constants
#Win_Main= 0

#But1    = 0
#But2    = 1
#But3    = 2

Global.i gEvent, gQuit

; search file from name in default icon theme and return pixbuf or Null ...
Procedure IconDefaultTheme_LoadIconFromName(icon_name.s, icon_size, flags);    NOT NEEDED for readonly mode, just example for loading image
	Protected *pixbuf
	Protected *error.GError
	
	*pixbuf= gtk_icon_theme_load_icon(gtk_icon_theme_get_default_(), icon_name, icon_size, flags, @*error)
	If *error : Debug PeekS(*error\message, -1, #PB_UTF8) : EndIf
	ProcedureReturn *pixbuf
EndProcedure

ProcedureC Callback_TogglebuttonClickBlocked(*widget.GtkWidget, *Event.GdkEventButton, user_data)
	Select user_data
			Case #But2, #But3
			If *Event\type = #GDK_BUTTON_PRESS
				Debug "No change from user allowed for ToggleButton " + Str(user_data)
				ProcedureReturn #True;                                                 no further action
			EndIf
	EndSelect
EndProcedure

Procedure Create_WinMain()
	If OpenWindow(#Win_Main, 300, 200, 300, 120, "ToggleButtonGadget (readonly)", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
		ButtonGadget     (#But1,  5,  5, 200, 26, "I'm toggleable",    #PB_Button_Toggle)
		ButtonGadget     (#But2,  5, 35, 200, 26, "Try me too!", #PB_Button_Toggle)
		;add systemicon to ButtonImageGadget ...
		ButtonImageGadget(#But3,  5, 65,  28, 28, IconDefaultTheme_LoadIconFromName("edit-clear", 16, 0), #PB_Button_Toggle)
		
		g_signal_connect(GadgetID(#But2), "button-press-event", @Callback_TogglebuttonClickBlocked(), #But2)
		g_signal_connect(GadgetID(#But3), "button-press-event", @Callback_TogglebuttonClickBlocked(), #But3)
		
		SetGadgetState(#But2, 1)
	EndIf
EndProcedure

Create_WinMain()

Repeat
	gEvent= WaitWindowEvent()
	
	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
	EndSelect
Until gQuit
; IDE Options = PureBasic 5.42 LTS (Linux - x86)
; CursorPosition = 44
; FirstLine = 40
; Folding = -
; EnableUnicode
; EnableXP