﻿; Module/File:     ComboBox_EnabledModes.pb
; Function:        extended ComboBox sensitivity modes - Linux
; Author:          Omi
; Date:            Sep. 03, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gtk_combo_box_get_button_sensitivity(*combo_box.GtkComboBox)
	gtk_combo_box_set_button_sensitivity(*combo_box.GtkComboBox, sensitivity)
EndImport

#MainWin= 0

Enumeration
	#myCB1
	#myCB2
	#myCB3
	#myCB4
EndEnumeration

Enumeration GtkSensitivityType
	#GTK_SENSITIVITY_AUTO
	#GTK_SENSITIVITY_ON
	#GTK_SENSITIVITY_OFF
EndEnumeration

Global.i gEvent, gQuit, I


If OpenWindow(#MainWin, #PB_Ignore, #PB_Ignore, 400, 200, "ComboBox sensitivity modes", #PB_Window_ScreenCentered)
	TextGadget(#PB_Any, 5, 10, 190, 20, "AUTO without entries", #PB_Text_Right)
	TextGadget(#PB_Any, 5, 45, 190, 20, "AUTO with entries", #PB_Text_Right)
	TextGadget(#PB_Any, 5, 80, 190, 20, "Always ON, without entries", #PB_Text_Right)
	TextGadget(#PB_Any, 5, 115, 190, 20, "Always OFF, with entries", #PB_Text_Right)
	ComboBoxGadget(#myCB1, 200, 5, 150, 30)
	ComboBoxGadget(#myCB2, 200, 40, 150, 30)
	ComboBoxGadget(#myCB3, 200, 75, 150, 30)
	ComboBoxGadget(#myCB4, 200, 110, 150, 30)
	
	For I= 1 To 5
		AddGadgetItem(#myCB2, -1, "item #"+ Str(I))
	Next I
	
	For I= 1 To 5
		AddGadgetItem(#myCB4, -1, "item #"+ Str(I))
	Next I
	
	gtk_combo_box_set_button_sensitivity(GadgetID(#myCB1), #GTK_SENSITIVITY_AUTO)
	gtk_combo_box_set_button_sensitivity(GadgetID(#myCB2), #GTK_SENSITIVITY_AUTO)
	gtk_combo_box_set_button_sensitivity(GadgetID(#myCB3), #GTK_SENSITIVITY_ON)
	gtk_combo_box_set_button_sensitivity(GadgetID(#myCB4), #GTK_SENSITIVITY_OFF)
	
	;gtk_combo_box_get_button_sensitivity(GadgetID(#myCB1));            read sensitivity
	
Else
	End
EndIf

Repeat
	gEvent= WaitWindowEvent()
	If EventWindow() = #MainWin
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
		EndSelect
	EndIf
Until gQuit

End
; IDE Options = PureBasic 5.40 LTS Beta 9 (Linux - x86)
; CursorPosition = 33
; EnableUnicode
; EnableXP