﻿; Module/File:     Dialog_RecentChooserSys.pb
; Function:        Standard-Sys-RecentFile-Dialog with optional filter / tooltips - Linux gtk/gtk3
; Author:          Omi
; Date:            Nov. 20, 2015
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	;Import with 2 Buttons ...
	gtk_recent_chooser_dialog_new(title.p-utf8, *parent.GtkWindow, button_text1.p-utf8, button_resp1.l, button_text2.p-utf8, button_resp2.l, Term= #Null) As "gtk_recent_chooser_dialog_new"
	gtk_recent_chooser_get_current_item(*chooser)
	gtk_recent_chooser_set_show_tips(*chooser, show_tips)
	gtk_recent_chooser_set_filter(*chooser, *filter)
	gtk_recent_info_get_uri_display(*info)
	gtk_recent_filter_new()
	gtk_recent_filter_add_pattern(*filter, pattern.p-utf8)
	gtk_recent_filter_set_name(*filter, name.p-utf8)
	gtk_dialog_run.l(*dialog.GtkDialog)
EndImport

; object variables
#MainWin= 0

#But1   = 0
#Txt1   = 1


Global.i gEvent, gQuit
Global   *gRecentInfo

Procedure.i ShowRecentChooseDialog(title.s, ParentWindow, filter.s, button1.s, resp1.l, button2.s, resp2.l)
	Protected *chooser= gtk_recent_chooser_dialog_new(title, WindowID(ParentWindow), button1, resp1, button2, resp2)
	Protected *RecentInfo
	
	If filter <> ""
		Protected *rffilter= gtk_recent_filter_new()
		gtk_recent_filter_set_name(*rffilter, filter)
		gtk_recent_filter_add_pattern(*rffilter, filter)
		gtk_recent_chooser_set_filter(*chooser, *rffilter)
	EndIf
	
; 	gtk_recent_chooser_set_show_tips(*chooser, #True);                            activate tooltips
	
	If gtk_dialog_run(*chooser) = #GTK_RESPONSE_OK
		*RecentInfo= gtk_recent_chooser_get_current_item(*chooser)
	EndIf
	gtk_widget_destroy_(*chooser)
	
	ProcedureReturn *RecentInfo
EndProcedure


If OpenWindow(#MainWin, 300, 200, 500, 200, "RecentChooser dialog", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	ButtonGadget(#But1, 5,  5, 490, 26, "Open RecentChooser dialog")
	TextGadget  (#Txt1, 5, 35, 490, 35, "")
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
				
			Case #PB_Event_Gadget
				If EventGadget() = #But1
					*gRecentInfo= ShowRecentChooseDialog("RecentChooserDialog", #MainWin, "*.pb", "gtk-cancel", #GTK_RESPONSE_CANCEL, "gtk-ok", #GTK_RESPONSE_OK)
					If *gRecentInfo
						SetGadgetText(#Txt1, PeekS(gtk_recent_info_get_uri_display(*gRecentInfo), -1, #PB_UTF8))
					Else
						SetGadgetText(#Txt1, "")
					EndIf
				EndIf
				
		EndSelect
		
	Until gQuit
EndIf
; IDE Options = PureBasic 5.40 LTS (Linux - x86)
; CursorPosition = 8
; Folding = -
; EnableUnicode
; EnableXP