﻿; Module/File:     Dialog_SmallMessageNoButtons.pb
; Function:        gtk-Dialog text + closer, w/o Buttons,  - Linux
; Author:          Omi
; Date:            Oct. 11, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

;DialogBox-Response ...
; #GTK_RESPONSE_NONE        = -1
; #GTK_RESPONSE_REJECT      = -2
; #GTK_RESPONSE_ACCEPT      = -3
; #GTK_RESPONSE_DELETE_EVENT=  MessageBox closed via Window-Close
; #GTK_RESPONSE_OK          =  MessageBox OK
; #GTK_RESPONSE_CANCEL      =  MessageBox Cancel
; #GTK_RESPONSE_YES         =  MessageBox Yes
; #GTK_RESPONSE_NO          =  MessageBox No
; #GTK_RESPONSE_APPLY       = -10,
; #GTK_RESPONSE_HELP        = -11

EnableExplicit

ImportC ""
	gtk_window_set_modal(*window.GtkWindow, modal)
	gtk_window_set_title(*window.GtkWindow, title.p-utf8)
	gtk_dialog_get_content_area(*dialog.GtkDialog)
	gtk_label_new(str.p-utf8)
	gtk_image_new_from_stock(stock_id.p-utf8, size)
EndImport

; Object constants
#MainWin=0
#But1= 0
#But2= 1
#But3= 2
#But4= 3

#WinX=300
#WinY=200
#WinW=300
#WinH=130

Global.i gEvent, gQuit

Procedure.l DialogBoxSmallMessage(DlgTitle.s, DlgBody.s, DlgIcon.s)
	Protected hbox
	Protected *dialog.GtkWidget, *label.GtkWidget, *image.GtkWidget
	Protected.l Response; prev. .i with wrong Return on 64-Bit
	
	*dialog= gtk_dialog_new_()
	gtk_window_set_modal(*dialog, #True)
	gtk_window_set_resizable_(*dialog, #False)
	gtk_window_set_title(*dialog, DlgTitle)
	hbox= gtk_hbox_new_(#False, 0)
	gtk_container_set_border_width_(hbox, 8)
	gtk_box_pack_start_(gtk_dialog_get_content_area(*dialog), hbox, #False, #False, 0)
	
	*image= gtk_image_new_from_stock(DlgIcon, #GTK_ICON_SIZE_DIALOG)
	gtk_box_pack_start_(hbox, *image, #False, #False, 0)
	
	*label= gtk_label_new(DlgBody)
	gtk_box_pack_start_(hbox, *label, #False, #False, 10)

	gtk_widget_show_all_(*dialog)
	Response= gtk_dialog_run_(*dialog)
	gtk_widget_destroy_(*dialog)
	ProcedureReturn Response
EndProcedure


;- Main ...
If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "native Dialogbox", #PB_Window_SystemMenu)
	ButtonGadget(#But1, 5, 5, 290, 26, "gtk-Error-Dialog o. Buttons")
	ButtonGadget(#But2, 5, 35, 290, 26, "gtk-Info-Dialog o. Buttons")
	ButtonGadget(#But3, 5, 65, 290, 26, "gtk-Warn-Dialog o. Buttons")
	ButtonGadget(#But4, 5, 95, 290, 26, "gtk-Question-Dialog o. Buttons")
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
				
			Case #PB_Event_CloseWindow
				gQuit= #True
				
			Case #PB_Event_Gadget
				
				Select EventGadget()
						
					Case #But1
						Debug DialogBoxSmallMessage("gtk-mini-error", "You shouldn't push this Button again ;-)!" + #LF$ + "The 2. Line.", "gtk-dialog-error")
						
					Case #But2
						Debug DialogBoxSmallMessage("gtk-mini-info", "Sie haben diesen Buttons noch einmal gedrückt!" + #LF$ + "Die 2. Zeile.", "gtk-dialog-info")
						
					Case #But3
						Debug DialogBoxSmallMessage("gtk-mini-warnung", "I would like to give you a warning!" + #LF$ + "The 2. Line.", "gtk-dialog-warning")

					Case #But4
						Debug DialogBoxSmallMessage("gtk-mini-info", "Warum haben Sie diese Buttons schon wieder gedrückt?" + #LF$ + "Die 2. Zeile.", "gtk-dialog-question")

				EndSelect
				
		EndSelect
		
	Until gQuit
EndIf
; IDE Options = PureBasic 5.40 LTS Beta 9 (Linux - x86)
; CursorPosition = 8
; Folding = -
; EnableUnicode
; EnableXP
; CurrentDirectory = /home/charly-xubuntu/Programming/PureBasic/purebasic/