﻿; Module/File:     Display_GetDefault.pb
; Function:        Get Default-Display & some display informations - Linux
; Author:          Omi
; Date:            Dec. 12, 2016
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.4
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gdk_display_manager_get()
	gdk_display_manager_list_displays(*display_manager)
	g_slist_length(*list.GSList)
	g_slist_free(*list.GSList)
	gdk_display_get_default()
; 	gdk_display_get_device_manager(*display.GdkDisplay); gtk3
	gdk_display_get_name(*display.GdkDisplay)
	gdk_display_supports_shapes(*display.GdkDisplay)
	gdk_display_get_default_cursor_size(*display.GdkDisplay)
	gdk_display_get_maximal_cursor_size(*display.GdkDisplay, *width, *height)
	gdk_display_supports_input_shapes(*display.GdkDisplay)
	gdk_display_supports_cursor_color(*display.GdkDisplay)
	gdk_display_supports_cursor_alpha(*display.GdkDisplay)
EndImport
	
; Object constants
#Win_Main  = 0


Global.i gEvent, gQuit
Global   *gDisplay.GdkDisplay
Global   *gDisplayManager, *gGSList.GSList
Global.i gCWidth, gCHeight

Procedure Create_WinMain()
	If OpenWindow(#Win_Main, 300, 200, 500, 100, "Get default display ...", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
		ButtonGadget(0, 5, 5, 490, 26, "Debug Default-display and some infos...")
	EndIf
EndProcedure

Create_WinMain()

Repeat
	gEvent= WaitWindowEvent()
	
	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
			
		Case #PB_Event_Gadget
			If EventGadget()= 0
				*gDisplayManager= gdk_display_manager_get()
				*gGSList        = gdk_display_manager_list_displays(*gDisplayManager)
				*gDisplay       = gdk_display_get_default()
				Debug "Available displays                  : " + g_slist_length(*gGSList) : g_slist_free(*gGSList)
				Debug "Default display ..."
				Debug "Display-adress                      : " + Str(*gDisplay)
				Debug "Display-name                        : " + PeekS(gdk_display_get_name_(*gDisplay), -1, #PB_UTF8)
; 				Debug "Display: DeviceManager              : " + gdk_display_get_device_manager(*gDisplay); gtk3
				Debug "Display: Number of screens          : " + gdk_display_get_n_screens_(*gDisplay)
				Debug "Display window shape possible       : " + gdk_display_supports_shapes(*gDisplay)
				Debug "Display window input shape possible : " + gdk_display_supports_input_shapes(*gDisplay)
				Debug "Display cursor default size (pix)   : " + gdk_display_get_default_cursor_size(*gDisplay)
				gdk_display_get_maximal_cursor_size(*gDisplay, @gCWidth, @gCHeight)
				Debug "Display cursor max size (pix)       : " + gCWidth + "x" + gCHeight
				Debug "Display multicolored cursor possible: " + gdk_display_supports_cursor_color(*gDisplay)
				Debug "Display cursor has alpha channel    : " + gdk_display_supports_cursor_alpha(*gDisplay)
			EndIf
			
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.42 LTS (Linux - x86)
; CursorPosition = 60
; Folding = -
; EnableXP