﻿; Module/File:     Editor_GetBufferCurposInChars.pb
; Function:        Get cursor position in textbuffer in char-offset - Linux
; Author:          Omi
; Date:            Mar. 30, 2015
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	g_object_get_property(*object.GObject, property.p-utf8, *gval)
EndImport

; Object constants
#MainWin= 0
#Edt1   = 0
#Bt1    = 1

#WinX= 300
#WinY= 200
#WinW= 300
#WinH= 200

Macro G_TYPE_MAKE_FUNDAMENTAL(x)
	((x) << 2)
EndMacro

;GType ...
#G_TYPE_INT      = G_TYPE_MAKE_FUNDAMENTAL(6)


Global.i gEvent, gQuit
Global.s EditString1= "PureBasic... " + #LF$ + #LF$ + "ist eine 'Hochsprachen' Programmiersprache, die auf den bekannten 'BASIC'-Regeln basiert. " + 
             "Sie ist größtenteils kompatibel mit jedem anderen 'BASIC'-Compiler, egal ob für das Amiga- oder PC-Format. " + 
             "Das Erlernen von PureBasic ist sehr leicht! PureBasic ist für Anfänger genauso wie für Experten geschaffen worden. " + 
             "Die Übersetzungsgeschwindigkeit ist wirklich schnell. Diese Software wurde für das Windows- Operating-System entwickelt. " + #LF$ +
             "Wir haben eine Menge Anstrengungen in ihre Realisierung gesetzt, um eine schnelle, zuverlässige und systemfreundliche Sprache zu produzieren. " + #LF$ +
             "Die Syntax ist einfach, aber mit den fortgeschrittenen Funktionen von PureBasic wie z.B. Zeigern, Strukturen, Prozeduren und dynamisch verknüpften Listen sind die Möglichkeiten unbegrenzt. " + 
             "Für den erfahrenen Programmierer gibt es keine Probleme, Zugang zu irgendwelchen legalen OS-Strukturen oder API-Objekten zu bekommen." + #LF$ +
             "PureBasic ist eine portable Sprache, welche zur Zeit auf den AmigaOS, Linux, MacOS X und Windows Computersystemen arbeitet. " + #LF$ +
             "Dies bedeutet, dass derselbe Programmcode für jedes System nativ kompiliert werden kann und trotzdem die volle Power des jeweiligen Systems ausnutzt. " + 
             "Es gibt keine Flaschenhälse wie einen virtuellen Prozessor oder einen Code-Übersetzer; der generierte Code produziert ein optimiertes Executable."

Procedure.i Editor_GetBufferCurpos(Gadget)
	Protected *buffer= gtk_text_view_get_buffer_(GadgetID(Gadget))
	Protected gVal.GValue
	Protected PosInChars
	
	g_value_init_(@gVal, #G_TYPE_INT)
	g_object_get_property(*buffer, "cursor-position", @gVal)
	PosInChars= g_value_get_int_(@gVal)
	g_value_unset_(@gVal)
	ProcedureReturn PosInChars
EndProcedure

If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "EditorGadget-Buffer-Cursorposition", #PB_Window_SystemMenu)
	ButtonGadget(#Bt1, 5, 5, 190, 26, "Get cursorposition in chars")
	EditorGadget(#Edt1, 5, 35, #WinW-10, #WinH-39, #PB_Editor_WordWrap)
	AddGadgetItem(#Edt1, -1, EditString1)
	
	gtk_text_view_set_wrap_mode_(GadgetID(#Edt1), #GTK_WRAP_WORD)
	gtk_button_set_focus_on_click_(GadgetID(#Bt1), #False)
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
				
			Case #PB_Event_Gadget
				Select EventGadget()
						Case #Bt1
							Debug "Cursorposition in chars: " + Str(Editor_GetBufferCurpos(#Edt1))
							
				EndSelect

		EndSelect
		
	Until gQuit
EndIf
; IDE Options = PureBasic 5.41 LTS (Linux - x64)
; CursorPosition = 12
; Folding = -
; EnableUnicode
; EnableXP