﻿; Module/File:     Editor_GetScrolledWindowBasicInfos.pb
; Function:        EditorGadget: Get ScrolledWindow, some sizes and basic infos on sliders/adjustments - Linux
; Author:          Omi
; Date:            Jan. 01, 2016 ☑
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gtk_scrolled_window_get_vscrollbar(*scrolled_window.GtkScrolledWindow)
	gtk_scrolled_window_get_hscrollbar(*scrolled_window.GtkScrolledWindow)
	gtk_widget_get_visible(*widget.GtkWidget)
	gtk_widget_get_allocation(*widget.GtkWidget, *allocation.GtkAllocation);     gtk2 + gtk3
	gtk_container_get_border_width(*container.GtkContainer)
	gtk_text_view_get_border_window_size(*text_view.GtkTextView, type)
	gtk_adjustment_get_value.d(*adjustment.GtkAdjustment)
EndImport

; Object constants
#Win_Main  = 0

#Edt1     = 0
#Edt2     = 1
#Splitter = 2
#But1     = 3

Global.i gEvent, gQuit
Global.GtkTextView       *gTextView
Global.GtkScrolledWindow *gScrolledWindow
Global.GtkWidget         *gVScrollbar,  *gHScrollbar
Global.GtkAdjustment     *gVAdjustment, *gHAdjustment
Global.GtkAllocation     gAllocation
Global.s S1= "A little Text to demonstrate a multiple view of the same text being shown and editable in 2 (or more) PureBasic-EditorGadget. " + #LF$ + #LF$ + 
             "To make this possible it is necessary To use the same 'TextBuffer' for several EditorGadgets (TextViews)!" + #LF$ + #LF$ + 
             "Enter some new text here and change the Editor to type in your text ..." + #LF$ + #LF$ + #LF$ + #LF$ + 
             "Some lines to fill the place:" + #LF$ + 
             "Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. "+ #LF$ + 
             "At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. "+ #LF$ + 
             "Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. "+ #LF$ + 
             "At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet."



Procedure Widget_GetAllocatedWidth(*widget)
	gtk_widget_get_allocation(*widget, @gAllocation)
	ProcedureReturn gAllocation\width
	;only gtk3 ...
; 	ProcedureReturn gtk_widget_get_allocated_width(*widget)
EndProcedure

Procedure Widget_GetAllocatedHeight(*widget)
	gtk_widget_get_allocation(*widget, @gAllocation)
	ProcedureReturn gAllocation\height
	;only gtk3 ..
; 	ProcedureReturn gtk_widget_get_allocated_height(*widget)
EndProcedure

If OpenWindow(#Win_Main, 0, 0, 500, 235, "Editor - Sizes & more", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	ButtonGadget(#But1,   5,   5, 400, 26, "Show Editor sizes & some data ...")
	EditorGadget(#Edt1,   5,  40, 490, 190, #PB_Editor_WordWrap)
	AddGadgetItem(#Edt1, -1,  S1)
	
	*gTextView= GadgetID(#Edt1)
	
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
				
			Case #PB_Event_Gadget
				Select EventGadget()
					Case #But1
						*gScrolledWindow= gtk_widget_get_parent_(*gTextView);                           here's the ScrolledWindow from EditorGadget
						*gVScrollbar    = gtk_scrolled_window_get_vscrollbar(*gScrolledWindow);         here's the vertical Scrollbar from ScrolledWindow
						*gHScrollbar    = gtk_scrolled_window_get_hscrollbar(*gScrolledWindow);         here's the vertical Scrollbar
						*gVAdjustment   = gtk_scrolled_window_get_vadjustment_(*gScrolledWindow);       here's the vertical adjustment from ScrolledWindow
						*gHAdjustment   = gtk_scrolled_window_get_hadjustment_(*gScrolledWindow);       here's the horizontal adjustment
						
						Debug "V-Scrollbar visible, gtk3?         " + Str(gtk_widget_get_visible(*gVScrollbar))
						Debug "H-Scrollbar visible, gtk3?         " + Str(gtk_widget_get_visible(*gHScrollbar))
						Debug "Allocated V-Scrollbar-width        " + Widget_GetAllocatedWidth(*gVScrollbar)
						Debug "Allocated H-Scrollbar-height       " + Widget_GetAllocatedHeight(*gHScrollbar)
						Debug "PB-Editor-Width (w. scrolled Win.) " + Str(GadgetWidth(#Edt1, #PB_Gadget_ActualSize))
						Debug "PB-Editor-Height (w. scrolled Win.)" + Str(GadgetHeight(#Edt1, #PB_Gadget_ActualSize))
						Debug "Allocated Editor-width             " + Widget_GetAllocatedWidth(*gTextView)
						Debug "Allocated Editor-height            " + Widget_GetAllocatedHeight(*gTextView)
						Debug "V-Adjustment value                 " + StrD(gtk_adjustment_get_value(*gVAdjustment))
						Debug "H-Adjustment value                 " + StrD(gtk_adjustment_get_value(*gHAdjustment))
						Debug "ScrolledWindow border-width        " + gtk_container_get_border_width(*gScrolledWindow)
						Debug "Editor border-width                " + gtk_text_view_get_border_window_size(*gTextView, #GTK_TEXT_WINDOW_LEFT)
						Debug " ---"
				EndSelect
		EndSelect
		
	Until gQuit
EndIf
; IDE Options = PureBasic 5.42 LTS (Linux - x86)
; CursorPosition = 86
; FirstLine = 34
; Folding = -
; EnableUnicode
; EnableXP