﻿; Module/File:     Editor_ScrollLineUpDown.pb
; Function:        Scrolls on line up or down - Linux gtk2/gtk3
; Author:          Omi
; Date:            Apr. 01, 2015
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gtk_adjustment_get_page_size.d(*adjustment.GtkAdjustment)
	gtk_adjustment_get_upper.d(*adjustment.GtkAdjustment)
	gtk_adjustment_get_step_increment.d(*adjustment.GtkAdjustment)
	gtk_adjustment_set_value(*adjustment.GtkAdjustment, value.d)
	gtk_adjustment_get_value.d(*adjustment.GtkAdjustment)
EndImport

; Object constants
#MainWin= 0
#Edt1   = 0
#Bt1    = 1
#Bt2    = 2

#WinX= 300
#WinY= 200
#WinW= 300
#WinH= 200

Global.i gEvent, gQuit
Global *gAdjustment.GtkAdjustment
Global.d gEdtPageSize, gEdtUpper, gEdtStep, gEdtStepInc
Global.s EditString= "PureBasic... " + #LF$ + #LF$ + "ist eine 'Hochsprachen' Programmiersprache, die auf den bekannten 'BASIC'-Regeln basiert. " + 
             "Sie ist größtenteils kompatibel mit jedem anderen 'BASIC'-Compiler, egal ob für das Amiga- oder PC-Format. " + 
             "Das Erlernen von PureBasic ist sehr leicht! PureBasic ist für Anfänger genauso wie für Experten geschaffen worden. " + 
             "Die Übersetzungsgeschwindigkeit ist wirklich schnell. Diese Software wurde für das Windows- Operating-System entwickelt. " +
             "Wir haben eine Menge Anstrengungen in ihre Realisierung gesetzt, um eine schnelle, zuverlässige und systemfreundliche Sprache zu produzieren. " + #LF$ +
             "Die Syntax ist einfach, aber mit den fortgeschrittenen Funktionen von PureBasic wie z.B. Zeigern, Strukturen, Prozeduren und dynamisch verknüpften Listen sind die Möglichkeiten unbegrenzt. " + 
             "Für den erfahrenen Programmierer gibt es keine Probleme, Zugang zu irgendwelchen legalen OS-Strukturen oder API-Objekten zu bekommen." + #LF$ +
             "PureBasic ist eine portable Sprache, welche zur Zeit auf den AmigaOS, Linux, MacOS X und Windows Computersystemen arbeitet. " + 
             "Dies bedeutet, dass derselbe Programmcode für jedes System nativ kompiliert werden kann und trotzdem die volle Power des jeweiligen Systems ausnutzt. " + 
             "Es gibt keine Flaschenhälse wie einen virtuellen Prozessor oder einen Code-Übersetzer; der generierte Code produziert ein optimiertes Executable."


Procedure.d Min(A.d, B.d)
	Protected Ret.d= B
	If A < B: Ret= A: EndIf
	ProcedureReturn Ret
EndProcedure

Procedure.d Max(A.d, B.d)
	Protected Ret.d= B
	If A > B: Ret= A: EndIf
	ProcedureReturn Ret
EndProcedure

Procedure Editor_ScrollLineDown()
	gEdtPageSize= gtk_adjustment_get_page_size(*gAdjustment)
	gEdtStepInc = Int(gtk_adjustment_get_step_increment(*gAdjustment))
	gEdtUpper   = gtk_adjustment_get_upper(*gAdjustment)
	gEdtStep    = gtk_adjustment_get_value(*gAdjustment)
	If gEdtStep < (gEdtUpper-gEdtPageSize)
		gEdtStep= Min(gEdtStep + gEdtStepInc, gEdtUpper-gEdtPageSize)
		Debug gEdtStep
		gtk_adjustment_set_value(*gAdjustment, gEdtStep)
	Else
		RemoveWindowTimer(#MainWin, 0)
		Debug "down"
	EndIf
EndProcedure

Procedure Editor_ScrollLineUp()
	gEdtPageSize= gtk_adjustment_get_page_size(*gAdjustment)
	gEdtStepInc = Int(gtk_adjustment_get_step_increment(*gAdjustment))
	gEdtUpper   = gtk_adjustment_get_upper(*gAdjustment)
	gEdtStep    = gtk_adjustment_get_value(*gAdjustment)
	If gEdtStep > 0
		gEdtStep= Max(gEdtStep - gEdtStepInc, 0)
		Debug gEdtStep
		gtk_adjustment_set_value(*gAdjustment, gEdtStep)
	Else
		RemoveWindowTimer(#MainWin, 1)
		Debug "up"
	EndIf
EndProcedure

If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "EditorGadget - Scroll per line", #PB_Window_SystemMenu)
	ButtonGadget(#Bt1, 5, 5, 100, 25, "Fade to bottom");, #PB_Button_Toggle)
	ButtonGadget(#Bt2, 105, 5, 100, 25, "Fade to top");, #PB_Button_Toggle)
	EditorGadget(#Edt1, 5, 35, #WinW-10, #WinH-39, #PB_Editor_WordWrap)
	AddGadgetItem(#Edt1, -1, EditString)
	
	gtk_text_view_set_wrap_mode_(GadgetID(#Edt1), #GTK_WRAP_WORD)
	
	*gAdjustment= gtk_scrolled_window_get_vadjustment_(gtk_widget_get_parent_(GadgetID(#Edt1)))
	
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
				
			Case #PB_Event_Gadget
				Select EventGadget()
					Case #Bt1
						AddWindowTimer(#MainWin, 0, 50)
						RemoveWindowTimer(#MainWin, 1)
						
					Case #Bt2
						AddWindowTimer(#MainWin, 1, 50)
						RemoveWindowTimer(#MainWin, 0)
						
				EndSelect
			Case #PB_Event_Timer
				If EventTimer() = 0
					Editor_ScrollLineDown()
				ElseIf EventTimer() = 1
					Editor_ScrollLineUp()
				EndIf
		EndSelect
		
	Until gQuit
EndIf
; IDE Options = PureBasic 5.40 LTS Beta 9 (Linux - x86)
; CursorPosition = 97
; FirstLine = 80
; Folding = -
; EnableUnicode
; EnableXP