﻿; Module/File:     Editor_SysPopupReplacement.pb
; Function:        Replaces a rightclick-syspopup in TextView - Linux
; Author:          Omi
; Date:            Sep. 03, 2016 ☑
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

Enumeration #PB_Event_FirstCustomValue
	#Event_Rightclick
	#Event_Rightrelease
EndEnumeration

ImportC ""
	g_signal_connect(*instance, detailed_signal.p-ascii, *c_handler, *data, destroy= 0, flags= 0) As "g_signal_connect_data"
	g_signal_handler_find(*instance, mask, signal_id, detail, *closure, func, data_)
EndImport

; Object constants
#Win_Main= 0

#Bt1    = 0
#Edt1   = 1

If CreatePopupMenu(0);                           replacement popup for editor
  MenuItem(1, "Cut")
  MenuItem(2, "Copy")
  MenuItem(3, "Paste")
  MenuBar()
  OpenSubMenu("Options")
    MenuItem(4, "Window...")
    MenuItem(5, "Gadget...")
  CloseSubMenu()
  MenuBar()
  MenuItem( 6, "Quit")
EndIf

Global.i gEvent, gQuit
Global.s gS= "A RightClick in the Editor calls the System-Editor-Popup." + #LF$ + #LF$ +
            "Button ON :" + #LF$ + "  A replacement-popup is shown after releasing the right button" + #LF$ + 
            "Button OFF:" + #LF$ + "  The original popup is shown again."


ProcedureC Callback_TextviewRSclick(*widget.GtkWidget, *Event.GdkEventButton, user_data)
	If user_data = #Edt1
		If *Event\button = 3
			If *Event\type = #GDK_BUTTON_PRESS
				PostEvent(#Event_Rightclick, GetActiveWindow(), user_data)
				ProcedureReturn #True
			EndIf
		EndIf
	EndIf
EndProcedure

ProcedureC Callback_TextviewRSrelease(*widget.GtkWidget, *Event.GdkEventButton, user_data)
	If user_data = #Edt1
		If *Event\button = 3
			If *Event\type = #GDK_BUTTON_RELEASE
				PostEvent(#Event_Rightrelease, GetActiveWindow(), user_data)
				ProcedureReturn #True
			EndIf
		EndIf
	EndIf
EndProcedure

Procedure Editor_ConnectHandler(Gadget, *Callback)
	g_signal_connect(GadgetID(Gadget), "button-press-event", *Callback, Gadget, #Null, #Null)
	g_signal_connect(GadgetID(Gadget), "button-release-event", *Callback, Gadget, #Null, #Null)
EndProcedure

Procedure Editor_DisconnectHandler(Gadget, *Callback)
	Protected HandlerId
	Protected *text_view= GadgetID(Gadget)
	
	; find signalhandler for widget with callback ...
	HandlerId= g_signal_handler_find(*text_view, #G_SIGNAL_MATCH_FUNC, 0, 0, 0, *Callback, 0)
	If HandlerId
		g_signal_handler_disconnect_(*text_view, HandlerId);                             disconnect handler
	EndIf
EndProcedure

If OpenWindow(#Win_Main, 300, 200, 400, 200, "EditorGadget-Popup-Replacement", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	ButtonGadget(#Bt1,  5,  5, 390,  28, "Replaces the Rightclick-popup in Editor", #PB_Button_Toggle)
	EditorGadget(#Edt1, 5, 35, 390, 160)
	AddGadgetItem(#Edt1, -1, gS)
	gtk_text_view_set_wrap_mode_(GadgetID(#Edt1), #GTK_WRAP_WORD)
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
				
			Case #PB_Event_Gadget
				If GetGadgetState(#Bt1)
					Editor_ConnectHandler(#Edt1, @Callback_TextviewRSclick());    Kills editor-sys-popup on rightclick
					Editor_ConnectHandler(#Edt1, @Callback_TextviewRSrelease());    Kills editor-sys-popup on rightrelease
				Else
					Editor_DisconnectHandler(#Edt1, @Callback_TextviewRSclick()); reinstalls editor-sys-popup on rightclick
					Editor_DisconnectHandler(#Edt1, @Callback_TextviewRSrelease()); reinstalls editor-sys-popup on rightrelease
				EndIf
				
			Case #Event_Rightclick
				If EventGadget() = #Edt1
					Debug "Right singleclick in Editor " + Str(#Edt1) + " w. custom popup"
				EndIf
				
			Case #Event_Rightrelease
				If EventGadget() = #Edt1
					DisplayPopupMenu(0, WindowID(#Win_Main))
				EndIf
				
		EndSelect
		
	Until gQuit
EndIf
; IDE Options = PureBasic 5.42 LTS (Linux - x86)
; CursorPosition = 96
; FirstLine = 91
; Folding = -
; EnableUnicode
; EnableXP