﻿; Module/File:     Editor_TabWidth.pb
; Function:        EditorGadget: setzt Tab-Einzug für 1. Tab - Linux gtk2/gtk3
; Author:          Omi
; Date:            Aug 01, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	pango_tab_array_new_with_positions(size.i, positions_in_pixels.i, first_alignment.i, first_position.i)
	pango_tab_array_set_tab(*tab_array, tab_index.i, alignment.i, location.i)
	pango_tab_array_free(tab_array)
EndImport

#PangoUnit= 1024

; Object constants
#MainWin= 0
#Txt1   = 0
#Bt1    = 1
#Edt1   = 2

#WinX= 300
#WinY= 200
#WinW= 320
#WinH= 200

Global.i gEvent, gQuit
Global *pTabArray
Global.s S1= "Dies ist ein mehrzeiliger Text in dem das Ein- und Auschalten der Cursordarstellung innerhalb eines EditorGadgets per Toggle-" + 
             "Button gezeigt wird, da die Darstellung eines Cursors innerhalb eines'read-only'-Textes wenig Sinn macht!"
Global.s S2 = #TAB$ + "Hier wird ein Tabulatur zu Zeilenbeginn gesetzt der mit dem SpinGadget zeichenweise eingestellt werden kann!"
Global.s S3 = "3." + #TAB$ + "Zeile mit nachträglichem Tab."

#Font= 0
LoadFont(#Font, "courier 10 pitch", 10);                                       set monospace font

If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "EditorGadget-Space paragraph indentation", #PB_Window_SystemMenu)
	TextGadget(#Txt1, 5, 7, 110, 20, "Tab-width (chars): ", #PB_Text_Right)
	SpinGadget(#Bt1, 120, 1, 60, 25, 0, 8, #PB_Spin_Numeric)
	SetGadgetState(#Bt1, 2)
	EditorGadget(#Edt1, 5, 30, #WinW-10, #WinH-34)
	SetGadgetFont(#Edt1, FontID(#Font))
	AddGadgetItem(#Edt1, -1, S1)
	AddGadgetItem(#Edt1, -1, S2)
	AddGadgetItem(#Edt1, -1, S3)
	
	SetActiveGadget(#Edt1)
	gtk_text_view_set_wrap_mode_(GadgetID(#Edt1), #GTK_WRAP_WORD);                 wortweiser Zeilenumbruch
	gtk_text_view_set_pixels_below_lines_(GadgetID(#Edt1), 5);                     5 Pixel unter Absatz
	
	*pTabArray= pango_tab_array_new_with_positions(1, #False, 0, #PangoUnit * 2 * 8);  Voreinstellung in PangoUnits, 2 fixe Zeichen (ohne Zeichenbreiteerkennung)
	;*pTabArray= pango_tab_array_new_with_positions(1, #True, 0, 16);               in Pixels
	gtk_text_view_set_tabs_(GadgetID(#Edt1), *pTabArray)
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
				
			Case #PB_Event_Gadget
				If EventGadget() = #Bt1
					pango_tab_array_set_tab(*pTabArray, 0, 0, GetGadgetState(#Bt1) * 8 * #PangoUnit + 1);         Change 1. tab-width (index= 0), only in PangoUnits ('0'= standard 8 chars, that's why +1)
					gtk_text_view_set_tabs_(GadgetID(#Edt1), *pTabArray);                                Set & Redraw
				EndIf
		EndSelect
		
	Until gQuit
EndIf

pango_tab_array_free(*pTabArray);      free array
; IDE Options = PureBasic 5.40 LTS Beta 9 (Linux - x86)
; CursorPosition = 49
; FirstLine = 30
; EnableUnicode
; EnableXP
; CurrentDirectory = /home/charly-xubuntu/Programming/PureBasic/purebasic/