﻿; Module/File:     Gadget_AddInfoBar_.pb
; Function:        Add 'infobar'-widget - Linux
; Author:          Omi
; Date:            Nov. 22, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	g_signal_connect(*instance, detailed_signal.p-ascii, *c_handler, *data, destroy= 0, flags= 0) As "g_signal_connect_data"
	gtk_info_bar_new()
	gtk_info_bar_new_with_buttons(first_button_text.p-utf8, ret, null= 0)
	gtk_info_bar_add_button(*info_bar.GtkWidget, button_text.p-utf8, ret)
	gtk_info_bar_set_message_type(*info_bar.GtkWidget, message_type)
	gtk_info_bar_get_content_area(*info_bar.GtkWidget)
	gtk_label_new(label.p-utf8)
EndImport

; Object constants
#MainWin= 0

#WinX   = 300
#WinY   = 200
#WinW   = 500
#WinH   = 240

#GTK_MESSAGE_OTHER= 4

Global.i gEvent, gQuit

ProcedureC Callback_InfoBarResponse(*widget.GtkWidget, user_data)
	Debug "widget:  " + Str(*widget)
	Debug "clicked: " + Str(user_data)
EndProcedure

Procedure.i InfoBarGadget(Gadget, x, y, w, h)
	Protected.i Container= ContainerGadget(Gadget, x, y, w, 220, #PB_Container_Flat)
	Protected *bar.GtkWidget
	If Gadget <> #PB_Any : Container= Gadget : EndIf
	Protected *vbox= gtk_vbox_new_(#False, 0)
	gtk_container_add_(GadgetID(Container), *vbox)
	
	*bar= gtk_info_bar_new()
	gtk_box_pack_start_(*vbox, *bar, #False, #False, 0)
	gtk_info_bar_set_message_type(*bar, #GTK_MESSAGE_INFO)
	Protected *label.GtkWidget= gtk_label_new("This is an info bar with message type #GTK_MESSAGE_INFO")
	gtk_box_pack_start_(gtk_info_bar_get_content_area(*bar), *label, #False, #False, 0)
	
	*bar= gtk_info_bar_new()
	gtk_box_pack_start_(*vbox, *bar, #False, #False, 0)
	gtk_info_bar_set_message_type(*bar, #GTK_MESSAGE_WARNING)
	*label.GtkWidget= gtk_label_new("This is an info bar with message type #GTK_MESSAGE_WARNING")
	gtk_box_pack_start_(gtk_info_bar_get_content_area(*bar), *label, #False, #False, 0)
	
	*bar= gtk_info_bar_new_with_buttons("gtk-cancel", 0)
	gtk_info_bar_add_button(*bar, "gtk-ok", 1)
	g_signal_connect (*bar, "response", @Callback_InfoBarResponse(), *bar)
	gtk_box_pack_start_(*vbox, *bar, #False, #False, 0)
	gtk_info_bar_set_message_type(*bar, #GTK_MESSAGE_QUESTION)
	*label.GtkWidget= gtk_label_new("This is an info bar with message type #GTK_MESSAGE_QUESTION")
	gtk_box_pack_start_(gtk_info_bar_get_content_area(*bar), *label, #False, #False, 0)
	
	*bar= gtk_info_bar_new()
	gtk_box_pack_start_(*vbox, *bar, #False, #False, 0)
	gtk_info_bar_set_message_type(*bar, #GTK_MESSAGE_ERROR)
	*label.GtkWidget= gtk_label_new("This is an info bar with message type #GTK_MESSAGE_ERROR")
	gtk_box_pack_start_(gtk_info_bar_get_content_area(*bar), *label, #False, #False, 0)
	
	*bar= gtk_info_bar_new()
	gtk_box_pack_start_(*vbox, *bar, #False, #False, 0)
	gtk_info_bar_set_message_type(*bar, #GTK_MESSAGE_OTHER)
	*label.GtkWidget= gtk_label_new("This is an info bar with message type #GTK_MESSAGE_OTHER")
	gtk_box_pack_start_(gtk_info_bar_get_content_area(*bar), *label, #False, #False, 0)
	
	gtk_widget_show_all_(GadgetID(Container))
	CloseGadgetList()
	ProcedureReturn *bar
EndProcedure

If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "Add InfoBar", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	InfoBarGadget(#PB_Any, 5, 5, 490, 36)
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True

		EndSelect
		
	Until gQuit
EndIf
; IDE Options = PureBasic 5.40 LTS Beta 9 (Linux - x86)
; CursorPosition = 5
; Folding = -
; EnableUnicode
; EnableXP