﻿; Module/File:     Gadget_EmbeddedAnimationWoDecoder.pb
; Function:        Add gif animation to pb-ImageGadget, w/o Decoder, uses pixbuf-loader - Linux (gtk2/gtk3)
; Author:          Omi/Keya
; Date:            Sep. 20, 2015
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------
;see Version w/o pixbuf-loader 'ImageGadget_AnimationFromFile.pb'

EnableExplicit

ImportC ""
	gdk_pixbuf_loader_write(*loader, *buf, count, *error)
	gdk_pixbuf_loader_get_animation(*loader)
	gdk_pixbuf_loader_new()
	gdk_pixbuf_loader_close(*loader, *error)
	gdk_pixbuf_animation_get_width(pixbuf)
	gdk_pixbuf_animation_get_height(pixbuf)
EndImport

#Win_Main= 0

Enumeration
	#Txt1
	#ImG1
EndEnumeration

Global.i gEvent, gQuit

Procedure ImageAnimationGetFromMem(mem, size)
	Protected loader = gdk_pixbuf_loader_new()
	Protected *err.GError
	
	*err= 0 : gdk_pixbuf_loader_write(loader, mem, size, @*err)
	If *err : Debug "Error: " + PeekS(*err\message, -1, #PB_UTF8) : EndIf
	
	*err= 0 : gdk_pixbuf_loader_close(loader, @*err);  Important to get the things going, else: Do you know 'Sankt Nimmerleinstag'?!
	If *err : Debug "Error: " + PeekS(*err\message, -1, #PB_UTF8) : EndIf
	
	ProcedureReturn gdk_pixbuf_loader_get_animation(loader)
EndProcedure

Procedure ImageAnimationSet(Gadget, Animation)
	gtk_image_set_from_animation_(GadgetID(Gadget), Animation)
	ResizeGadget(Gadget, #PB_Ignore, #PB_Ignore, gdk_pixbuf_animation_get_width(Animation), gdk_pixbuf_animation_get_height(Animation))
EndProcedure

If OpenWindow(#Win_Main, #PB_Ignore, #PB_Ignore, 500, 300, "Use exe embedded animation w/o ImageDecoder", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	TextGadget(#Txt1, 5, 5, 490, 45, "A PB ImageGadget with a embedded decoderless gif animation ...")
	ImageGadget(#ImG1, 200, 110, 60, 60, #Null)
	ImageAnimationSet(#ImG1, ImageAnimationGetFromMem(?Img1, ?Img2-?Img1))
	
	Repeat
		gEvent= WaitWindowEvent()
		
		If EventWindow() = #Win_Main
			
			Select gEvent
					
				Case #PB_Event_CloseWindow
					gQuit= #True
					
			EndSelect
			
		EndIf
	Until gQuit
EndIf

DataSection
	;Choose your pathes and gif animation here ...
	;http://www.picgifs.com/graphics/a/3d-smileys/graphics-3d-smileys-302517.gif
	Img1:  : IncludeBinary "/home/charly-xubuntu/Downloads/Bilder/graphics-3d-smileys-302517.gif";"/usr/share/gtk-2.0/demo/floppybuddy.gif"
	Img2:  : ; MUST! End of Img5-Mem:
EndDataSection
; IDE Options = PureBasic 5.51 Beta 1 (Linux - x86)
; CursorPosition = 8
; Folding = -
; EnableXP
; EnableUnicode