﻿; Module/File:     Gadget_ImageFromThemeWoDecoder.pb
; Function:        Add any system-default-icon-theme icon as image to pb-Button, -images or -window without ImageDecoder - Linux (gtk2/gtk3)
; Author:          Omi
; Date:            Oct. 07, 2015
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

; UsePNGImageDecoder()
; additional use of all system supported image types as svg, gif, ...

ImportC ""
	gtk_icon_theme_load_icon(*icon_theme.GtkIconTheme, icon_name.p-utf8, size, flags, *error.GError)
	gtk_button_set_image(*button.GtkButton, *image.GtkWidget)
	gtk_button_set_image_position(*button.GtkButton, position)
	gtk_button_set_label(*button.GtkButton, label.p-utf8)
	gtk_image_clear(*image.GtkWidget)
	g_object_set(*object.GObject, property_name.p-utf8, *data, v= 0)
EndImport

Enumeration GtkIconLookupFlags
; 	0
; 	#GTK_ICON_LOOKUP_NO_SVG           = 1
; 	#GTK_ICON_LOOKUP_FORCE_SVG        = 2
; 	#GTK_ICON_LOOKUP_USE_BUILTIN      = 4
; 	#GTK_ICON_LOOKUP_GENERIC_FALLBACK = 8
; 	#GTK_ICON_LOOKUP_FORCE_SIZE       = 16
EndEnumeration

#Win_Main= 0
#But1    = 0
#ImG1    = 1
#BIG1    = 2
#LIG     = 3

Global.i gEvent, gQuit
Global   *gImage1

Procedure ButtonGadget_AddImage(Gadget, *Pic, Label.s, Alignment)
	gtk_button_set_image(GadgetID(Gadget), *Pic)
	gtk_button_set_label(GadgetID(Gadget), Label)
	gtk_button_set_image_position(GadgetID(Gadget), Alignment)
EndProcedure

; search file from name in default icon theme and return pixbuf or Null ...
Procedure IconDefaultTheme_LoadIconFromName(icon_name.s, icon_size, flags)
	Protected *pixbuf
	Protected *error.GError
	
	*pixbuf= gtk_icon_theme_load_icon(gtk_icon_theme_get_default_(), icon_name, icon_size, flags, @*error)
	If *error : Debug PeekS(*error\message, -1, #PB_UTF8) : EndIf
	ProcedureReturn *pixbuf
EndProcedure


If OpenWindow(#Win_Main, #PB_Ignore, #PB_Ignore, 500, 300, "Def. theme icon as PB-Image w/o ImageDecoder", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	
	;if icons are not shown, uncomment the following line ...
	g_object_set(gtk_settings_get_default_(), "gtk-button-images", #True, #Null)
	
	TextGadget  (#PB_Any, 5, 45, 190,  22, "A PB ImageGadget()")
	TextGadget  (#PB_Any, 5, 85, 190,  22, "A PB ButtonImageGadget()")
	TextGadget  (#PB_Any, 5, 125, 240,  30, "Look at window-icon")
	
	;list available icons names with API-library-function: '/Misc/System_DefIconThemeIconList.pb' ...
	;use this icon names here (this are no 'stock' names) ...
	ButtonGadget(#But1,   5,  5, 290,  30, " ")
	*gImage1= gtk_image_new_from_pixbuf_(IconDefaultTheme_LoadIconFromName("go-left", 16, 0));        Needs Ptr to free it
	ButtonGadget_AddImage(#But1, *gImage1, "1. ButtonGadget with left image", #GTK_POS_LEFT);         add image to #But1
	
	ImageGadget(#ImG1,       200, 40, 32, 32, IconDefaultTheme_LoadIconFromName("accessories-text-editor", 32, 0))
	ButtonImageGadget(#BIG1, 200, 80, 28, 28, IconDefaultTheme_LoadIconFromName("go-down", 16, 0))
	
	ListIconGadget(#LIG,  5, 175, 490, 120, "Col1 with embedded pixbufs w/o ImageDecoder", 350, #PB_ListIcon_GridLines)
	AddGadgetColumn(#LIG, 1, "Col 2", 90)
	AddGadgetItem(#LIG,  -1, "1-1" + #LF$ + "1-2", IconDefaultTheme_LoadIconFromName("node-add", 16, 0))
	AddGadgetItem(#LIG,  -1, "2-1" + #LF$ + "2-2", IconDefaultTheme_LoadIconFromName("zoom-out", 16, 0))
	
	gtk_window_set_icon_(WindowID(#Win_Main), IconDefaultTheme_LoadIconFromName("gtk-apply", 16, 0)); set window icon from theme
	
	Repeat
		gEvent= WaitWindowEvent()
			
			Select gEvent
					
				Case #PB_Event_CloseWindow
					gQuit= #True
					
			EndSelect
			
	Until gQuit
EndIf

;free global image-memory...
gtk_image_clear(*gImage1)
; IDE Options = PureBasic 5.40 LTS Beta 9 (Linux - x86)
; CursorPosition = 56
; Folding = -
; EnableUnicode
; EnableXP