﻿; Module/File:     Gadget_IsVisible.pb
; Function:        Gadget-Sichtbarkeit abfragen - Linux gtk3(gtk2)
; Author:          Omi
; Date:            Juli 15, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gtk_widget_get_visible(*widget.GtkWidget)
	gtk_widget_is_visible(*widget.GtkWidget); gtk3, with gtk2 deactivate this line and range beyond
EndImport

; Object constants
#MainWin= 0
#But1   = 0
#Cont1  = 1
#But2   = 2
#Cont2  = 3

#WinX  = 300
#WinY  = 200
#WinW  = 200
#WinH  = 120

Global.i gEvent, gQuit, gCounter

Procedure RunIt()
	Select gCounter
		Case 0
			HideGadget(#But1, #True)
			HideGadget(#Cont1, #True)
			HideGadget(#Cont2, #True)
			Debug "Hide free Button 1, Container 1 & Container 2 with child-Button ..."
		Case 1
			Debug "Button1 (free) visible (get)?: " + Str(gtk_widget_get_visible(GadgetID(#But1)))
			If GadgetType(#Cont1) = #PB_GadgetType_Container
				Debug "Container1 (free) visible (get)?: " + Str(gtk_widget_get_visible(gtk_widget_get_parent_(GadgetID(#Cont1))))
			Else
				Debug "Container1 (free) visible (get)?: " + Str(gtk_widget_get_visible(GadgetID(#Cont1)))
			EndIf
			Debug "Button2 (boxed) visible (get)?: " + Str(gtk_widget_get_visible(GadgetID(#But2)))
			If GadgetType(#Cont2) = #PB_GadgetType_Container
				Debug "Container1 visible (get, special query)?: " + Str(gtk_widget_get_visible(gtk_widget_get_parent_(GadgetID(#Cont2))))
			Else
				Debug "Container1 visible (get)?: " + Str(gtk_widget_get_visible(GadgetID(#Cont2)))
			EndIf
			
			;	*** and gtk3, deactivate the following 2 lines with gtk2 ***
			Debug "Button2 (boxed) visible (is)?: " + Str(gtk_widget_is_visible(GadgetID(#But2)))
			Debug "Container2 visible (is)?: " + Str(gtk_widget_is_visible(GadgetID(#Cont2)))
			
			Debug " ---"
		Case 2
			HideGadget(#But1, #False)
			HideGadget(#Cont1, #False)
			HideGadget(#Cont2, #False)
			Debug "Show free Button 1, Container 1 & Container 2 with child-Button ..."
		Case 3
			Debug "Button1 visible?: " + Str(gtk_widget_get_visible(GadgetID(#But1)))
			Debug "Container1 visible?: " + Str(gtk_widget_get_visible(GadgetID(#Cont1)))
			Debug "Button2 visible?: " + Str(gtk_widget_get_visible(GadgetID(#But2)))
			Debug "Container2 visible?: " + Str(gtk_widget_get_visible(GadgetID(#Cont2)))
	EndSelect
	gCounter+ 1
EndProcedure


If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "Gadget-Visibility", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	TextGadget(#PB_Any, 5, 5, 150, 20, "Do nothing, watch ...")
	ButtonGadget(#But1, 5, 25, 150, 25, "hide me")
	ContainerGadget(#Cont1, 5, 55, 150, 25, #PB_Container_Double)
	CloseGadgetList()
	ContainerGadget(#Cont2, 5, 85, 154, 29, #PB_Container_Double)
	ButtonGadget(#But2, 1, 1, 150, 25, "hide me")
	CloseGadgetList()
	
	AddWindowTimer(0, 0, 1000)
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
			Case #PB_Event_Timer
				RunIt()
		EndSelect
		
	Until gQuit
EndIf

RemoveWindowTimer(0, 0)
; IDE Options = PureBasic 5.40 LTS Beta 9 (Linux - x86)
; CursorPosition = 50
; FirstLine = 5
; Folding = -
; EnableUnicode
; EnableXP
; CurrentDirectory = /home/charly-xubuntu/Programming/PureBasic/purebasic/