﻿; Module/File:     Widget_SetVisible.pb
; Function:        Set a (PB-unknown) widget (in-)visible - Linux
; Author:          Omi
; Date:            Oct. 12, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gtk_button_set_image(*button.GtkWidget, *image.GtkWidget)
	gtk_widget_set_visible(*widget.GtkWidget, visible)
	gtk_widget_get_visible(*widget.GtkWidget)
	gtk_image_clear(*image.GtkWidget)
	gtk_image_new_from_stock(stock_id.p-utf8, size)
EndImport

; Object constants
#MainWin  = 0
#StatusBar= 0

Global.i gEvent, gQuit
Global *StatusBar
Global *SB_Image1

If OpenWindow(#MainWin, 300, 200, 300, 200, "set/get widget visibility", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	
	If CreateStatusBar(#StatusBar, WindowID(#MainWin))
		AddStatusBarField(150)
		StatusBarText(#StatusBar, 0, "StatusBar-Text")
		*StatusBar= StatusBarID(#StatusBar)
		;*** add a gtk-widget for the example ...
		*SB_Image1 = gtk_image_new_from_stock("gtk-caps-lock-warning", #GTK_ICON_SIZE_MENU);               get stockicon - without function                                                                            free UTF-8 mem
		gtk_box_pack_start_(*StatusBar, *SB_Image1, #False, #False, 0);                                    pack in statusbar
		gtk_widget_show_(*SB_Image1)
		;***
	EndIf
	
	AddWindowTimer(#MainWin, 0, 1000)
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
				
			Case #PB_Event_Timer
				;*** the function ***
				gtk_widget_set_visible(*SB_Image1, gtk_widget_get_visible(*SB_Image1) !1);                   convert widget-visibility
				;***              ***
		EndSelect
		
	Until gQuit
EndIf

;free image-memory...
gtk_image_clear(*SB_Image1)

RemoveWindowTimer(#MainWin, 0)
; IDE Options = PureBasic 5.40 LTS Beta 9 (Linux - x86)
; CursorPosition = 7
; EnableUnicode
; EnableXP