﻿; Module/File:     SystemIcon_Load.pb
; Function:        Autosearch, load and use registered system icon w. PB, w/o use of decoder - Linux
; Author:          Omi
; Date:            Jun. 18, 2016
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.4
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

;System icon are loaded by name as pixbufs (same as ImageID(#Image) and can be used everywhere, ImageID(#Image) is used.
;If Icon doesn't exist, '0' is returned and no Image is used -> NO CRASH !!! :-)

EnableExplicit

;UsePNGImageDecoder();   :-)

ImportC ""
	gtk_icon_theme_load_icon(*icon_theme.GtkIconTheme, icon_name.p-utf8, size, flags, *error.GError); gtk2.4
EndImport

Enumeration GtkIconLookupFlags
	#GTK_ICON_LOOKUP_ALL              = 0; Not gtk-defined, own constant to clearify
	#GTK_ICON_LOOKUP_NO_SVG           = 1
	#GTK_ICON_LOOKUP_FORCE_SVG        = 2
	#GTK_ICON_LOOKUP_USE_BUILTIN      = 4
	#GTK_ICON_LOOKUP_GENERIC_FALLBACK = 8
	#GTK_ICON_LOOKUP_FORCE_SIZE       = 16
EndEnumeration

; Object constants
#Win_Main  = 0


Global.i gEvent, gEventWin, gQuit

Procedure IconTheme_LoadIconFromName(icon_name.s, icon_size, flags)
	Protected *pixbuf
	Protected *error.GError
	
	*pixbuf= gtk_icon_theme_load_icon(gtk_icon_theme_get_default_(), icon_name, icon_size, flags, @*error)
	
	If *error : Debug icon_name + ": " + PeekS(*error\message, -1, #PB_UTF8) : EndIf
	ProcedureReturn *pixbuf
EndProcedure

Procedure Create_WinMain()
	If OpenWindow(#Win_Main, 300, 200, 500, 200, "Use registered system icons", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
		TextGadget       (#PB_Any,   5, 15, 90, 22, "edit-clear")
		ImageGadget      (0,       100,  5, 32, 32, IconTheme_LoadIconFromName("edit-clear", 32, #GTK_ICON_LOOKUP_ALL))
		TextGadget       (#PB_Any,   5, 55, 90, 22, "find")
		ButtonImageGadget(1,        90, 45, 32, 32, IconTheme_LoadIconFromName("find", 32, #GTK_ICON_LOOKUP_ALL))
	EndIf
EndProcedure

Create_WinMain()

Repeat
	gEvent= WaitWindowEvent()
	
	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
			
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.42 LTS (Linux - x86)
; CursorPosition = 31
; FirstLine = 15
; Folding = -
; EnableUnicode
; EnableXP