﻿; Module/File:     System_DefIconThemeGetFileFromName.pb
; Function:        Get path&file from icon name + size of default icon theme - Linux
; Author:          Omi
; Date:            Oct. 02, 2015
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------
;Code for icons from Default icon theme

EnableExplicit

Enumeration GtkIconLookupFlags
	#GTK_ICON_LOOKUP_NO_SVG           = 1
	#GTK_ICON_LOOKUP_FORCE_SVG        = 2
	#GTK_ICON_LOOKUP_USE_BUILTIN      = 4
	#GTK_ICON_LOOKUP_GENERIC_FALLBACK = 8
	#GTK_ICON_LOOKUP_FORCE_SIZE       = 16
EndEnumeration

ImportC ""
	gtk_icon_theme_lookup_icon(*icon_theme.GtkIconTheme, icon_name.p-utf8, size, flags)
EndImport


Global.i gEvent, gQuit
Global.i gIconSize= 16, gIconFlags= 0
Global.s gIconName= "edit-undo-symbolic"

Procedure.s IconDefaultTheme_FilenameFromNameSize(icon_name.s, icon_size, flags)
	Protected *icon_info
	Protected.s S

	*icon_info= gtk_icon_theme_lookup_icon(gtk_icon_theme_get_default_(), icon_name, icon_size, flags)
	If *icon_info
		S= PeekS(gtk_icon_info_get_filename_(*icon_info), -1, #PB_UTF8)
		Debug "Base size: " + Str(gtk_icon_info_get_base_size_(*icon_info))
	EndIf
	
	ProcedureReturn S
EndProcedure


Procedure Create_WinMain()
	If OpenWindow(0, 300, 200, 500, 200, "IconTheme path from name", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)

	EndIf
EndProcedure

Create_WinMain()

Debug "File for icon '" + gIconName + "' with size " + Str(gIconSize) + " and flags-sum " + Str(gIconFlags) + ":"
Debug IconDefaultTheme_FilenameFromNameSize(gIconName, gIconSize, gIconFlags)

Repeat
	gEvent= WaitWindowEvent()
	
	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
			
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.31 (Linux - x86)
; CursorPosition = 32
; FirstLine = 18
; Folding = -
; EnableUnicode
; EnableXP