﻿; Module/File:     System_DefIconThemeIconList.pb
; Function:        List icon names of default icon theme and context - Linux
; Author:          Omi
; Date:            Oct. 02, 2015
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------
;Code for icons from Default icon theme

EnableExplicit

ImportC ""
	gtk_icon_theme_list_icons(*icon_theme.GtkIconTheme, context.p-utf8)
	gtk_icon_theme_list_icons_p(*icon_theme.GtkIconTheme, *context) As "gtk_icon_theme_list_icons"
	gtk_icon_theme_get_icon_sizes(*icon_theme.GtkIconTheme, icon_name.p-utf8)
EndImport


Global.i gEvent, gQuit
Global.s gS= "Actions"; choose context or ""

Procedure IconDefaultTheme_ListIconNames(context.s)
	Protected *gList.GList
	Protected *IconName
	Protected n
	
	If context <> ""
		*gList= gtk_icon_theme_list_icons(gtk_icon_theme_get_default_(), context)
	Else
		*gList= gtk_icon_theme_list_icons_p(gtk_icon_theme_get_default_(), #Null)
	EndIf
	Protected *gList0.GSList = *gList
	
	If *gList
		Repeat
			*IconName= *gList\data
			Debug PeekS(*IconName, -1, #PB_UTF8)
			*gList= *gList\next
			n+ 1
		Until *gList = 0
	EndIf
	Debug " ---"
	
	If *gList0
		*gList= *gList0
		Repeat
			g_free_(*gList\data);     free entries
			*gList= *gList\next
		Until *gList = 0
		g_list_free_(*gList0);      free list
	EndIf
	
	ProcedureReturn n
EndProcedure


Procedure Create_WinMain()
	If OpenWindow(0, 300, 200, 500, 200, "Window", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)

	EndIf
EndProcedure

Create_WinMain()

;frequent contextes ...
;use API-Lib-function: '/Misc/System_DefIconThemeContextList.pb'
;"", "International","Places","Emotes","FileSystems","Applications","Devices","Actions","Categories","Animations","MimeTypes","Stock","Status","Emblems"

Debug "Available icon names for default-icon-theme context: " + gS
Debug " ---"
Debug Str(IconDefaultTheme_ListIconNames(gS)) + " icons found"

Repeat
	gEvent= WaitWindowEvent()
	
	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
			
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.40 LTS (Linux - x86)
; CursorPosition = 21
; Folding = -
; EnableUnicode
; EnableXP