﻿; Module/File:     System_DefIconThemePathes.pb
; Function:        List of pathes with default icon themes - Linux
; Author:          Omi
; Date:            Oct. 02, 2015
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------
;Code for icons from Default icon theme

EnableExplicit

ImportC ""
	gtk_icon_theme_get_search_path(*icon_theme.GtkIconTheme, *path, n_elements)
EndImport

; Object constants
#Win_Main  = 0

Global.i gEvent, gQuit

Procedure.s IconDefaultTheme_GetPathes()
	Protected   *iPath, iNelements
	Protected.i I
	Protected.s S
	
	gtk_icon_theme_get_search_path(gtk_icon_theme_get_default_(), @*iPath, @iNelements)
	For I= 0 To iNelements- 1
		S+ PeekS(PeekI(*iPath + I*SizeOf(I)), -1, #PB_UTF8) + #LF$
	Next I
	g_strfreev_(*iPath)
	
	Debug iNelements
	ProcedureReturn RTrim(S, #LF$)
EndProcedure

Procedure Create_WinMain()
	If OpenWindow(#Win_Main, 300, 200, 500, 200, "List IconTheme paths", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	EndIf
EndProcedure

Create_WinMain()

Debug "List of paths for system default icons:"
Debug IconDefaultTheme_GetPathes()


Repeat
	gEvent= WaitWindowEvent()
	
	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
			
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.40 LTS (Linux - x86)
; CursorPosition = 15
; Folding = -
; EnableUnicode
; EnableXP