﻿; Module/File:     System_SupportedImageFormatsList.pb
; Function:        List of system supported image formats (for decoderless use) - Linux
; Author:          Keya, Omi
; Date:            Sep. 26, 2015
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------
;works for PB-Decoderless API's: Default-Icon-Theme- & PixbufLoader-Commands

EnableExplicit

ImportC ""
	gdk_pixbuf_get_formats()
	gdk_pixbuf_format_get_name(*format)
	gdk_pixbuf_format_is_writable(*format)
	gdk_pixbuf_format_is_scalable(*format)
	gdk_pixbuf_format_get_description(*format)
	gdk_pixbuf_format_get_extensions(*format)
	gdk_pixbuf_format_get_mime_types(*format)
	gdk_pixbuf_format_is_disabled(*format)
EndImport

Global.i gEvent, gQuit
Global   *gGSlist.GSList

Procedure GdkEnumPixbufFormats()
	Protected   *gSList.GSList = gdk_pixbuf_get_formats()
	Protected   *gSList0.GSList= *gSList
	Protected   *GdkPixbufFmt, *ptr
	Protected.s S
	Protected.i n, I
	
	If *gSList
		Repeat
			*GdkPixbufFmt= *gSList\data
			AddGadgetItem(0, -1, PeekS(gdk_pixbuf_format_get_name(*GdkPixbufFmt), -1, #PB_UTF8))
			SetGadgetItemText(0, n, PeekS(gdk_pixbuf_format_get_description(*GdkPixbufFmt), -1, #PB_UTF8), 1)
			SetGadgetItemText(0, n, Str(gdk_pixbuf_format_is_writable(*GdkPixbufFmt)), 2)
			SetGadgetItemText(0, n, Str(gdk_pixbuf_format_is_scalable(*GdkPixbufFmt)), 3);     svg?
			SetGadgetItemText(0, n, Str(gdk_pixbuf_format_is_disabled(*GdkPixbufFmt)), 4)
			
			I= 0 : S= ""
			*ptr= gdk_pixbuf_format_get_extensions(*GdkPixbufFmt);         read all extensions
			While PeekI(*ptr+ I*SizeOf(I))
				S+ PeekS(PeekI(*ptr+ I*SizeOf(I)), -1, #PB_UTF8)+ #LF$
				I+ 1
			Wend
			SetGadgetItemText(0, n, RTrim(S, #LF$), 5)
			
			I= 0 : S= ""
			*ptr= gdk_pixbuf_format_get_mime_types(*GdkPixbufFmt);         read all mime types
			While PeekI(*ptr+ I*SizeOf(I))
				S+ PeekS(PeekI(*ptr+ I*SizeOf(I)), -1, #PB_UTF8)+ #LF$
				I+ 1
			Wend
			SetGadgetItemText(0, n, RTrim(S, #LF$), 6)
			
			*gSList= *gSList\next
			n+ 1
		Until *gSList = 0
	EndIf
	
	ProcedureReturn *gSList0
EndProcedure


If OpenWindow(0, 300, 200, 880, 300, "Demo: System supported image formats", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	ListIconGadget(0, 5, 5, 870, 290, "Type", 80, #PB_ListIcon_GridLines)
	AddGadgetColumn(0, 1, "description", 240)
	AddGadgetColumn(0, 2, "write access", 100)
	AddGadgetColumn(0, 3, "scalable", 70)
	AddGadgetColumn(0, 4, "disabled", 70)
	AddGadgetColumn(0, 5, "Extensions", 100)
	AddGadgetColumn(0, 6, "MIME-Types", 100)
	
	*gGSlist= GdkEnumPixbufFormats()
	
	Repeat
		gEvent= WaitWindowEvent()
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
				
		EndSelect
	Until gQuit
EndIf

g_slist_free_(*gGSlist)
; IDE Options = PureBasic 5.40 LTS Beta 9 (Linux - x86)
; CursorPosition = 61
; Folding = -
; EnableUnicode
; EnableXP