﻿; Module/File:     LIG_AddScrollEvent.pb
; Function:        Adds Event on LIG-scrolling - Linux
; Author:          Omi
; Date:            Oct. 04, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gtk_adjustment_get_value.d(*adjustment.GtkAdjustment)
	g_signal_connect(*instance, detailed_signal.p-ascii, *c_handler, *data, destroy= 0, flags= 0) As "g_signal_connect_data"
EndImport

;Object constants
#MainWin= 0
#LIG= 2

#WinX= 200
#WinY= 200
#WinW= 420
#WinH= 400

Global.i gEvent, gQuit
Global *gAdjustment.GtkAdjustment

ProcedureC TV_HScrollEvent(*adjustment.GtkAdjustment, user_data);     callback for hor. scrolling
	If user_data= #LIG
		Debug "Hor. scroll event ..."
		Debug " value : " + StrD(gtk_adjustment_get_value(*adjustment))
		Debug " ---"
	EndIf
EndProcedure

ProcedureC TV_VScrollEvent(*adjustment.GtkAdjustment, user_data);     callback for vert. scrolling
	If user_data= #LIG
		Debug "Vert. scroll event ..."
		Debug " value : " + StrD(gtk_adjustment_get_value(*adjustment))
		Debug " ---"
	EndIf
EndProcedure

Procedure CreateWindow_Main()
	Protected.l I, J
	Protected.s pText
	If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "Event on scroll action", #PB_Window_SystemMenu)
		ListIconGadget(#LIG, 5, 5, 400, 380, "Col 0", 70, #PB_ListIcon_AlwaysShowSelection | #PB_ListIcon_GridLines | #PB_ListIcon_CheckBoxes)
		
		For I = 1 To 6
			AddGadgetColumn(#LIG, I, "Col " + Str(I), 60)
		Next I
		For I = 0 To 25
			pText = ""
			For J = 0 To 6
				pText + Str(I) + "x" + Str(J) + Chr(10)
			Next J
			AddGadgetItem(#LIG, -1, pText)
		Next I
		
		; / events on hor. scroll arrows, slider or mousewheel ... /
		*gAdjustment= gtk_tree_view_get_hadjustment_(GadgetID(#LIG))
		g_signal_connect(*gAdjustment, "value-changed", @TV_HScrollEvent(), #LIG)
		; / events on vert. scroll arrows, slider or mousewheel ... /
		*gAdjustment= gtk_tree_view_get_vadjustment_(GadgetID(#LIG))
		g_signal_connect(*gAdjustment, "value-changed", @TV_VScrollEvent(), #LIG)

	EndIf
EndProcedure

CreateWindow_Main()

Repeat
	gEvent= WaitWindowEvent()

	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.40 LTS Beta 9 (Linux - x86)
; CursorPosition = 26
; Folding = -
; EnableUnicode
; EnableXP