﻿; Module/File:     LIG_AddScrollEvent_Wheel2.pb
; Function:        Adds Event on LIG-scrolling with mousewheel - Linux gtk3
; Author:          Omi
; Date:            Sep. 02, 2015
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	g_signal_connect(*instance, detailed_signal.p-ascii, *c_handler, *data, destroy= 0, flags= 0) As "g_signal_connect_data"
	gdk_event_get_scroll_deltas (*event, *delta_x, *delta_y)
EndImport

;Object constants
#MainWin= 0
#LIG= 0

#WinX= 200
#WinY= 200
#WinW= 420
#WinH= 400

Global.i gEvent, gQuit

ProcedureC TV_ScrollWheelEvent(*widget, *event.GdkEventScroll, user_data);     callback for scrolling with wheel
	Protected.d delta_x, delta_y
	If user_data= #MainWin
		
		If *widget= GadgetID(#LIG)
			Debug "scroll event..."
			Debug " modifier key: " + Str(*event\state)
			Debug " direction   : " + Str(*event\direction)
			If *event\direction = 4
				Debug gdk_event_get_scroll_deltas (*event, @delta_x, @delta_y)
				Debug delta_x
				Debug delta_y
			EndIf
			Debug "---"
		EndIf
	EndIf
EndProcedure

Procedure CreateWindow_Main()
	Protected.l I, J
	Protected.s pText
	If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "Event on mousewheel scroll action", #PB_Window_SystemMenu)
		ListIconGadget(#LIG, 5, 5, 400, 380, "Col 0", 70, #PB_ListIcon_AlwaysShowSelection | #PB_ListIcon_GridLines)
		
		For I = 1 To 6
			AddGadgetColumn(#LIG, I, "Col " + Str(I), 60)
		Next I
		For I = 0 To 25
			pText = ""
			For J = 0 To 6
				pText + Str(I) + "x" + Str(J) + Chr(10)
			Next J
			AddGadgetItem(#LIG, -1, pText)
		Next I
		
		; / events an mouse wheel scrolling /
		g_signal_connect(GadgetID(#LIG), "scroll-event", @TV_ScrollWheelEvent(), #MainWin)
	EndIf
EndProcedure

CreateWindow_Main()

Repeat
	gEvent= WaitWindowEvent()

	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.40 LTS Beta 9 (Linux - x86)
; CursorPosition = 22
; Folding = -
; EnableUnicode
; EnableXP