﻿; Module/File:     LIG_CellEditNative_1.pb
; Function:        CellEdit, good one, most native - Linux
; Author:          empty (english forum), multicolumn by Omi, help from shardik
; Date:            Oct. 19, 2014
; Version:         0.2; fixed column 0 not editable (shardik)
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC "-gtk"
	g_object_set(*object.GObject, property_name.p-utf8, *data, v= 0)
	g_signal_connect(*instance, detailed_signal.p-ascii, *c_handler, *data, destroy= 0, flags= 0) As "g_signal_connect_data"
	gtk_cell_layout_get_cells(*cell_layout)
	g_type_check_instance_is_a(*instance.GTypeInstance, *type.GTypeClass)
EndImport

;Object constants
#Win = 0
#LIG = 0
#BUT = 1

Global.i gEvent, gQuit

;cell-edit:
; 1. after column-add:
;    TV_ColumnEditConnect(Gadget, Column, Editable= #True):  connect Column in LIG For editability And choose immediate editybility (Default: editable)
; 2. on demand:
;    TV_ColumnEditableEnable(Gadget, Column, Editable)    :  live-set enable/disable editability of columns

ProcedureC Callback_TV_CellEdited(*Renderer, path.s, NewCellTxt.s, Gadget); callback
	If GetGadgetData(Gadget)>- 1
		SetGadgetItemText(Gadget, Val(path), PeekS(@NewCellTxt, -1, #PB_UTF8), GetGadgetData(Gadget))
	EndIf
EndProcedure

ProcedureC Callback_TV_CellEditStart(*Renderer, edit.s, path.s, Gadget);  callback
	Protected *TreePath, *TreeColumn, *ColumnList.GList
	Protected.i Column= -1
	
	gtk_tree_view_get_cursor_(GadgetID(Gadget), @*TreePath, @*TreeColumn);  pathes of cell just started to edit
	If *TreePath
		*ColumnList= gtk_tree_view_get_columns_(GadgetID(Gadget));            adress of column-List
		Column     = g_list_index_(*ColumnList, *TreeColumn);                 index of edited column
		gtk_tree_path_free_(*TreePath) 
		g_list_free_(*ColumnList)
	EndIf
	SetGadgetData(Gadget, Column);                                          Save current edited column in LIG-Data till next editstart
EndProcedure

Procedure TV_ColumnEditConnect(Gadget, Column, Editable= #True);          connection for cell-edit, choose immediate editability
	Protected *TreePath  = gtk_tree_view_get_column_(GadgetID(Gadget), Column)
	Protected *List.GList= gtk_cell_layout_get_cells(*TreePath)
	Protected *Renderer.GtkCellRenderer
	Protected.i I
	
	For I= 0 To g_list_length_(*List) - 1;                                  search 'text'-renderer
		*Renderer= g_list_nth_data_(*List, I)
		If g_type_check_instance_is_a(*Renderer, gtk_cell_renderer_text_get_type_())
			Break
		EndIf
	Next I
	
	g_list_free_(*List)
	SetGadgetData(Gadget, -1)
	g_signal_connect(*Renderer, "editing-started", @Callback_TV_CellEditStart(), Gadget)
	g_signal_connect(*Renderer, "edited", @Callback_TV_CellEdited(), Gadget)
	If Editable : g_object_set(*Renderer, "editable", 1) : EndIf            
EndProcedure

Procedure TV_ColumnEditableEnable(Gadget, Column, Editable);              set/unset editability
	Protected *TreePath  = gtk_tree_view_get_column_(GadgetID(Gadget), Column)
	Protected *List.GList= gtk_cell_layout_get_cells(*TreePath)
	Protected *Renderer.GtkCellRenderer
	Protected.i I
	
	For I= 0 To g_list_length_(*List) - 1
		*Renderer= g_list_nth_data_(*List, I)
		If g_type_check_instance_is_a(*Renderer, gtk_cell_renderer_text_get_type_())
			Break
		EndIf
	Next I
	
	g_list_free_(*List)
	g_object_set(*Renderer, "editable", Editable);                          #True editable, #False= locked
EndProcedure


Procedure CreateWin_Main()
	Protected.i I, J
	Protected.s pText
	
	OpenWindow(#Win, 100, 100, 400, 200, "ListIcon cell-editing", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	ButtonGadget(#BUT, 5, 170, 150, 26, "Column 6 editable", #PB_Button_Toggle)
	
	ListIconGadget(#LIG, 5, 5, 390, 160, "Edit 0", 50, #PB_ListIcon_GridLines)
	TV_ColumnEditConnect(#LIG, 0);                                          connect and set column 0 editable
	For I = 1 To 6
		If I< 4
			AddGadgetColumn(#LIG, I, "Fix " + Str(I), 50)
		Else
			If I< 6
				AddGadgetColumn(#LIG, I, "Edit " + Str(I), 50)
				TV_ColumnEditConnect(#LIG, I);                                    connect and set column 4-6 editable
			Else
				AddGadgetColumn(#LIG, I, "Vari " + Str(I), 50)
				TV_ColumnEditConnect(#LIG, I, #False);                            connect but initial lock of column 6
			EndIf
		EndIf
	Next I
	For I = 0 To 25
		pText = ""
		For J = 0 To 6
			pText + Str(I) + "_" + Str(J) + Chr(10)
		Next J
		AddGadgetItem(#LIG, -1, pText)
	Next I
EndProcedure

CreateWin_Main()

Repeat
	gEvent= WaitWindowEvent()
	
	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
			
		Case #PB_Event_Gadget
			
			Select EventGadget()
				Case #BUT
					If GetGadgetState(#BUT)
						TV_ColumnEditableEnable(#LIG, 6, #True);                    activate col 6 editability
						SetGadgetItemText(#LIG, -1, "Edit 6", 6)
					Else
						TV_ColumnEditableEnable(#LIG, 6, #False);                   deactivate col 6 editability
						SetGadgetItemText(#LIG, -1, "Vari 6", 6)
					EndIf
			EndSelect
	EndSelect
Until gQuit
; IDE Options = PureBasic 5.40 LTS Beta 9 (Linux - x86)
; Folding = -
; EnableUnicode
; EnableXP
; Executable = ../../test