﻿; Module/File:     LIG_ColumnsCount.pb
; Function:        Get number of columns in ListIconGadget - Linux gtk2/gtk3
; Author:          Omi
; Date:            Juli 14, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

;A simpler version for only gtk3 see 'LIG_ColumnsCount2.pb'

EnableExplicit

; Object constants
#MainWin= 0
#LIG= 0

Global.i gEvent, gQuit

;- Functions ...
Procedure.i LIG_CountColumns(Gadget);                                LIG: Num of columns
	Protected *ColumnList= gtk_tree_view_get_columns_(GadgetID(Gadget));       column-pointer
	Protected Columns= g_list_length_(*ColumnList)
	
	g_list_free_(*ColumnList)

	ProcedureReturn Columns
EndProcedure

;- 
;- Example ...
Procedure CreateWindow_Main()
	Protected.l I, O
	Protected *Column
	#Img1= 0
	#Img2= 1
	If OpenWindow(#MainWin, 200, 200, 500, 400, "Num of LIG-columns", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
		ListIconGadget(#LIG, 5, 5, 480, 380, "column 0", 70, #PB_ListIcon_AlwaysShowSelection | #PB_ListIcon_GridLines)
		
		For O= 1 To 4
			AddGadgetColumn(#LIG, O, "column "+Str(O), 70)
		Next O
		For I= 0 To 19
			AddGadgetItem(#LIG, -1, Str(I)+".0")
		Next I
		
		For O= 1 To 4
			For I= 0 To 19
				If O< 3
					SetGadgetItemText(#LIG, I, Str(I)+"."+Str(O), O)
				Else
					SetGadgetItemText(#LIG, I, Str(19-I)+"."+Str(O), O)
				EndIf
			Next I
		Next O

	EndIf

EndProcedure

CreateWindow_Main()

Debug "columns: " + Str( LIG_CountColumns(#LIG))

Repeat
	gEvent= WaitWindowEvent()

	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.40 LTS Beta 9 (Linux - x86)
; CursorPosition = 10
; Folding = -
; EnableUnicode
; EnableXP
; CurrentDirectory = /home/charly-xubuntu/Programming/PureBasic/purebasic/