﻿; Module/File:     LIG_ColumnsHeaderClickable.pb
; Function:        All LIG-columns clickable, signal on/off to individual or all column(s) - Linux
; Author:          Omi / freak
; Date:            Oct. 17, 2014
; Version:         0.2
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------
; extended version ;-)

EnableExplicit

ImportC ""
	gtk_tree_view_column_get_tree_view(*Column.GtkTreeViewColumn)
	g_signal_connect(*instance, detailed_signal.p-ascii, *c_handler, *data, destroy= 0, flags= 0) As "g_signal_connect_data"
	g_signal_handler_find(*instance, mask, signal_id, detail, *closure, func, data_)
	g_signal_handlers_disconnect_by_func(*instance, *c_handler, *data)
EndImport

; Object constants
#MainWin= 0
#LIG  = 0
#But1 = 1
#But2 = 2
#But3 = 3

#WinX= 200
#WinY= 200
#WinW= 500
#WinH= 400

Global.i gEvent, gQuit

;- extern Function ...
Procedure.i TV_ColumnsCount(Gadget);                                           count LIG-column
	Protected *ColumnList= gtk_tree_view_get_columns_(GadgetID(Gadget));         pointer on columns
	Protected Columns= g_list_length_(*ColumnList)
	
	g_list_free_(*ColumnList)
	ProcedureReturn Columns
EndProcedure


;- Functions ...
ProcedureC Callback_TV_HeaderClicked(*Column.GtkTreeViewColumn, Colmn);        callback: LIG-column-header clicked
	If gtk_tree_view_column_get_tree_view(*Column)= GadgetID(#LIG)
		Debug "Click on column-header ..."
		Debug "Column-Index   : " + Str(Colmn)
		Debug "Column-path @  : " + gtk_tree_view_column_get_tree_view(*Column)
		Debug ""
	EndIf
EndProcedure


Procedure TV_HeaderClickable(Gadget, Clickable);                               LIG-Header (all columns) clickable (Clickable= #True) or not (Clickable= #False)
	gtk_tree_view_set_headers_clickable_(GadgetID(Gadget), Clickable)
EndProcedure

Procedure TV_ColumnClickConnect(Gadget, Column, Connect);                      Click-Signal (event) on LIG-Header-Column (Connect= #True) or not (Connect= #False)
	Protected.i I, HandlerId, On= #False
	Protected *Column.GtkTreeViewColumn
	
	For I= 0 To TV_ColumnsCount(Gadget)- 1
		If Column= #PB_Any
			On= #True
		Else
			If I= Column
				On= #True
			Else
				On= #False
			EndIf
		EndIf
		If ON
			*Column = gtk_tree_view_get_column_(GadgetID(Gadget), I);                pointer to column
			If *Column
				If Connect
					HandlerId= g_signal_handler_find(*Column, #G_SIGNAL_MATCH_FUNC, 0, 0, 0, @Callback_TV_HeaderClicked(), 0); handler already exists?
					If HandlerId
						If Not g_signal_handler_is_connected_(*Column, HandlerId);         handler not connected
							g_signal_connect(*Column, "clicked", @Callback_TV_HeaderClicked(), I);     connect 'click'-handler to column
						EndIf
					Else;                                                                no handler exists
						g_signal_connect(*Column, "clicked", @Callback_TV_HeaderClicked(), I);       connect new 'click'-handler to column
					EndIf
				Else
					HandlerId= g_signal_handler_find(*Column, #G_SIGNAL_MATCH_FUNC, 0, 0, 0, @Callback_TV_HeaderClicked(), 0)
					If HandlerId
						g_signal_handler_disconnect_(*Column, HandlerId);                  disconnect handler
					EndIf
				EndIf
			EndIf
		EndIf
	Next I
EndProcedure

;- Example
Procedure CreateWindow_Main()
	Protected.l I, O
	Protected *Column

	If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "ColumnsHeaderClickable", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
		ButtonGadget(#But1, 5, 5, 250, 26, "ListIconGadget-Header clickable", #PB_Button_Toggle)
		OptionGadget(#But2, 280, 5, 200, 26, "Signal on all columns")
		OptionGadget(#But3, 280, 35, 200, 26, "Signal on column 0 to 2")
		
		ListIconGadget(#LIG, 5, 70, 490, 320, "Column 0", 70, #PB_ListIcon_AlwaysShowSelection | #PB_ListIcon_GridLines | #PB_ListIcon_CheckBoxes)
		For O= 1 To 4
			AddGadgetColumn(#LIG, O, "Column "+Str(O), 70)
		Next O
		For I= 0 To 19
			AddGadgetItem(#LIG, -1, Str(I)+".0")
		Next I
		
		For O= 1 To 4
			For I= 0 To 19
				SetGadgetItemText(#LIG, I, Str(I)+"."+Str(O), O)
			Next I
		Next O
		
		For O= 3 To 4
			For I= 0 To 19
				SetGadgetItemText(#LIG, I, Str(19-I)+"."+Str(O), O)
			Next I
		Next O
	EndIf
	
	SetGadgetState(#But1, #True)
	
	TV_HeaderClickable(#LIG, #True);                                             #LIG-Header clickable
	TV_ColumnClickConnect(#LIG, #PB_Any, #True);                                 Click-signal on all columns
	
EndProcedure

CreateWindow_Main()

Repeat
	gEvent= WaitWindowEvent()

	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
			
		Case #PB_Event_Gadget
			
			Select EventGadget()
				Case #But1
					TV_HeaderClickable(#LIG, GetGadgetState(#But1))
					
				Case #But2
					TV_ColumnClickConnect(#LIG, #PB_Any, #True);                         Click-signal on all columns
					
				Case #But3
					TV_ColumnClickConnect(#LIG, 0, #True);                               Click-signal on column 0
					TV_ColumnClickConnect(#LIG, 1, #True)
					TV_ColumnClickConnect(#LIG, 2, #True)
					TV_ColumnClickConnect(#LIG, 3, #False);                              No Click-signal on column 3
					TV_ColumnClickConnect(#LIG, 4, #False);                               "
			EndSelect
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.40 LTS Beta 9 (Linux - x86)
; CursorPosition = 11
; FirstLine = 30
; Folding = -
; EnableUnicode
; EnableXP
; CurrentDirectory = /home/charly-xubuntu/Programming/PureBasic/purebasic/