﻿; Module/File:     LIG_GetSelectedListV2.pb
; Function:        Query all indices (rows) of (multi-) selected ListIconGadget items, V2 - Linux
; Author:          Omi
; Date:            Nov. 30, 2015 ☑
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gtk_tree_selection_get_selected_rows(*selection.GtkTreeSelection, *model)
EndImport

;Object constants
#MainWin= 0
#LIG = 0
#But1= 1

Global.i gEvent, gQuit

Procedure.s TV_GetSelectionList(Gadget)
	Protected   *gList.GList= gtk_tree_selection_get_selected_rows(gtk_tree_view_get_selection_(GadgetID(Gadget)), #Null)
	Protected.s sSelections
	Protected.i I
	
;	Method 1 ...
	If *gList
		Repeat
			;use it on each pass ...
;			Debug PeekL(gtk_tree_path_get_indices_(*gList\data));                    or fill a array, string, ...
			sSelections+ Str(PeekL(gtk_tree_path_get_indices_(*gList\data))) + ";"
			*gList= *gList\next
		Until *gList = #Null
	EndIf
	
;	Method 2 ...
; 	If *gList
; 		For I= 0 To g_list_length_(*gList)-1
;			;use it on each pass ...
; 			Debug PeekL(gtk_tree_path_get_indices_(g_list_nth_data_(*gList, I)));  or fill a array, string, ...
;			sSelections+ Str(PeekL(gtk_tree_path_get_indices_(*gList\data))) + ";"
; 		Next I
; 	EndIf
	g_list_free_(*gList)
	Debug " ---"
	ProcedureReturn sSelections
EndProcedure

Procedure CreateWindow_Main()
	Protected.i I, O

	If OpenWindow(#MainWin, 200, 200, 500, 400, "List Multiselections", #PB_Window_SystemMenu)
		ButtonGadget(#But1,  5,  5, 400,  26, "First select some item, than click ...")
		ListIconGadget(#LIG, 5, 35, 480, 350, "Spalte 1", 70, #PB_ListIcon_AlwaysShowSelection | #PB_ListIcon_GridLines | #PB_ListIcon_MultiSelect)
		
		For O= 1 To 4
			AddGadgetColumn(#LIG, O, "Spalte "+Str(O+ 1), 70)
		Next O
		For I= 1 To 20
			AddGadgetItem(#LIG, -1, Str(I)+".1")
		Next I
		
		For O= 1 To 4
			For I= 0 To 19
				SetGadgetItemText(#LIG, I, Str(I+1)+"."+Str(O+1), O)
			Next I
		Next O
		
		For O= 3 To 4
			For I= 0 To 19
				SetGadgetItemText(#LIG, I, Str(20-I)+"."+Str(O+1), O)
			Next I
		Next O
		
		GadgetToolTip(#But1, "Use [Ctrl] with leftclick!")
		
	EndIf
EndProcedure

CreateWindow_Main()

Repeat
	gEvent= WaitWindowEvent()

	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
		Case #PB_Event_Gadget
			Select EventGadget()
				Case #But1
					Debug RTrim(TV_GetSelectionList(#LIG), ";")
			EndSelect
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.42 LTS (Linux - x86)
; CursorPosition = 56
; FirstLine = 39
; Folding = -
; EnableUnicode
; EnableXP