﻿; Module/File:     LIG_GetVisibleBottomItemPath.pb
; Function:        Get Path (+ index) from bottom Item - Linux
; Author:          Omi
; Date:            Sept. 22, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gtk_tree_view_get_visible_range(*tree_view.GtkTreeView, *tPathF, *tPathL)
EndImport

; Object constants
#MainWin= 0
#LIG= 0
#But1= 1

#WinX= 200
#WinY= 200
#WinW= 500
#WinH= 450

Global.i gEvent, gQuit
Global gLItem, gLPath


;- Functions ...
Procedure.i TV_GetIndexFromPath(Gadget, *tPath);          LIG: Index / Zeile (= Item) anhand des Pfad-Zeigers holen
	ProcedureReturn PeekL(gtk_tree_path_get_indices_(*tPath))
EndProcedure

Procedure TV_GetBottomItemPath(Gadget, *LItem)
	Protected.i Ret
	Protected *tPathF, *tPathL
	
	Ret= gtk_tree_view_get_visible_range(GadgetID(Gadget), @*tPathF, @*tPathL)
	If Ret
		PokeL(*LItem, TV_GetIndexFromPath(Gadget, *tPathL))
	EndIf
	gtk_tree_path_free_(*tPathF)
	;gtk_tree_path_free_(*tPathL) -> free after call
	
	ProcedureReturn *tPathL
EndProcedure

;- Example ...
Procedure CreateWindow_Main()
	Protected.l I, O
	If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "Get bottom line path", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
		ListIconGadget(#LIG, 5, 5, 480, 380, "Spalte 1", 70, #PB_ListIcon_AlwaysShowSelection | #PB_ListIcon_GridLines | #PB_ListIcon_CheckBoxes)
		ButtonGadget(#But1, 5, 400, 150, 25, "Debug bottom line")
		For O= 1 To 4
			AddGadgetColumn(#LIG, O, "Spalte "+Str(O+ 1), 70)
		Next O
		For I= 1 To 30
			AddGadgetItem(#LIG, -1, Str(I)+".1")
		Next I
		
		For O= 1 To 4
			For I= 0 To 29
				SetGadgetItemText(#LIG, I, Str(I+1)+"."+Str(O+1), O)
			Next I
		Next O
		
		For O= 3 To 4
			For I= 0 To 29
				SetGadgetItemText(#LIG, I, Str(20-I)+"."+Str(O+1), O)
			Next I
		Next O

	EndIf
	
EndProcedure

CreateWindow_Main()

Repeat
	gEvent= WaitWindowEvent()

	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
		Case #PB_Event_Gadget
			Select EventGadget()
				Case #But1
					gLPath= TV_GetBottomItemPath(#LIG, @gLItem)
					Debug "bottom line path  : " + Str(gLPath)
					Debug "index in parameter: " + Str(gLItem)
					gtk_tree_path_free_(gLPath)
			EndSelect
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.40 LTS Beta 9 (Linux - x86)
; CursorPosition = 10
; Folding = -
; EnableUnicode
; EnableXP
; Executable = ../../ImageViewer/LinuxPbSystemIconViewer
; CurrentDirectory = /home/charly-xubuntu/Programming/PureBasic/purebasic/