﻿; Module/File:     LIG_GetVisibleItems.pb
; Function:        Get number of partially visible items - Linux
; Author:          Omi
; Date:            Juli 11, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gtk_tree_view_get_visible_range(*tree_view.GtkTreeView, *tPathF, *tPathL)
EndImport

; Object constants
#MainWin= 0
#LIG= 0
#CbBox= 1

#WinX= 200
#WinY= 200
#WinW= 500
#WinH= 450

Global.i gEvent, gQuit


;- Functions ...
Procedure.i TV_GetIndexFromTreePath(Gadget, *tPath);                 LIG: get Index/Zeile/Item from TreePath
	ProcedureReturn PeekL(gtk_tree_path_get_indices_(*tPath))
EndProcedure

Procedure TV_GetVisibleItems(Gadget)
	Protected.i Ret, Num
	Protected *tPathF, *tPathL
	
	Ret= gtk_tree_view_get_visible_range(GadgetID(Gadget), @*tPathF, @*tPathL)
	If Ret
		Num=  TV_GetIndexFromTreePath(Gadget, *tPathL) - TV_GetIndexFromTreePath(Gadget, *tPathF) + 1
	Else
		Debug "not Okay"
	EndIf
	gtk_tree_path_free_(*tPathF)
	gtk_tree_path_free_(*tPathL)
	
	ProcedureReturn Num
EndProcedure

;- Example ...
Procedure CreateWindow_Main()
	Protected.l I, O
	Protected *Column
	#Img1= 0
	#Img2= 1
	If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "Get patially visible item count", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
		ListIconGadget(#LIG, 5, 5, 480, 385, "Spalte 1", 70, #PB_ListIcon_AlwaysShowSelection | #PB_ListIcon_GridLines | #PB_ListIcon_CheckBoxes)
		ButtonGadget(#CbBox, 5, 400, 150, 25, "Debug visible items")
		For O= 1 To 4
			AddGadgetColumn(#LIG, O, "Spalte "+Str(O+ 1), 70)
		Next O
		For I= 1 To 30
			AddGadgetItem(#LIG, -1, Str(I)+".1")
		Next I
		
		For O= 1 To 4
			For I= 0 To 29
				SetGadgetItemText(#LIG, I, Str(I+1)+"."+Str(O+1), O)
			Next I
		Next O
		
		For O= 3 To 4
			For I= 0 To 29
				SetGadgetItemText(#LIG, I, Str(20-I)+"."+Str(O+1), O)
			Next I
		Next O

	EndIf
	
EndProcedure

CreateWindow_Main()

Repeat
	gEvent= WaitWindowEvent()

	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
		Case #PB_Event_Gadget
			Select EventGadget()
				Case #CbBox
					Debug TV_GetVisibleItems(#LIG)
			EndSelect
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.40 LTS Beta 9 (Linux - x86)
; CursorPosition = 8
; Folding = -
; EnableUnicode
; EnableXP
; CurrentDirectory = /home/charly-xubuntu/Programming/PureBasic/purebasic/