﻿; Module/File:     LIG_GetVisibleItems2.pb
; Function:        Get Number of (partially/half/whole) visible items - Linux
; Author:          Omi
; Date:            Oct. 31, 2014
; Version:         0.2; update num for partially & full visible rows
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gtk_tree_view_get_visible_range(*tree_view.GtkTreeView, *tPathF, *tPathL)
EndImport

; Object constants
#MainWin= 0
#LIG    = 0
#But1   = 1
#But2   = 2
#But3   = 3
#Txt1   = 4
#Txt2   = 5
#Txt3   = 6

#WinX   = 200
#WinY   = 200
#WinW   = 500
#WinH   = 450

Global.i gEvent, gQuit

Enumeration; row visibility
	#TV_PathVisible;       > 0 pix visible
	#TV_PathVisibleHalf;   min. half height visible
	#TV_PathVisibleFull;   full height visible
EndEnumeration

;- Functions ...
Procedure.i TV_GetIndexFromTreePath(Gadget, *tPath);                 LIG: get Index/Zeile/Item from TreePath
	ProcedureReturn PeekL(gtk_tree_path_get_indices_(*tPath))
EndProcedure

Procedure TV_GetVisibleItems(Gadget, Visible= #TV_PathVisible)
	Protected.i            Ret, Num, SubLine
	Protected              *tPathF, *tPathL
	Protected.GdkRectangle CellRectF, CellRectL, VisRect
	
	Ret= gtk_tree_view_get_visible_range(GadgetID(Gadget), @*tPathF, @*tPathL)
	If Visible
		gtk_tree_view_get_visible_rect_(GadgetID(Gadget), @VisRect)
		gtk_tree_view_get_cell_area_(GadgetID(Gadget), *tPathF, #Null, @CellRectF)
		gtk_tree_view_get_cell_area_(GadgetID(Gadget), *tPathL, #Null, @CellRectL)
		If Visible= #TV_PathVisibleHalf;                                   min. half visible rows
			If CellRectF\y<= -(CellRectF\height / 2) : SubLine+ 1 : EndIf
			If (CellRectL\y + (CellRectL\height / 2))> VisRect\height : SubLine+ 1 : EndIf
		ElseIf Visible= #TV_PathVisibleFull;                               full visible rows
			If CellRectF\y< 0 : SubLine+ 1 : EndIf
			If (CellRectL\y + CellRectL\height)>= VisRect\height : SubLine+ 1 : EndIf
		EndIf
	EndIf
	If Ret
		Num= TV_GetIndexFromTreePath(Gadget, *tPathL) - TV_GetIndexFromTreePath(Gadget, *tPathF) + 1 - SubLine
	Else
		Debug "not Okay"
	EndIf
	gtk_tree_path_free_(*tPathF)
	gtk_tree_path_free_(*tPathL)
	
	ProcedureReturn Num
EndProcedure

;- Example ...
Procedure CreateWindow_Main()
	Protected.i I, O

	If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "Get num of visible items - ext. modes", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
		ListIconGadget(#LIG, 5, 5, 490, 350, "column 1", 70, #PB_ListIcon_AlwaysShowSelection | #PB_ListIcon_GridLines)
		ButtonGadget(#But1, 5, 360, 200, 26, "num of partial visible items:")
		ButtonGadget(#But2, 5, 390, 200, 26, "num of min. half visible items:")
		ButtonGadget(#But3, 5, 420, 200, 26, "num of full visible items:")
		TextGadget(#Txt1, 220, 366, 50, 24, "")
		TextGadget(#Txt2, 220, 396, 50, 24, "")
		TextGadget(#Txt3, 220, 426, 50, 24, "")
		
		For O= 1 To 4
			AddGadgetColumn(#LIG, O, "column "+Str(O), 70)
		Next O
		For I= 0 To 19
			AddGadgetItem(#LIG, -1, Str(I)+".0")
		Next I
		
		For O= 1 To 4
			For I= 0 To 19
				If O< 3
					SetGadgetItemText(#LIG, I, Str(I)+"."+Str(O), O)
				Else
					SetGadgetItemText(#LIG, I, Str(19-I)+"."+Str(O), O)
				EndIf
			Next I
		Next O
		
	EndIf
	
EndProcedure

CreateWindow_Main()

Repeat
	gEvent= WaitWindowEvent()

	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
		Case #PB_Event_Gadget
			Select EventGadget()
				Case #But1
					SetGadgetText(#Txt1, Str(TV_GetVisibleItems(#LIG)));       visible
				Case #But2
					SetGadgetText(#Txt2, Str(TV_GetVisibleItems(#LIG, 1)));    min. half visible
				Case #But3
					SetGadgetText(#Txt3, Str(TV_GetVisibleItems(#LIG, 2)));    only full visible
			EndSelect
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.40 LTS Beta 9 (Linux - x86)
; CursorPosition = 14
; Folding = -
; EnableUnicode
; EnableXP