﻿; Module/File:     LIG_ItemToPath&Index.pb
; Function:        Get TreePath from LIG-item and index/item from TreePath - Linux
; Author:          Omi
; Date:            Oct. 31, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gtk_tree_model_get_iter_from_string(*tree_model, *iter.GtkTreeIter, path_string.p-utf8)
EndImport

;Object constants
#MainWin= 0
#TXT1 = 0
#TXT2 = 1
#TXT3 = 2
#TXT4 = 3
#TXT5 = 4
#LIG  = 5

#WinX= 200
#WinY= 200
#WinW= 500
#WinH= 400

Global.i gEvent, gQuit
Global *gTPath

Procedure.i TV_GetPathFromIndex(Gadget, Row);                        path-pointer from LIG-item
	Protected iter.GtkTreeIter
	Protected *tModel= gtk_tree_view_get_model_(GadgetID(Gadget))
	Protected *tPath
	If Row> -1
		gtk_tree_model_get_iter_from_string(*tModel, @iter, Str(Row))
		*tPath = gtk_tree_model_get_path_(*tModel , @iter)
	EndIf
	
	ProcedureReturn *tPath
EndProcedure

Procedure.i TV_GetIndexFromTreePath(*TreePath);                      => index=item from TreeView-path
	ProcedureReturn PeekL(gtk_tree_path_get_indices_(*TreePath))
EndProcedure


Procedure CreateWindow_Main()
	Protected.i I, O

	If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "convert item to path & index", #PB_Window_SystemMenu)
		TextGadget(#TXT1, 5, 10, 100, 24, "select item...")
		TextGadget(#TXT2, 120, 10, 100, 24, "path from item : ", #PB_Text_Right)
		TextGadget(#TXT3, 225, 10, 70, 24, "000000000")
		TextGadget(#TXT4, 300, 10, 100, 24, "index from path: ", #PB_Text_Right)
		TextGadget(#TXT5, 405, 10, 70, 24, "000000000")
		ListIconGadget(#LIG, 5, 30, #WinW-10, 365, "column 0", 70, #PB_ListIcon_AlwaysShowSelection | #PB_ListIcon_GridLines | #PB_ListIcon_CheckBoxes)

		For O= 1 To 4
			AddGadgetColumn(#LIG, O, "column "+Str(O), 70)
		Next O
		For I= 0 To 19
			AddGadgetItem(#LIG, -1, Str(I)+".0")
		Next I
		
		For O= 1 To 4
			For I= 0 To 19
				SetGadgetItemText(#LIG, I, Str(I)+"."+Str(O), O)
			Next I
		Next O
		
		For O= 3 To 4
			For I= 0 To 19
				SetGadgetItemText(#LIG, I, Str(19-I)+"."+Str(O), O)
			Next I
		Next O

	EndIf

EndProcedure

CreateWindow_Main()

Repeat
	gEvent= WaitWindowEvent()

	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
		Case #PB_Event_Gadget
			If EventGadget()= #LIG
				If EventType()= #PB_EventType_Change
					
					*gTPath= TV_GetPathFromIndex(#LIG, GetGadgetState(#LIG));       path from selected item
					SetGadgetText(#TXT3, Str(*gTPath))
					
					If *gTPath
						SetGadgetText(#TXT5, Str(TV_GetIndexFromTreePath(*gTPath)));  and back from path to item/index
						gtk_tree_path_free_(*gTPath)
					EndIf
				EndIf
			EndIf
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.40 LTS Beta 9 (Linux - x86)
; CursorPosition = 8
; Folding = -
; EnableUnicode
; EnableXP