﻿; Module/File:     LIG_ItemsReorderable.pb
; Function:        D&D-reorderable LIG items w. autoscroll, w/o PB-activation - Linux
; Author:          Omi
; Date:            Dec. 20, 2015
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

;not neccessary
ImportC ""
	g_signal_connect(*instance, detailed_signal.p-ascii, *c_handler, *pdata, destroy= 0, flags= 0) As "g_signal_connect_data"
EndImport

;Object constants
#MainWin= 0
#LIG= 0

Global.i gEvent, gQuit

;not neccessary, only to debug infos ...
ProcedureC Callback_TreeView_RowInserted(*tree_model, *path, *iter, user_data)
	Debug "Row inserted: " + Str(PeekL(gtk_tree_path_get_indices_(*path)))
EndProcedure

ProcedureC Callback_TreeView_RowDeleted(*tree_model, *path, *iter, user_data)
	Debug "Row deleted : " + Str(PeekL(gtk_tree_path_get_indices_(*path)))
EndProcedure

ProcedureC Callback_TreeView_RowChanged(*tree_model, *path, *iter, user_data)
	Debug "Row changed : " + Str(PeekL(gtk_tree_path_get_indices_(*path)))
EndProcedure
;-----


Procedure CreateWindow_Main()
	Protected.i I, O, *TreeModel

	If OpenWindow(#MainWin, 200, 200, 500, 400, "ListIconGadget-Items reorderable", #PB_Window_SystemMenu)
		TextGadget(#PB_Any,  5,  5, 490, 22, "Reordering rows (items) by Drag&Drop whithin 1 ListIconGadget ...")
		ListIconGadget(#LIG, 5, 40, 490, 355, "column 0", 70, #PB_ListIcon_AlwaysShowSelection | #PB_ListIcon_GridLines | #PB_ListIcon_CheckBoxes)

		For O= 1 To 4
			AddGadgetColumn(#LIG, O, "column "+Str(O), 70)
		Next O
		For I= 0 To 19
			AddGadgetItem(#LIG, -1, Str(I)+".0")
		Next I
		
		For O= 1 To 4
			For I= 0 To 19
				SetGadgetItemText(#LIG, I, Str(I)+"."+Str(O), O)
			Next I
		Next O
		
		For O= 3 To 4
			For I= 0 To 19
				SetGadgetItemText(#LIG, I, Str(19-I)+"."+Str(O), O)
			Next I
		Next O
	EndIf
	
	;no combination with Drop on further ListIconGadgets possible, if activated!!! & there's a bug at moment if you quit ...
	gtk_tree_view_set_reorderable_(GadgetID(#LIG), #True)
	
	;not neccessary, only for additional infos ...
	*TreeModel= gtk_tree_view_get_model_(GadgetID(#LIG))
	g_signal_connect(*TreeModel, "row-inserted", @Callback_TreeView_RowInserted(), 0)
	g_signal_connect(*TreeModel, "row-deleted",  @Callback_TreeView_RowDeleted(),  0)
	g_signal_connect(*TreeModel, "row-changed",  @Callback_TreeView_RowChanged(),  0)
EndProcedure

CreateWindow_Main()

Repeat
	gEvent= WaitWindowEvent()

	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.42 LTS (Linux - x86)
; CursorPosition = 66
; Folding = -
; EnableUnicode
; EnableXP