﻿; Module/File:     LIG_TooltipOnColumn.pb
; Function:        Show Tooltip on TreeView-column - Linux gtk2/gtk3
; Author:          Omi
; Date:            Oct. 14, 2016 ☑
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gtk_tree_view_set_tooltip_column(*GtkTreeView, Column)
	gtk_tooltip_set_text(*tooltip, text.p-utf8)
	gtk_tooltip_set_icon_from_icon_name(*tooltip, stock_id.p-utf8, size)
	g_signal_connect(*instance, detailed_signal.p-ascii, *c_handler, *data, destroy= 0, flags= 0) As "g_signal_connect_data"
	gtk_tree_view_convert_widget_to_bin_window_coords(*tree_view, wx, wy, *bx, *by)
EndImport

; Object constants
#MainWin= 0
#LIG1= 0

#WinX= 200
#WinY= 200
#WinW= 400
#WinH= 330

Global.i gEvent, gQuit, I
Global.i gTTColumn= 2


ProcedureC Callback_ListIconCheckTooltip(*Widget.GtkWidget, mX, mY, key, *tooltip, Gadget); user_data= Gadget
	Protected ColumnIndex
	Protected Show= #False
	Protected *tPath, *tColumn, *ColumnList.GList
	
	If *Widget = GadgetID(#LIG1)
		gtk_tree_view_convert_widget_to_bin_window_coords(*Widget, mX, mY, @mX, @mY)
		
		If gtk_tree_view_get_path_at_pos_(*Widget, mX, mY, @*tPath, @*tColumn, #Null, #Null)
			If GadgetType(Gadget) = #PB_GadgetType_ListIcon
				*ColumnList= gtk_tree_view_get_columns_(GadgetID(Gadget))
				ColumnIndex= g_list_index_(*ColumnList, *tColumn)
				If ColumnIndex = 2;                                                               choose your columns here !
					gtk_tooltip_set_text(*tooltip, "Own dynamic tooltip: " + #LF$ + "This is column " + ColumnIndex)
					;you wanna icon? ...
					gtk_tooltip_set_icon_from_icon_name(*tooltip, "gtk-info", #GTK_ICON_SIZE_MENU); OR try "dialog-information"
					Show= #True
				EndIf
			EndIf
		EndIf
	EndIf
	
	ProcedureReturn Show
EndProcedure

Procedure CreateWindow_Main()
	Protected.i I
	
	If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "ListIconGadget - Tooltip on column x", #PB_Window_SystemMenu)
		ListIconGadget(#LIG1, 5, 5, #WinW-10, #WinH-10, "column0", 130, #PB_ListIcon_GridLines)
		AddGadgetColumn(#LIG1, 1, "column1", 130)
		AddGadgetColumn(#LIG1, 2, "column2 (w. tooltip)", 100)
		
		For I = 0 To 10
			AddGadgetItem (#LIG1, -1, "Line " + Str(I) + " | Column 0" + #LF$ + "Line " + Str(I) + " | Column 1" + #LF$ + "Line " + Str(I) + " | Column 2")
		Next I
	EndIf
	
	gtk_tree_view_set_tooltip_column(GadgetID(#LIG1), 0);                        set to 0 !
	g_signal_connect(GadgetID(#LIG1), "query-tooltip", @Callback_ListIconCheckTooltip(), #LIG1, #Null, #Null)
EndProcedure

CreateWindow_Main()

Repeat
	gEvent= WaitWindowEvent()
	
	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
			
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.42 LTS (Linux - x86)
; CursorPosition = 47
; Folding = -
; EnableUnicode
; EnableXP