﻿; Module/File:     LIG_TooltipOnColumnHeader_Gtk3.pb
; Function:        ListIconGadget, add tooltip on columns-header - Linux gtk3
; Author:          Omi
; Date:            Oct. 17, 2016 ☑
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gtk_tree_view_column_get_button(*tree_column.GtkTreeViewColumn)
	gtk_tree_view_column_get_widget(*tree_column.GtkTreeViewColumn)
	gtk_widget_set_tooltip_text(*widget.GtkWidget, text.p-utf8)
EndImport

; Object constants
#MainWin= 0

#LIG  = 0

Global.i gEvent, gQuit

Procedure TV_ColumnHeaderTooltip_Set(Gadget, Column, ToolTipText.s)
	Protected *Column= gtk_tree_view_get_column_(GadgetID(Gadget), Column)
	Protected *Button= gtk_tree_view_column_get_button(*Column)
	
	If *Button
		gtk_widget_set_tooltip_text(*Button, ToolTipText)
	EndIf
EndProcedure

Procedure CreateWindow_Main()
	Protected.i I, O
	
	If OpenWindow(#MainWin, 200, 200, 500, 400, "ColumnsHeaderTooltip Gtk3", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
		ListIconGadget(#LIG, 5, 5, 490, 390, "Column 0", 90, #PB_ListIcon_AlwaysShowSelection | #PB_ListIcon_GridLines | #PB_ListIcon_CheckBoxes)
		For O= 1 To 4
			AddGadgetColumn(#LIG, O, "Column "+Str(O), 90)
		Next O
		For I= 0 To 19
			AddGadgetItem(#LIG, -1, Str(I)+"-0")
			For O= 1 To 4
				SetGadgetItemText(#LIG, I, Str(I)+"-"+Str(O), O)
			Next O
		Next I
	EndIf
	
	TV_ColumnHeaderTooltip_Set(#LIG, 0, "This is header-column 0")
	TV_ColumnHeaderTooltip_Set(#LIG, 1, "This is header-column 1")
	TV_ColumnHeaderTooltip_Set(#LIG, 2, "This is header-column 2")
	TV_ColumnHeaderTooltip_Set(#LIG, 3, "This is header-column 3")
	TV_ColumnHeaderTooltip_Set(#LIG, 4, "This is header-column 4")
EndProcedure

CreateWindow_Main()


Repeat
	gEvent= WaitWindowEvent()

	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
			
		Case #PB_Event_Gadget
			
			Select EventGadget()
			
			EndSelect
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.42 LTS (Linux - x86)
; CursorPosition = 57
; Folding = -
; EnableUnicode
; EnableXP