﻿; Module/File:     LV_RowEditNative_1.pb
; Function:        Items editable, native - Linux
; Author:          empty (english forum), help from shardik
; Date:            July. 17, 2015
; Version:         0.2; fixed: no row > 10 
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC "-gtk"
	g_object_set(*object.GObject, property_name.p-utf8, *data, v= 0)
	g_signal_connect(*instance, detailed_signal.p-ascii, *c_handler, *data, destroy= 0, flags= 0) As "g_signal_connect_data"
	gtk_cell_layout_get_cells(*cell_layout)
EndImport

; Object constants
#MainWin= 0
#LV= 0

#WinX= 200
#WinY= 200
#WinW= 300
#WinH= 400

Global.i gEvent, gQuit

; same Procs as ListIconGadget ...
ProcedureC Callback_TV_CellEdited(*Renderer, path.s, NewCellTxt.s, Gadget)
	If GetGadgetData(Gadget)>- 1
		SetGadgetItemText(Gadget, Val(PeekS(@path, -1, #PB_UTF8)), PeekS(@NewCellTxt, -1, #PB_UTF8), GetGadgetData(Gadget))
	EndIf
EndProcedure

ProcedureC Callback_TV_CellEditStart(*Renderer, edit.s, path.s, Gadget)
	Protected *TreePath, *TreeColumn, *ColumnList.GList
	Protected.i Column= -1
	
	gtk_tree_view_get_cursor_(GadgetID(Gadget), @*TreePath, @*TreeColumn);  pathes of cell just started to edit
	If *TreePath
		*ColumnList= gtk_tree_view_get_columns_(GadgetID(Gadget));            adress of column-List
		Column     = g_list_index_(*ColumnList, *TreeColumn);                 index of edited column
		gtk_tree_path_free_(*TreePath) 
		g_list_free_(*ColumnList)
	EndIf
	SetGadgetData(Gadget, Column);                                          Save current edited column in LIG-Data till next editstart
EndProcedure

Procedure TV_ColumnEditConnect(Gadget, Column)
	Protected *TreePath  = gtk_tree_view_get_column_(GadgetID(Gadget), Column)
	Protected *List.GList= gtk_cell_layout_get_cells(*TreePath)
	Protected *Renderer.GtkCellRenderer= g_list_nth_data_(*List, 0)
	
	g_list_free_(*List)
	SetGadgetData(Gadget, -1)
	g_signal_connect(*Renderer, "editing-started", @Callback_TV_CellEditStart(), Gadget)
	g_signal_connect(*Renderer, "edited", @Callback_TV_CellEdited(), Gadget)
	g_object_set(*Renderer, "editable", 1)
EndProcedure

Procedure TV_ColumnEditableEnable(Gadget, Column, Editable)
	Protected *TreePath  = gtk_tree_view_get_column_(GadgetID(Gadget), Column)
	Protected *List.GList              = gtk_cell_layout_get_cells(*TreePath)
	Protected *Renderer.GtkCellRenderer= g_list_nth_data_(*List, 0)
	
	g_list_free_(*List)
	g_object_set(*Renderer, "editable", Editable);                     #True editable, #False= locked
EndProcedure

;- Example ...
Procedure CreateWindow_Main()
	Protected.l I, O
	Protected *Column

	If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "ListView edit cell", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
		ListViewGadget(#LV, 5, 5, 290, 390)
		For I= 1 To 40
			AddGadgetItem(#LV, -1, Str(I)+".1")
		Next I
	EndIf
	
	TV_ColumnEditConnect(#LV, 0);       LVG always column '0'

EndProcedure

CreateWindow_Main()

Repeat
	gEvent= WaitWindowEvent()

	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.40 LTS Beta 9 (Linux - x86)
; CursorPosition = 70
; FirstLine = 45
; Folding = -
; EnableUnicode
; EnableXP
; CurrentDirectory = /home/charly-xubuntu/Programming/PureBasic/purebasic/