﻿; Module/File:     Menu_RecentFilesSys.pb
; Function:        Show system RecentFiles on submenu - Linux gtk2/gtk3
; Author:          Omi
; Date:            Nov. 28, 2015
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------
;works on Menu and ImageMenu

EnableExplicit

ImportC ""
	gtk_menu_get_attach_widget(*menu.GtkMenu)
	gtk_menu_item_get_label(*menu_item.GtkMenuItem)
	gtk_menu_item_get_submenu(*menu_item.GtkMenuItem)
	gtk_menu_item_set_submenu(*menu_item.GtkMenuItem, *submenu.GtkWidget)
	gtk_recent_manager_get_default()
; 	gtk_recent_manager_add_item(*manager, uri.p-utf8)
	gtk_recent_chooser_menu_new_for_manager(*manager)
	gtk_recent_chooser_set_filter(*chooser, *filter)
	gtk_recent_chooser_menu_set_show_numbers(*menu, show_numbers)
	gtk_recent_chooser_get_current_item(*chooser)
	gtk_recent_info_get_uri_display(*info)
	gtk_recent_info_unref(*info)
	gtk_recent_filter_new()
	gtk_recent_filter_add_pattern(*filter, pattern.p-utf8)
	g_signal_connect(*instance, detailed_signal.p-ascii, *c_handler, *data, destroy= 0, flags= 0) As "g_signal_connect_data"
EndImport

UsePNGImageDecoder()

; Object constants
#Win_Main = 0

Enumeration;                 Create Menu with item for RecentFile submenu-call (without items for submenu!)
	#Mn1
	#Mn1_Item11
	#Mn1_Item12
	#Mn1_Item13;               item used for RecentFiles-Submenu
	#Mn1_Item14
	#Mn1_Item15
	#Mn1_Item16
EndEnumeration

Global.i gEvent, gMenuEvent, gQuit
Global.s gGtkSubSytem
Global   *gMenuItem.GtkMenuItem
Global   *gRecentManager


Procedure.s GetGtkSubSytem()
	CompilerIf #PB_Compiler_Version < 540
		CompilerIf Subsystem("gtk3")
			gGtkSubSytem= "gtk3"
		CompilerElse
			gGtkSubSytem= "gtk2"
		CompilerEndIf
	CompilerElse
		CompilerIf Subsystem("gtk2")
			gGtkSubSytem= "gtk2"
		CompilerElse
			gGtkSubSytem= "gtk3"
		CompilerEndIf
	CompilerEndIf
	ProcedureReturn gGtkSubSytem
EndProcedure

;-
;- RecentFile-Library (until PB returns the widgets-adr ;-)_____________

Procedure.s Menu_GetItemLabel(*widget.GtkWidget);                                        works for popups, menus, submenus
	Protected   *subType.GtkImageMenuItem
	Protected.s ItemType, ItemLabel
	
	If *widget
		ItemType= PeekS(gtk_widget_get_name_(*widget), -1, #PB_UTF8);                        Menu item type
		If gGtkSubSytem= "gtk3"
			If ItemType <> "GtkSeparatorMenuItem";                                             else separator is harmed
				ItemLabel= PeekS(gtk_menu_item_get_label(*widget), -1, #PB_UTF8);                Label always in item
			EndIf
		Else;                                                                                gtk2
			*subType= *widget
			If *subType\menu_item\item\bin\child
				If PeekS(gtk_widget_get_name_(*subType\menu_item\item\bin\child), -1, #PB_UTF8) = "GtkAccelLabel";  gtk2 uses subitems for labels
					ItemLabel= PeekS(gtk_label_get_text_(*subType\menu_item\item\bin\child), -1, #PB_UTF8)
				EndIf
			EndIf
		EndIf
		ItemLabel= RemoveString(ItemLabel, "_", #PB_String_CaseSensitive, 1, 1);             remove "_" 
	EndIf
	
	ProcedureReturn ItemLabel
EndProcedure

Procedure.i Menu_FindItemByID(*menu, Menu, Title.s, ItemID)
	Protected   *widget.GtkWidget, *SubMenu.GtkWidget
	Protected   *list.GList= gtk_container_get_children_(*menu)
	Protected   *Agree= #Null
	Protected.s ItemLabel, sItemLabel= RemoveString(StringField(GetMenuItemText(Menu, ItemID), 1, #TAB$), "&", 1, 1)
	Protected.i I
	
	For I= 0 To g_list_length_(*list)- 1
		*widget= g_list_nth_data_(*list, I)
		
		If *widget
			*SubMenu= gtk_menu_item_get_submenu(*widget)
			ItemLabel= Menu_GetItemLabel(*widget)
			If sItemLabel = ItemLabel
				If gtk_menu_get_attach_widget(*menu)
					If Menu_GetItemLabel(gtk_menu_get_attach_widget(*menu)) = Title
						*Agree= *widget
						Break
					EndIf
				Else
					If Title = ""
						*Agree= *widget
						Break
					EndIf
				EndIf
			EndIf
			
			If *SubMenu
				*Agree= Menu_FindItemByID(*SubMenu, Menu, Title, ItemID)
				If *Agree : Break : EndIf
			EndIf
		EndIf
	Next I
	g_list_free_(*list)
	
	ProcedureReturn *Agree
EndProcedure

ProcedureC Callback_RecentChooserActivated(*chooser, user_data)
	Protected *RecentInfo= gtk_recent_chooser_get_current_item(*chooser)

	If *RecentInfo
		Debug PeekS(gtk_recent_info_get_uri_display(*RecentInfo), -1, #PB_UTF8)
		gtk_recent_info_unref(*RecentInfo)
	EndIf
EndProcedure

;-
;- Main _____________
Procedure.i Menu_AddRecentFiles(*item.GtkMenuItem, filter.s= "", ShowNumbers= #False)
	Protected *RecentManager= gtk_recent_manager_get_default()
	Protected *menu= gtk_recent_chooser_menu_new_for_manager(*RecentManager)
	
	gtk_recent_chooser_menu_set_show_numbers(*menu, ShowNumbers)
	
	If filter <> ""
		Protected *rffilter= gtk_recent_filter_new()
		gtk_recent_filter_add_pattern(*rffilter, filter)
		gtk_recent_chooser_set_filter(*menu, *rffilter)
	EndIf
	gtk_menu_item_set_submenu(*item, *menu)
	g_signal_connect(*menu, "item-activated", @Callback_RecentChooserActivated(), 0)
	
	ProcedureReturn *RecentManager;*menu
EndProcedure

Procedure CreateWindow_Main()
	OpenWindow(#Win_Main, 0, 0, 400, 300, "Sys-RecentFiles on menu", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
EndProcedure

Procedure Create_Mn1()
		CreateMenu(#Mn1, WindowID(#Win_Main));                                     CreateImageMenu also possible
		MenuTitle("File")
		MenuItem(#Mn1_Item11, "&New"        + #TAB$ + "Ctrl+N")
		MenuBar()
		MenuItem(#Mn1_Item12, "Open"       + #TAB$ + "Ctrl+O")
		MenuItem(#Mn1_Item13, "Recent files");                                     item to add submenu
		MenuBar()
		
		MenuItem(#Mn1_Item14, "&Save"       + #TAB$ + "Ctrl+S")
		MenuBar()
		MenuItem(#Mn1_Item15, "&Print"      + #TAB$ + "Ctrl+P")
		MenuBar()
		MenuItem(#Mn1_Item16, "Quit")
EndProcedure

gGtkSubSytem= GetGtkSubSytem()
CreateWindow_Main()
Create_Mn1()

*gMenuItem     = Menu_FindItemByID(MenuID(#Mn1), #Mn1, "File", #Mn1_Item13)
*gRecentManager= Menu_AddRecentFiles(*gMenuItem, "", #True)
;Adding an item (choose an existing file) ...
; gtk_recent_manager_add_item(*gRecentManager, "/home/charly-xubuntu/Programming/PBSource/LinuxAPI_Lib/Menu&Popup/others/Menu_SysRecentFiles.pb")

Repeat
	gEvent= WaitWindowEvent()
	
	Select gEvent
			
		Case #PB_Event_CloseWindow
			gQuit= #True
			
		Case #PB_Event_Menu
			gMenuEvent= EventMenu()
			If gMenuEvent <> #Mn1_Item13
				Debug GetMenuItemText(#Mn1, gMenuEvent)
				If gMenuEvent = #Mn1_Item16
					gQuit= #True
				EndIf
			EndIf
			
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.40 LTS (Linux - x64)
; CursorPosition = 9
; Folding = --
; EnableUnicode
; EnableXP