﻿; Module/File:     Popup_AddStockImageByLabel.pb
; Function:        Add a stock image to popup item by label - Linux gtk2/gtk3
; Author:          Omi
; Date:            Nov. 30, 2015
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gtk_image_new_from_stock(stock_id.p-utf8, size)
	gtk_container_get_children(*container.GtkContainer)
	gtk_container_remove(*container.GtkContainer, *widget.GtkWidget)
	gtk_menu_item_get_label(*menu_item.GtkMenuItem)
	gtk_menu_item_get_submenu(*menu_item.GtkMenuItem)
	gtk_menu_get_attach_widget(*menu.GtkMenu)
	gtk_image_menu_item_set_image(*image_menu_item, *image)
	gtk_widget_get_name(*widget.GtkWidget)
EndImport


; Object constants
#Win_Main = 0

#But1     = 0

Enumeration;                           Popup
	#Pu1
	#Pu1_Item1
	#Pu1_Item2
	#Pu1_Item3
	#Pu1_Item4
	#Pu1_Item51
	#Pu1_Item52
	#Pu1_Item53
	#Pu1_Item6
EndEnumeration

#G_TYPE_STRING= 64

Global.i gEvent, gQuit
Global.s gGtkSubSytem

Procedure.s GetGtkSubSytem()
	CompilerIf #PB_Compiler_Version < 540
		CompilerIf Subsystem("gtk3")
			gGtkSubSytem= "gtk3"
		CompilerElse
			gGtkSubSytem= "gtk2"
		CompilerEndIf
	CompilerElse
		CompilerIf Subsystem("gtk2")
			gGtkSubSytem= "gtk2"
		CompilerElse
			gGtkSubSytem= "gtk3"
		CompilerEndIf
	CompilerEndIf
	ProcedureReturn gGtkSubSytem
EndProcedure

;-
;- RecentFile-Library (until PB returns the widgets-adr ;-)_____________

Procedure.s Menu_GetItemLabel(*widget.GtkWidget);                                        works for popups, menus, submenus
	Protected   *subType.GtkImageMenuItem
	Protected.s ItemType, ItemLabel
	
	If *widget
		ItemType= PeekS(gtk_widget_get_name_(*widget), -1, #PB_UTF8);                         Menu item type
		If gGtkSubSytem= "gtk3"
			If ItemType <> "GtkSeparatorMenuItem";                                             else separator is harmed
				ItemLabel= PeekS(gtk_menu_item_get_label(*widget), -1, #PB_UTF8);                Label always in item
			EndIf
		Else;                                                                                gtk2
			*subType= *widget
			If *subType\menu_item\item\bin\child
				If PeekS(gtk_widget_get_name_(*subType\menu_item\item\bin\child), -1, #PB_UTF8) = "GtkAccelLabel";  gtk2 uses subitems for labels
					ItemLabel= PeekS(gtk_label_get_text_(*subType\menu_item\item\bin\child), -1, #PB_UTF8)
				EndIf
			EndIf
		EndIf
		ItemLabel= RemoveString(ItemLabel, "_", #PB_String_CaseSensitive, 1, 1);             "_" remove
	EndIf
	
	ProcedureReturn ItemLabel
EndProcedure

Procedure.i Popup_AddStockImageByLabel(*menu, Menu, Title.s, sItemLabel.s, StockItem.s)
	Protected   *widget.GtkWidget, *SubMenu.GtkWidget
	Protected   *list.GList= gtk_container_get_children(*menu)
	Protected   *Agree= #Null
	Protected.s ItemLabel
	Protected.i I
	
	For I= 0 To g_list_length_(*list)- 1
		*widget= g_list_nth_data_(*list, I)
		
		If *widget
			*SubMenu= gtk_menu_item_get_submenu(*widget)
			ItemLabel= Menu_GetItemLabel(*widget)
			If sItemLabel = ItemLabel
				If gtk_menu_get_attach_widget(*menu)
					If Menu_GetItemLabel(gtk_menu_get_attach_widget(*menu)) = Title
						*Agree= *widget
					EndIf
				Else
					If Title = ""
						*Agree= *widget
					EndIf
				EndIf
				If *Agree
					Protected *image.GtkImage= gtk_image_new_from_stock(StockItem, #GTK_ICON_SIZE_MENU)
					gtk_image_menu_item_set_image(*Agree, *image)
					Break
				EndIf
			EndIf
			
			If *SubMenu
				*Agree= Popup_AddStockImageByLabel(*SubMenu, Menu, Title, sItemLabel, StockItem)
				If *Agree : Break : EndIf
			EndIf
		EndIf
	Next I
	
	g_list_free_(*list)
	ProcedureReturn *Agree
EndProcedure

;-----------------------

Procedure CreateWindow_Main()
	OpenWindow(#Win_Main, 0, 0, 400, 300, "PopupItems w. Stock-Images", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	ButtonGadget(#But1,   5,   5, 390, 26, "Open Popup ...")

EndProcedure

Procedure Create_Pu1()
	CreatePopupMenu(#Pu1)
	MenuItem(#Pu1_Item1, "New")
	MenuItem(#Pu1_Item2, "Open")
	MenuItem(#Pu1_Item3, "Save")
	MenuItem(#Pu1_Item4, "Print")
	MenuBar()
	
	OpenSubMenu("Format")
	MenuItem(#Pu1_Item51, "Ascii")
	MenuItem(#Pu1_Item52, "UTF8")
	MenuItem(#Pu1_Item53, "Unicode")
	CloseSubMenu()
	MenuBar()
	
	MenuItem(#Pu1_Item6, "Quit")
EndProcedure

gGtkSubSytem= GetGtkSubSytem()
CreateWindow_Main()
Create_Pu1()

Popup_AddStockImageByLabel(MenuID(#Pu1), #Pu1, "", "New", "gtk-new")
Popup_AddStockImageByLabel(MenuID(#Pu1), #Pu1, "", "Open", "gtk-open")
Popup_AddStockImageByLabel(MenuID(#Pu1), #Pu1, "", "Save", "gtk-save")
Popup_AddStockImageByLabel(MenuID(#Pu1), #Pu1, "", "Print", "gtk-print")
Popup_AddStockImageByLabel(MenuID(#Pu1), #Pu1, "", "Quit", "gtk-quit")


Repeat
	gEvent= WaitWindowEvent()
	
	Select gEvent
			
		Case #PB_Event_CloseWindow
			gQuit= #True
			
		Case #PB_Event_Gadget
			
			Select EventGadget()
					
				Case #But1
					DisplayPopupMenu(#Pu1, WindowID(#Win_Main))
					
			EndSelect
			
		Case #PB_Event_Menu
			Debug GetMenuItemText(#Pu1, EventMenu())
			
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.40 LTS (Linux - x64)
; CursorPosition = 8
; Folding = --
; EnableUnicode
; EnableXP