﻿; Module/File:     Popup_ExtendedItemAccess_Demo.pb
; Function:        Extended access and functions on popup elements - Linux gtk2/gtk3
; Author:          Omi
; Date:            Nov. 06, 2016
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------
;A little help file see /FilesForCodes/X-Menu+Popup-Workaround.pdf

EnableExplicit

CompilerIf #PB_Compiler_OS = #PB_OS_Linux
	CompilerIf #PB_Compiler_Version >= 540
		CompilerIf Subsystem("gtk2")
			#GtkSubSytem= "gtk2"
		CompilerElse
			#GtkSubSytem= "gtk3"
		CompilerEndIf
	CompilerElse
		CompilerIf Subsystem("gtk3")
			#GtkSubSytem= "gtk3"
		CompilerElse
			#GtkSubSytem= "gtk2"
		CompilerEndIf
	CompilerEndIf
CompilerElse
	#GtkSubSytem= ""
CompilerEndIf

UsePNGImageDecoder()

ImportC ""
	gtk_container_get_children(*container.GtkContainer)
	gtk_menu_item_get_label(*menu_item.GtkMenuItem)
	gtk_widget_get_name(*widget.GtkWidget)
	gtk_widget_get_sensitive(*widget.GtkWidget)
	gtk_widget_get_visible(*widget.GtkWidget)
	gtk_menu_item_set_label(*menu_item.GtkMenuItem, label.p-utf8)
	gtk_label_set_text(*label.GtkLabel, str.p-utf8)
	gtk_image_new_from_file(filename.p-utf8)
	gtk_image_new_from_icon_name(stock_id.p-utf8, size)
	gtk_icon_theme_load_icon(*icon_theme.GtkIconTheme, icon_name.p-utf8, size, flags, *error.GError)
	g_list_length(*list_.GList)
	
	gtk_widget_set_tooltip_text(*widget.GtkWidget, text.p-utf8)
	pango_font_description_from_string(str.p-utf8)
	CompilerIf #GtkSubSytem = "gtk3"
		gtk_widget_get_preferred_height(*widget.GtkWidget, *minimum_height, *natural_height)
		gtk_widget_get_preferred_width (*widget.GtkWidget, *minimum_height, *natural_height)
		gtk_menu_shell_get_selected_item(*menu_shell.GtkMenuShell)
		gtk_widget_override_font(*widget.GtkWidget, *font_desc)
		gdk_rgba_parse(*rgba, spec.p-utf8)
		gtk_widget_override_color(*widget.GtkWidget, state, *color)
		gtk_widget_override_background_color(*widget.GtkWidget, state, *color)
	CompilerElseIf #GtkSubSytem = "gtk2"
; 		gtk_widget_modify_font(*widget.GtkWidget, *font_desc)
; 		gdk_color_parse(*spec, *color.GdkColor)
	CompilerEndIf
	g_signal_connect(*instance, detailed_signal.p-ascii, *c_handler, *data, destroy= 0, flags= 0) As "g_signal_connect_data"
EndImport


; Object constants
#Win_Main = 0

#But1     = 0

Enumeration;                                                                              Popup
	#Pu1
	#Pu1_Item11
	#Pu1_Item12
	#Pu1_Item13
	#Pu1_Item14
	#Pu1_Item15
	#Pu1_Item151
	#Pu1_Item152
	#Pu1_Item153
	#Pu1_Item16
	#Pu1_Item17
	#Pu1_Item18
	#Pu1_Item19
EndEnumeration

Enumeration
	#Img1
EndEnumeration

Enumeration GtkStateFlags
	#GTK_STATE_FLAG_NORMAL      = 0
EndEnumeration

Structure GdkRGBA
	red.d
	green.d
	blue.d
	alpha.d
EndStructure


Global.i gEvent, gEvMenu, gQuit
Global   gMenu, *gFontDescription
Global.i gNatWidth, gNatHeight
Global   gColorRGBA.GdkRGBA

Declare Menu_ItemID(*MenuID, nthItem)
Declare Menu_GetItemMenu(*MenuItemID)
Declare.s Menu_GetItemLabel(*MenuItemID)
Declare.i Menu_GetItemMenu(*MenuItemID)
Declare.i Menu_GetSize(*Widget, *Width.integer, *Height.integer)


; search file from name in default icon theme and return pixbuf or Null ...
Procedure IconDefaultTheme_LoadIconFromName(icon_name.s, icon_size, flags= #Null)
	Protected *pixbuf
	Protected *error.GError
	
	*pixbuf= gtk_icon_theme_load_icon(gtk_icon_theme_get_default_(), icon_name, icon_size, flags, @*error)
	If *error : Debug PeekS(*error\message, -1, #PB_UTF8) : EndIf
	ProcedureReturn *pixbuf
EndProcedure

Procedure PangoDescriptionFromString(sFontDescription.s)
	Protected PangoFontDescription= pango_font_description_from_string(sFontDescription)
	
	ProcedureReturn PangoFontDescription
EndProcedure

ProcedureC Callback_MenuActivated(*widget.GtkWidget, user_data)
	If *widget = Menu_ItemID(gMenu, 7);              item 'Recent files' with submenu
		Debug "Popup SubMenu '" + Menu_GetItemLabel(*widget) + "' visible: " + Str(gtk_widget_get_visible(*widget)) + ", Sub-MenuID: " + Str(Menu_GetItemMenu(*widget))
		;NOT POSSIBLE, DRAWN LATER ...
; 		If Menu_GetSize(Menu_GetItemMenu(*widget), @gNatWidth, @gNatHeight)
; 			Debug " -> Menu size: " + Str(gNatWidth) + " x " + Str(gNatHeight)
; 		EndIf
	EndIf
EndProcedure

CompilerIf #GtkSubSytem = "gtk3"
	ProcedureC Callback_MenuButtonPress(*widget.GtkWidget, *Event.GdkEventButton, user_data)
		If *Event\button = 1
			If *Event\type = #GDK_BUTTON_PRESS
				If Not gtk_menu_shell_get_selected_item(*widget)
					Debug "Menu: " + Str(*widget) + " closed w/o selection"
				Else
					Debug "Selection from menu: " + Str(*widget) + ": " + Menu_GetItemLabel(gtk_menu_shell_get_selected_item(*widget))
				EndIf
			EndIf
		EndIf
	EndProcedure
CompilerEndIf
; 
; ProcedureC Callback_SelectionDone(*widget.GtkWidget, user_data)
; 	Debug *widget
; 	If Not gtk_menu_shell_get_selected_item(*widget)
; 		Debug "Menu done: " + Str(*widget) + " closed w/o selection"
; 	Else
; 		Debug "Selection from menu done: " + Str(*widget) + ": " + Menu_GetItemLabel(gtk_menu_shell_get_selected_item(*widget))
; 	EndIf
; EndProcedure

;--------------------

;can be the PB-Menu (MenuID()) + TitleIndex, or TitleIndex ((Sub-)Menu) + ItemIndex or ItemIndex (SubMenu-Title) + ItemIndex
Procedure Menu_ItemID(*MenuID, nthItem)
	Protected *MenuItemID.GtkWidget
	Protected *list.GList= gtk_container_get_children(*MenuID)
	
	If nthItem <= g_list_length(*list)- 1
		*MenuItemID= g_list_nth_data_(*list, nthItem)
	EndIf
	ProcedureReturn *MenuItemID
EndProcedure

Procedure.i Menu_CountItems(*MenuID)
	Protected   Number
	Protected.s sName
	
	If *MenuID
		sName= PeekS(gtk_widget_get_name(*MenuID), -1, #PB_UTF8)
		If sName = "GtkMenu" Or sName = "GtkMenuBar"
			Protected   *list.GList= gtk_container_get_children(*MenuID)
			Number= g_list_length(*list)
		Else
			Debug "*MenuID for " + Str(*MenuID) + " must be a GtkMenu Or GtkMenuBar!"
		EndIf
	Else
		Debug Str(*MenuID) + " is no valid GtkMenu- or GtkMenuBar-pointer!"
	EndIf
	ProcedureReturn Number
EndProcedure

Procedure.i Menu_GetItemMenu(*MenuItemID)
	If *MenuItemID
		*MenuItemID= gtk_menu_item_get_submenu_(*MenuItemID)
	EndIf
	ProcedureReturn *MenuItemID
EndProcedure

Procedure.i Menu_GetItemChecked(*MenuItemID)
	Protected.i Checked
	
	If *MenuItemID
		If PeekS(gtk_widget_get_name(*MenuItemID), -1, #PB_UTF8) = "GtkCheckMenuItem"
			Checked= gtk_check_menu_item_get_active_(*MenuItemID)
		EndIf
	EndIf
	ProcedureReturn Checked
EndProcedure

Procedure.i Menu_GetItemDisabled(*MenuItemID)
	Protected.i Disabled
	
	If *MenuItemID
		Disabled= gtk_widget_get_sensitive(*MenuItemID) !#True
	EndIf
	ProcedureReturn Disabled
EndProcedure

Procedure.i Menu_GetItemInvisible(*MenuItemID)
	Protected.i Invisible
	
	If *MenuItemID
		Invisible= gtk_widget_get_visible(*MenuItemID) !1
	EndIf
	ProcedureReturn Invisible
EndProcedure

Procedure.s Menu_GetItemLabel(*MenuItemID);                                              for item & title
	Protected.s ItemLabel= "", ItemType
	Protected   *subType.GtkImageMenuItem
	
	If *MenuItemID
		ItemType= PeekS(gtk_widget_get_name(*MenuItemID), -1, #PB_UTF8);                     Menu item type
		If #GtkSubSytem= "gtk3"
			If ItemType <> "GtkSeparatorMenuItem";                                             gtk_menu_item_get_label-access kills the visibility of MenuBar
				ItemLabel= PeekS(gtk_menu_item_get_label(*MenuItemID), -1, #PB_UTF8);            Label always in item
			EndIf
		Else
			If ItemType = "GtkMenuItem";                                                       Label in item
				ItemLabel= PeekS(gtk_menu_item_get_label(*MenuItemID), -1, #PB_UTF8)
			Else;                                                                              Label in child label
				*subType= *MenuItemID
				If ItemType <> "GtkSeparatorMenuItem";                                           gtk_menu_item_get_label-access kills the visibility of MenuBar
					ItemLabel= PeekS(gtk_label_get_text_(*subType\menu_item\item\bin\child), -1, #PB_UTF8)
				EndIf
			EndIf
		EndIf
	EndIf
	ItemLabel= RemoveString(ItemLabel, "_", #PB_String_CaseSensitive, 1, 1);               "_" entfernen
	ProcedureReturn ItemLabel
EndProcedure

Procedure.s Menu_GetItemType(*MenuItemID);                                               for item & title
	Protected.s ItemType
	
	If *MenuItemID
		ItemType= PeekS(gtk_widget_get_name(*MenuItemID), -1, #PB_UTF8);                       Menu item type
	EndIf
	ProcedureReturn ItemType
EndProcedure

Procedure.i Menu_GetSize(*Widget, *Width.integer, *Height.integer);                        for menu & item
	Protected.i Res= #False
	
	If gtk_widget_get_visible(*Widget)
		CompilerIf #GtkSubSytem = "gtk2"
			Protected requisition.GtkRequisition
			gtk_widget_size_request_(*Widget, @requisition)
			If requisition
				*Width\i = requisition\width
				*Height\i= requisition\height
				Res= #True
			EndIf
		CompilerElse
			gtk_widget_get_preferred_width(*Widget, #Null, @*Width\i)
			gtk_widget_get_preferred_height(*Widget, #Null, @*Height\i)
			Res= #True
		CompilerEndIf
	EndIf
	ProcedureReturn Res
EndProcedure

Procedure Menu_SetItemLabel(*MenuItemID, label.s);                                              for item & title
	Protected.s ItemLabel= "", ItemType
	Protected   *subType.GtkImageMenuItem
	
	If *MenuItemID
		ItemType= PeekS(gtk_widget_get_name(*MenuItemID), -1, #PB_UTF8);                     Menu item type
		If #GtkSubSytem= "gtk3"
			If ItemType <> "GtkSeparatorMenuItem";                                             gtk_menu_item_get_label-access kills the visibility of MenuBar
				gtk_menu_item_set_label(*MenuItemID, label);            Label always in item
			EndIf
		Else
			If ItemType = "GtkMenuItem";                                                       Label in item
				gtk_menu_item_set_label(*MenuItemID, label)
			Else;                                                                              Label in child label
				*subType= *MenuItemID
				If ItemType <> "GtkSeparatorMenuItem";                                           gtk_menu_item_get_label-access kills the visibility of MenuBar
					gtk_label_set_text(*subType\menu_item\item\bin\child, label)
				EndIf
			EndIf
		EndIf
	EndIf
EndProcedure

Procedure Menu_SetItemDisabled(*MenuItemID, Disabled)
	If *MenuItemID
		gtk_widget_set_sensitive_(*MenuItemID, Disabled !#True)
	EndIf
EndProcedure

Procedure Menu_SetItemInvisible(*MenuItemID, Invisible)
	If *MenuItemID
		If Invisible
			gtk_widget_hide_(*MenuItemID)
		Else
			gtk_widget_show_(*MenuItemID)
		EndIf
	EndIf
EndProcedure

Procedure.i Menu_SetItemImage(*MenuItemID, *Image)
	Protected.i Ret= #False
	
	If *MenuItemID And *Image
		If Menu_GetItemType(*MenuItemID) = "GtkImageMenuItem"
			gtk_image_menu_item_set_image_(*MenuItemID, *Image)
			Ret= #True
		EndIf
	EndIf
	ProcedureReturn Ret
EndProcedure

;--------------------

Procedure CreatePopup()
	CreatePopupMenu(#Pu1)
	
		MenuItem(#Pu1_Item11, "&New"        + #TAB$ + "Ctrl+N")
		MenuItem(#Pu1_Item12, "&Open"       + #TAB$ + "Ctrl+O")
		MenuItem(#Pu1_Item13, "&Save"       + #TAB$ + "Ctrl+S")
		MenuBar()
		
		MenuItem(#Pu1_Item14, "(en/dis)able next item ⬇")
		MenuItem(#Pu1_Item15, "&Print"      + #TAB$ + "Ctrl+P")
		MenuBar()
		
		OpenSubMenu("Recent files")
			MenuItem(#Pu1_Item151, "SubItem 1")
			MenuItem(#Pu1_Item152, "SubItem 2")
			MenuItem(#Pu1_Item153, "SubItem 3")
		CloseSubMenu()
		MenuBar()
		
		MenuItem(#Pu1_Item16, "Hide next items ⬇")
		MenuItem(#Pu1_Item17, "↳ Hide me     😈")
		MenuItem(#Pu1_Item18, "↳ Hide me too 😈")
		MenuBar()
		
		MenuItem(#Pu1_Item19, "&Quit")
		
		DisableMenuItem(#Pu1, #Pu1_Item15, #True)
EndProcedure

Procedure CreateWindow_Main()
	OpenWindow(#Win_Main, 0, 0, 400, 400, "API Popup access", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	
		ButtonGadget(#But1, 5, 5, 390, 26, "Open Popup w. extended features ...")
EndProcedure

Procedure Popup_ExtendedDemo()
	gMenu= MenuID(#Pu1)
	CompilerIf #GtkSubSytem = "gtk3"
		*gFontDescription= PangoDescriptionFromString("Monospace bold 11")
		
		;Change font of single menu items ...
		gtk_widget_override_font(Menu_ItemID(gMenu, 0), *gFontDescription)
		gtk_widget_override_font(Menu_ItemID(gMenu, 1), *gFontDescription)
		gtk_widget_override_font(Menu_ItemID(gMenu, 2), *gFontDescription)
		
		;Set COLOR for item font or label-background ...
		gdk_rgba_parse(@gColorRGBA, "#FF0000")
		gtk_widget_override_color(Menu_ItemID(gMenu, 0), #GTK_STATE_FLAG_NORMAL, gColorRGBA)
		gdk_rgba_parse(@gColorRGBA, "#00CF00")
		gtk_widget_override_color(Menu_ItemID(gMenu, 1), #GTK_STATE_FLAG_NORMAL, gColorRGBA)
		gdk_rgba_parse(@gColorRGBA, "#0000FF")
		gtk_widget_override_color(Menu_ItemID(gMenu, 2), #GTK_STATE_FLAG_NORMAL, gColorRGBA)
		gdk_rgba_parse(@gColorRGBA, "#CFEFFF")
		gtk_widget_override_background_color(gtk_bin_get_child_(Menu_ItemID(gMenu, 1)), #GTK_STATE_FLAG_NORMAL, gColorRGBA)
	CompilerEndIf
	
	;*** Deprecated since Gtk3.10 ... ***
	;Set MenuItem IMAGE from file (in Edit / Copy) ...
	Menu_SetItemImage(Menu_ItemID(gMenu, 0), gtk_image_new_from_file("/usr/share/icons/default.kde4/16x16/actions/document-new.png"))
	;Set MenuItem IMAGE from stock (in Edit / Cut) ...
	Menu_SetItemImage(Menu_ItemID(gMenu, 1), gtk_image_new_from_icon_name("document-open", #GTK_ICON_SIZE_MENU))
	;Set MenuItem IMAGE from default-system-icon (in Edit / Paste) ...
	Menu_SetItemImage(Menu_ItemID(gMenu, 2), gtk_image_new_from_pixbuf_(IconDefaultTheme_LoadIconFromName("document-save", 16)))
	;Set MenuItem IMAGE embedded (w. ImageDecoder, in Edit / Select All) ...
	If CatchImage(#Img1, ?Img1) : Menu_SetItemImage(Menu_ItemID(gMenu, 13), gtk_image_new_from_pixbuf_(ImageID(#Img1))) : EndIf
	
	;Set Tooltips for items ...
	gtk_widget_set_tooltip_text(Menu_ItemID(gMenu,  0), ~"Changed font and font color.\nLoaded png-image w/o decoder.")
	gtk_widget_set_tooltip_text(Menu_ItemID(gMenu,  1), ~"Changed font, font color and label background.\nStock-Image w/o decoder.")
	gtk_widget_set_tooltip_text(Menu_ItemID(gMenu,  2), ~"Changed font and font color.\nAuto-searched System-Icon w/o decoder.")
	gtk_widget_set_tooltip_text(Menu_ItemID(gMenu,  4), ~"Select this to enable/disable\nthe 'Print'-item\nA tooltip is set on this MenuItem.")
	gtk_widget_set_tooltip_text(Menu_ItemID(gMenu,  9), ~"Select this to hide/unhide\nthe following item\nA tooltip is set on this MenuItem.")
	gtk_widget_set_tooltip_text(Menu_ItemID(gMenu, 10),  "Hideable item.")
	gtk_widget_set_tooltip_text(Menu_ItemID(gMenu, 11),  "Hideable item.")
	gtk_widget_set_tooltip_text(Menu_ItemID(gMenu, 13),  "Embedded Image w. required decoder.")
	
	;Watch 'Recent files'-item submenu popup ...
	g_signal_connect(Menu_ItemID(gMenu, 7), "activate", @Callback_MenuActivated(), 0)
	CompilerIf #GtkSubSytem = "gtk3"
		g_signal_connect(MenuID(#Pu1), "button-press-event", @Callback_MenuButtonPress(), 0)
	CompilerEndIf
EndProcedure

CreateWindow_Main()
CreatePopup()

Popup_ExtendedDemo()

Repeat
	gEvent= WaitWindowEvent()
	
	Select gEvent
		
		Case #PB_Event_CloseWindow
			gQuit= #True
			
		Case #PB_Event_Gadget
			If EventGadget() = #But1
				DisplayPopupMenu(#Pu1, WindowID(#Win_Main))
				If Menu_GetSize(MenuID(#Pu1), @gNatWidth, @gNatHeight)
					Debug "Menu size: " + Str(gNatWidth) + " x " + Str(gNatHeight)
				EndIf
			EndIf
			
		Case #PB_Event_Menu
			gEvMenu= EventMenu()
			Select gEvMenu
					
				Case #Pu1_Item11;                                            set item label (text) ...
					Debug "Change label on item " + #Pu1_Item11
					Menu_SetItemLabel(Menu_ItemID(gMenu, 0), "New (clicked)")
						
				Case #Pu1_Item14;                                            disabling/enabling items ...
					Debug "Disable/able 'Print'-item"
					If Menu_GetItemDisabled(Menu_ItemID(gMenu, 5))
						Menu_SetItemDisabled(Menu_ItemID(gMenu, 5), #False)
					Else
						Menu_SetItemDisabled(Menu_ItemID(gMenu, 5), #True)
					EndIf
					
				Case #Pu1_Item16;                                            hiding/unhiding items ...
					If Menu_GetItemInvisible(Menu_ItemID(gMenu, 10))
						If Menu_GetItemChecked(Menu_ItemID(gMenu, 9))
							SetMenuItemState(#Pu1, #Pu1_Item16, #False);           'checked' only with PB-function -> else endless loop!!!
							Debug "Unhide following items + '" + GetMenuItemText(#Pu1, gEvMenu) + "' unchecked"
						EndIf
						Menu_SetItemInvisible(Menu_ItemID(gMenu, 10), #False)
						Menu_SetItemInvisible(Menu_ItemID(gMenu, 11), #False)
					Else
						If Not Menu_GetItemChecked(Menu_ItemID(gMenu, 9))
							SetMenuItemState(#Pu1, #Pu1_Item16, #True)
							Debug "Hide following items + '" + GetMenuItemText(#Pu1, gEvMenu) + "' checked"
						EndIf
						Menu_SetItemInvisible(Menu_ItemID(gMenu, 10), #True)
						Menu_SetItemInvisible(Menu_ItemID(gMenu, 11), #True)
					EndIf
					
				Default
; 					Debug "Selected: " + GetMenuItemText(#Pu1, gEvMenu)
					
			EndSelect
			
	EndSelect
	
Until gQuit

DataSection
	;Choose your pathes and pics here ...
	Img1:  : IncludeBinary "/usr/share/icons/gnome/16x16/actions/application-exit.png"
EndDataSection
; IDE Options = PureBasic 5.42 LTS (Linux - x86)
; CursorPosition = 8
; Folding = +----
; Markers = 263,267
; EnableUnicode
; EnableXP