﻿; Module/File:     CharCheck&Convert.pb
; Function:        Check for Characters, Digits and Umlauts + Caseconversion - Linux
; Author:          Omi
; Date:            Mar. 17, 2015
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	g_object_set_double(*Object, Property.p-ascii, Value.D, Null) As "g_object_set"
	gtk_tree_view_column_set_alignment(*tree_column, xalign.f)
	gtk_cell_layout_get_cells(*cell_layout)
EndImport

; Object constants
#MainWin  = 0
#TG       = 0
#LIG      = 1 

#WinX=300
#WinY=200
#WinW=800
#WinH=400

Global.i gEvent, gQuit, gI
Global.s gTestString= "azAZ "+#TAB$+"09äÄß_-.,;éÉêÊőŐåÅëËσΣηΗгГдД"

Procedure SetListIconColumnFormat(Gadget, Colmn, Alignment.d)
	Protected *Column, *CellRenderers
	Protected.l Count, Index
	
	*Column = gtk_tree_view_get_column_(GadgetID(Gadget), Colmn) 
	If *Column
		gtk_tree_view_column_set_alignment(*Column, Alignment);               title-alignment - fixed with ImportC
		
		*CellRenderers = gtk_cell_layout_get_cells(*Column); replaces 'gtk_tree_view_column_get_cell_renderers_()'
		If *CellRenderers
			Count = g_list_length_(*CellRenderers);                             number of columns
			For Index = 0 To Count-1
				g_object_set_double(g_list_nth_data_(*CellRenderers, Index), "xalign", Alignment, #Null)
			Next Index         
			g_list_free_(*CellRenderers)
		EndIf
		gtk_widget_queue_draw_(GadgetID(Gadget));                             force Redraw
	EndIf
EndProcedure

Procedure Resize_Window()
	ResizeGadget(#LIG, #PB_Ignore, #PB_Ignore, WindowWidth(#MainWin)- 10, WindowHeight(#MainWin)- 35)
EndProcedure

Procedure FillTable(S.s)
	Protected.i I, Line= 0, SLen= Len(S)
	Protected.c C
	
	For I= 1 To SLen
		SetGadgetItemText(#LIG, Line, Str(isalpha_(Asc(Mid(S, I, 1)))), I)
	Next I
	Line+ 1
	For I= 1 To SLen
		SetGadgetItemText(#LIG, Line, Str(isdigit_(Asc(Mid(S, I, 1)))), I)
	Next I
	Line+ 1
	For I= 1 To SLen
		SetGadgetItemText(#LIG, Line, Str(isascii_(Asc(Mid(S, I, 1)))), I)
	Next I
	Line+ 1
	For I= 1 To SLen
		SetGadgetItemText(#LIG, Line, Str(isalnum_(Asc(Mid(S, I, 1)))), I)
	Next I
	Line+ 1
	For I= 1 To SLen
		SetGadgetItemText(#LIG, Line, Str(isblank_(Asc(Mid(S, I, 1)))), I)
	Next I
	Line+ 1
	For I= 1 To SLen
		SetGadgetItemText(#LIG, Line, Str(isspace_(Asc(Mid(S, I, 1)))), I)
	Next I
	Line+ 1
	For I= 1 To SLen
		SetGadgetItemText(#LIG, Line, Str(ispunct_(Asc(Mid(S, I, 1)))), I)
	Next I
	Line+ 1
	For I= 1 To SLen
		SetGadgetItemText(#LIG, Line, Str(iscntrl_(Asc(Mid(S, I, 1)))), I)
	Next I
	Line+ 1
	For I= 1 To SLen
		SetGadgetItemText(#LIG, Line, Str(isupper_(Asc(Mid(S, I, 1)))), I)
	Next I
	Line+ 1
	For I= 1 To SLen
		SetGadgetItemText(#LIG, Line, Str(islower_(Asc(Mid(S, I, 1)))), I)
	Next I
	Line+ 1
	For I= 1 To SLen
		SetGadgetItemText(#LIG, Line, Chr(toupper_(Asc(Mid(S, I, 1)))), I)
	Next I
	Line+ 1
	For I= 1 To SLen
		SetGadgetItemText(#LIG, Line, Chr(tolower_(Asc(Mid(S, I, 1)))), I)
	Next I
	Line+ 2
	
	For I= 1 To SLen
		SetGadgetItemText(#LIG, Line, Str(iswalpha_(Asc(Mid(S, I, 1)))), I)
	Next I
	Line+ 1
	For I= 1 To SLen
		SetGadgetItemText(#LIG, Line, Str(iswdigit_(Asc(Mid(S, I, 1)))), I)
	Next I
	Line+ 1
	For I= 1 To SLen
		SetGadgetItemText(#LIG, Line, Str(iswalnum_(Asc(Mid(S, I, 1)))), I)
	Next I
	Line+ 1
	For I= 1 To SLen
		SetGadgetItemText(#LIG, Line, Str(iswblank_(Asc(Mid(S, I, 1)))), I)
	Next I
	Line+ 1
	For I= 1 To SLen
		SetGadgetItemText(#LIG, Line, Str(iswspace_(Asc(Mid(S, I, 1)))), I)
	Next I
	Line+ 1
	For I= 1 To SLen
		SetGadgetItemText(#LIG, Line, Str(iswpunct_(Asc(Mid(S, I, 1)))), I)
	Next I
	Line+ 1
	For I= 1 To SLen
		SetGadgetItemText(#LIG, Line, Str(iswcntrl_(Asc(Mid(S, I, 1)))), I)
	Next I
	Line+ 1
	For I= 1 To SLen
		SetGadgetItemText(#LIG, Line, Str(iswupper_(Asc(Mid(S, I, 1)))), I)
	Next I
	Line+ 1
	For I= 1 To SLen
		SetGadgetItemText(#LIG, Line, Str(iswlower_(Asc(Mid(S, I, 1)))), I)
	Next I
	Line+ 1
	For I= 1 To SLen
		SetGadgetItemText(#LIG, Line, Chr(towupper_(Asc(Mid(S, I, 1)))), I)
	Next I
	Line+ 1
	For I= 1 To SLen
		SetGadgetItemText(#LIG, Line, Chr(towlower_(Asc(Mid(S, I, 1)))), I)
	Next I
	
EndProcedure

If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "Usefull Linux-API char-functions (sample)", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_SizeGadget)
	TextGadget(#TG, 5, 5, 630, 22, "Unicode-Executable: " + #PB_Compiler_Unicode)
	ListIconGadget(#LIG, 5, 30, 790, 365, "Linux-Functions", 100, #PB_ListIcon_GridLines)
	SetListIconColumnFormat(#LIG, 0, 1.0)
	For gI= 1 To Len(gTestString)
		If Mid(gTestString, gI, 1)= " "
			AddGadgetColumn(#LIG, gI, "' '", 40)
		ElseIf Mid(gTestString, gI, 1)= #TAB$
			AddGadgetColumn(#LIG, gI, "[tab]", 40)
		Else
			AddGadgetColumn(#LIG, gI, Mid(gTestString, gI, 1), 40)
		EndIf
		SetListIconColumnFormat(#LIG, gI, 0.5)
	Next gI
	
	AddGadgetItem(#LIG, -1, "isalpha()")  : SetGadgetItemColor(#LIG, CountGadgetItems(#LIG)-1, #PB_Gadget_BackColor, $F0F0F0, 0)
	AddGadgetItem(#LIG, -1, "isdigit()")  : SetGadgetItemColor(#LIG, CountGadgetItems(#LIG)-1, #PB_Gadget_BackColor, $F0F0F0, 0)
	AddGadgetItem(#LIG, -1, "isascii()")  : SetGadgetItemColor(#LIG, CountGadgetItems(#LIG)-1, #PB_Gadget_BackColor, $F0F0F0, 0)
	AddGadgetItem(#LIG, -1, "isalnum()")  : SetGadgetItemColor(#LIG, CountGadgetItems(#LIG)-1, #PB_Gadget_BackColor, $F0F0F0, 0)
	AddGadgetItem(#LIG, -1, "isblank()")  : SetGadgetItemColor(#LIG, CountGadgetItems(#LIG)-1, #PB_Gadget_BackColor, $F0F0F0, 0)
	AddGadgetItem(#LIG, -1, "isspace()")  : SetGadgetItemColor(#LIG, CountGadgetItems(#LIG)-1, #PB_Gadget_BackColor, $F0F0F0, 0)
	AddGadgetItem(#LIG, -1, "ispunct()")  : SetGadgetItemColor(#LIG, CountGadgetItems(#LIG)-1, #PB_Gadget_BackColor, $F0F0F0, 0)
	AddGadgetItem(#LIG, -1, "iscntrl()")  : SetGadgetItemColor(#LIG, CountGadgetItems(#LIG)-1, #PB_Gadget_BackColor, $F0F0F0, 0)
	AddGadgetItem(#LIG, -1, "isupper()")  : SetGadgetItemColor(#LIG, CountGadgetItems(#LIG)-1, #PB_Gadget_BackColor, $F0F0F0, 0)
	AddGadgetItem(#LIG, -1, "islower()")  : SetGadgetItemColor(#LIG, CountGadgetItems(#LIG)-1, #PB_Gadget_BackColor, $F0F0F0, 0)
	AddGadgetItem(#LIG, -1, "toupper()")  : SetGadgetItemColor(#LIG, CountGadgetItems(#LIG)-1, #PB_Gadget_BackColor, $F0F0F0, 0)
	AddGadgetItem(#LIG, -1, "tolower()")  : SetGadgetItemColor(#LIG, CountGadgetItems(#LIG)-1, #PB_Gadget_BackColor, $F0F0F0, 0)
	AddGadgetItem(#LIG, -1, "---------")
	AddGadgetItem(#LIG, -1, "iswalpha()") : SetGadgetItemColor(#LIG, CountGadgetItems(#LIG)-1, #PB_Gadget_BackColor, $F0F0F0, 0)
	AddGadgetItem(#LIG, -1, "iswdigit()") : SetGadgetItemColor(#LIG, CountGadgetItems(#LIG)-1, #PB_Gadget_BackColor, $F0F0F0, 0)
	AddGadgetItem(#LIG, -1, "iswalnum()") : SetGadgetItemColor(#LIG, CountGadgetItems(#LIG)-1, #PB_Gadget_BackColor, $F0F0F0, 0)
	AddGadgetItem(#LIG, -1, "iswblank()") : SetGadgetItemColor(#LIG, CountGadgetItems(#LIG)-1, #PB_Gadget_BackColor, $F0F0F0, 0)
	AddGadgetItem(#LIG, -1, "iswspace()") : SetGadgetItemColor(#LIG, CountGadgetItems(#LIG)-1, #PB_Gadget_BackColor, $F0F0F0, 0)
	AddGadgetItem(#LIG, -1, "iswpunct()") : SetGadgetItemColor(#LIG, CountGadgetItems(#LIG)-1, #PB_Gadget_BackColor, $F0F0F0, 0)
	AddGadgetItem(#LIG, -1, "iswcntrl()") : SetGadgetItemColor(#LIG, CountGadgetItems(#LIG)-1, #PB_Gadget_BackColor, $F0F0F0, 0)
	AddGadgetItem(#LIG, -1, "iswupper()") : SetGadgetItemColor(#LIG, CountGadgetItems(#LIG)-1, #PB_Gadget_BackColor, $F0F0F0, 0)
	AddGadgetItem(#LIG, -1, "iswlower()") : SetGadgetItemColor(#LIG, CountGadgetItems(#LIG)-1, #PB_Gadget_BackColor, $F0F0F0, 0)
	AddGadgetItem(#LIG, -1, "towupper()") : SetGadgetItemColor(#LIG, CountGadgetItems(#LIG)-1, #PB_Gadget_BackColor, $F0F0F0, 0)
	AddGadgetItem(#LIG, -1, "towlower()") : SetGadgetItemColor(#LIG, CountGadgetItems(#LIG)-1, #PB_Gadget_BackColor, $F0F0F0, 0)
	
	gtk_tree_selection_set_mode_(gtk_tree_view_get_selection_(GadgetID(#LIG)), #GTK_SELECTION_NONE)
	FillTable(gTestString)
	
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
				
			Case #PB_Event_SizeWindow
				Resize_Window()
				
			Case #PB_Event_Gadget
				
		EndSelect
		
	Until gQuit
EndIf
; IDE Options = PureBasic 5.40 LTS (Linux - x86)
; CursorPosition = 16
; FirstLine = 22
; Folding = -
; EnableUnicode
; EnableXP