﻿; Module/File:     File_GetSymLink.pb
; Function:        Get a symbolic link or 0-pointer - Linux
; Author:          Omi
; Date:            Sep. 08, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------
;example from my system:
;"/usr/share/icons/default.kde4/16x16/actions/im-skype.png";        is link
;"/usr/share/icons/default.kde4/16x16/actions/zoom-select.png";     is file
;/dev/cdrom                                                         is link

EnableExplicit

ImportC ""
	g_file_read_link(filename.p-utf8, *error)
EndImport

; Object constants
#MainWin  = 0
#Button1  = 0

#WinX=300
#WinY=200
#WinW=300
#WinH=100

Global.l gEvent, gQuit, Link
Global.s Filename, LastPath= "/usr/share/icons/default.kde4/16x16/apps/kde.png"
Global *error

Procedure FileExist(FN$)
	Protected.i Ret= #True
	If FileSize(FN$)= < 0
		Ret=#False
	EndIf
	ProcedureReturn Ret
EndProcedure


If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "Get link", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	ButtonGadget(#Button1, 5, 5, 150, 26, "Choose File to check ...")
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
			Case #PB_Event_Gadget
				If EventGadget()= #Button1
					Filename= OpenFileRequester("Choose file or link to check ...", LastPath, "Alle Dateien (*.*)|*.*", 0)
					If FileExist(Filename)
						If GetFileAttributes(Filename) & #PB_FileSystem_Link;    is link?
							*error= 0;                                             must be 0 for call
							Link= g_file_read_link(Filename, @*error);            get pointer to string
							If Link;                                               0 if it's no link
								Debug "link to: " + PeekS(Link, -1, #PB_UTF8);                     read target-path
							EndIf
							LastPath= GetPathPart(Filename)
						Else
							Debug "no link"
						EndIf
					EndIf
				EndIf
		EndSelect
		
	Until gQuit
EndIf
; IDE Options = PureBasic 5.40 LTS Beta 9 (Linux - x86)
; CursorPosition = 5
; Folding = -
; EnableUnicode
; EnableXP