﻿; Module/File:     Keys_GetData.pb
; Function:        Get key and shift - Linux
; Author:          Omi
; Date:            Dec. 18, 2014
; Version:         0.2
; Target Compiler: PureBasic 5.22/5.31
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

;Shift-States: Bit (depends on installation)
; 0 = [Shift]
; 1 = [CapsLock]
; 2 = [Control]
; 3 = [Alt]
; 4 = [NumLock]
; 5 = 
; 6 = 
; 7 = [AltGr]
; 8 =
;
;26 = [Menue]

EnableExplicit

#MainWin= 0

ImportC ""
  g_signal_connect(*instance, detailed_signal.p-ascii, *c_handler, *data, destroy= 0, flags= 0) As "g_signal_connect_data"
EndImport


Global.i gEvent

ProcedureC KeyPressCallback(*widget, *event.GdkEventKey, *udata)
	Protected.i I, State, Pressed
	Protected.a KeyAsc
	Protected.l KeyWord
	Protected.s StateKeys, StateNames= "[Shift] [CapsLock] [Control] [Alt] [NumLock] [] [] [AltGr]"
	
	Pressed= *event\type
	KeyAsc = *event\keyval & $FF
	KeyWord= *event\keyval & $FFFF
	State  = *event\state
	For I= 0 To 7
		If (State >> I) & 1
			StateKeys+ StringField(StateNames, I+ 1, " ")
		EndIf
	Next I
	If KeyWord & $8000
		StateKeys+ "[Numberpad]"
		;(1) auch Bit 7 von KeyAsc gesetzt => ausblenden KeyAsc & $7F
	EndIf
	
	Debug #DOUBLEQUOTE$ + PeekS(*event\string, -1, #PB_UTF8	) + #DOUBLEQUOTE$ + " = BYTE (ASC): " + Str(KeyAsc) + "/" + Str(KeyAsc & $7F) + ", WORD: " + Str(KeyWord)
	Debug "State: " + Str(State) + " = " + StateKeys
	;Debug "Pressed: " + Str(Pressed)
	Debug ""
EndProcedure

If OpenWindow(#MainWin, #PB_Any, #PB_Any, 200, 100, "keyPress to debug")
	g_signal_connect(WindowID(#MainWin), "key_press_event", @KeyPressCallback(), #Null)

	Repeat
		gEvent = WaitWindowEvent()
	
	Until gEvent = #PB_Event_CloseWindow
EndIf
; IDE Options = PureBasic 5.40 LTS Beta 9 (Linux - x86)
; CursorPosition = 53
; FirstLine = 21
; Folding = -
; EnableUnicode
; EnableXP
; Executable = ../../ImageViewer/LinuxPbSystemIconViewer