﻿; Module/File:     RecentFilesSystem_Access.pb
; Function:        Misc system RecentFiles functions - Linux
; Author:          Omi
; Date:            Nov. 17, 2015
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gtk_recent_manager_get_default()
	gtk_recent_manager_get_items(*manager)
	gtk_recent_info_get_display_name(*info)
	gtk_recent_info_get_short_name(*info)
	gtk_recent_info_get_description(*info)
	gtk_recent_info_get_mime_type(*info)
	gtk_recent_info_last_application(*info)
	gtk_recent_info_get_uri_display(*info)
	gtk_recent_info_is_local(*info)
	gtk_recent_info_get_private_hint(*info)
	gtk_recent_info_get_age(*info)
	gtk_recent_info_get_added.q(*info)
	gtk_recent_info_get_modified.q(*info)
	gtk_recent_info_get_visited.q(*info)
	gtk_recent_info_unref(*info)
EndImport

; Object constants
#Win_Main = 0


Global.i gEvent, gQuit
Global   *gRecentManager

Procedure RecentFilesList()
	Protected *RecentManager= gtk_recent_manager_get_default()
	Protected *gList.GList  = gtk_recent_manager_get_items(*RecentManager)
	Protected *RecentInfo, *ptr
	
		If *gList
		Repeat
			*RecentInfo= *gList\data
			Debug "Display_name: " + PeekS(gtk_recent_info_get_display_name(*RecentInfo), -1, #PB_UTF8)
			
			*ptr= gtk_recent_info_get_short_name(*RecentInfo)
			If *ptr
				Debug "Short_name: " + PeekS(*ptr, -1, #PB_UTF8)
			EndIf
			
			*ptr= gtk_recent_info_get_uri_display(*RecentInfo)
			If *ptr
				Debug "Uri_display: " + PeekS(*ptr, -1, #PB_UTF8)
			EndIf
			
			*ptr= gtk_recent_info_get_description(*RecentInfo)
			If *ptr
				Debug "Description: " + PeekS(*ptr, -1, #PB_UTF8)
			EndIf
			
			*ptr= gtk_recent_info_get_mime_type(*RecentInfo)
			If *ptr
				Debug "Mime_type: " + PeekS(*ptr, -1, #PB_UTF8)
			EndIf
			Debug "Added: " + FormatDate("%dd.%mm.%yyyy %hh:%ii:%ss", gtk_recent_info_get_added(*RecentInfo))
			
			Debug "Modified: " + FormatDate("%dd.%mm.%yyyy %hh:%ii:%ss", gtk_recent_info_get_modified(*RecentInfo))
			
			Debug "Visited: " + FormatDate("%dd.%mm.%yyyy %hh:%ii:%ss", gtk_recent_info_get_visited(*RecentInfo))
			
			*ptr= gtk_recent_info_last_application(*RecentInfo)
			If *ptr
				Debug "Last App: " + PeekS(*ptr, -1, #PB_UTF8)
			EndIf
			
			Debug "Is local: " + Str(gtk_recent_info_is_local(*RecentInfo))
			
			Debug "Age (days): " + Str(gtk_recent_info_get_age(*RecentInfo))
			
			Debug "Private hint: " + Str(gtk_recent_info_get_private_hint(*RecentInfo))
			
			Debug " ---"
			
			*gList= *gList\next
			gtk_recent_info_unref(*RecentInfo)
		Until *gList = 0
	EndIf
	g_list_free_(*gList);      free list
EndProcedure

If OpenWindow(#Win_Main, 0, 0, 400, 300, "Window", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	
	RecentFilesList()
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
				
			Case #PB_Event_CloseWindow
				gQuit= #True
				
		EndSelect
		
	Until gQuit
	
EndIf
; IDE Options = PureBasic 5.40 LTS (Linux - x86)
; CursorPosition = 7
; Folding = -
; EnableUnicode
; EnableXP