﻿; Module/File:     Screenshot_MonitorGtk3.pb
; Function:        Screenshot from monitor with number - Linux gtk3
; Author:          Omi
; Date:            May 16, 2016
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.4x
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gdk_pixbuf_get_from_window(*window, src_x, src_y, width, height)
	gdk_window_get_width(*window)
	gdk_window_get_height(*window)
	gdk_pixbuf_save(*pixbuf, filename.p-utf8, type.p-utf8, *err.GError, null= 0)
	
	gdk_screen_get_monitor_plug_name(*screen.GdkScreen, monitor_num);   not necessary
EndImport

; Object constants
#Win_Main  = 0

#CbG = 0
#BtG = 1

Global.i gEvent, gQuit
Global.i gMonitors

Procedure Pixbuf_Save(*pixbuf)
	Protected   *err.GError
	Protected.s File= SaveFileRequester("Please choose file to save", GetCurrentDirectory(), "Image (*.png)|*.png", 0)
	If File <> ""
		gdk_pixbuf_save(*pixbuf, File, "png", @*err)
	Else
		MessageRequester("", "Screenshot isn't stored!")
	EndIf
EndProcedure

Procedure Monitor_GetScreenshot(nthMonitor)
	Protected *pixbuf
	Protected rect.GdkRectangle
	
	;Gdk inner size ...
	gdk_screen_get_monitor_geometry_(gdk_screen_get_default_(), nthMonitor, @rect)
	*pixbuf= gdk_pixbuf_get_from_window(gdk_get_default_root_window_(), rect\x, rect\y, rect\width, rect\height)
	
	If *pixbuf
		Pixbuf_Save(*pixbuf)
		g_object_unref_(*pixbuf)
	EndIf
EndProcedure

Procedure Create_WinMain()
	Protected.i I
	
	If OpenWindow(#Win_Main, 300, 200, 400, 100, "Screenshot of nthMonitor ", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
		TextGadget    (#PB_Any,   5,  9,  85, 22, "Monitor num: ")
		ComboBoxGadget(#CbG,    100,  5, 150, 30)
		ButtonGadget  (#BtG,      5, 40, 300, 26, "Screenshot from selected monitor")
		
		gMonitors= gdk_screen_get_n_monitors_(gdk_screen_get_default_());         number of monitors
		For I= 0 To gMonitors-1
			AddGadgetItem(#CbG, I, Str(I) + #TAB$ + PeekS(gdk_screen_get_monitor_plug_name(gdk_screen_get_default_(), I), -1, #PB_UTF8))
		Next I
		SetGadgetState(#CbG, 0)
	EndIf
EndProcedure

Create_WinMain()

Repeat
	gEvent= WaitWindowEvent()
	
	Select gEvent
			
		Case #PB_Event_CloseWindow
			gQuit= #True
			
		Case #PB_Event_Gadget
			
			Select EventGadget()
					
				Case #BtG
					Monitor_GetScreenshot(GetGadgetState(#CbG))
					
			EndSelect
			
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.42 LTS (Linux - x86)
; Folding = -
; EnableUnicode
; EnableXP