﻿; Module/File:     Screenshot_ScreenGdk3.pb
; Function:        Screenshot from own current screen - Linux gtk3
; Author:          Omi
; Date:            May 16, 2016
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.4x
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gdk_pixbuf_get_from_window(*window, src_x, src_y, width, height)
	gdk_window_get_width(*window)
	gdk_window_get_height(*window)
	gdk_pixbuf_save(*pixbuf, filename.p-utf8, type.p-utf8, *err.GError, null= 0)
EndImport

; Object constants
#Win_Main  = 0


Global.i gEvent, gQuit

Procedure Pixbuf_Save(*pixbuf)
	Protected   *err.GError
	Protected.s File= SaveFileRequester("Please choose file to save", GetCurrentDirectory(), "Image (*.png)|*.png", 0)
	
	If File <> ""
		gdk_pixbuf_save(*pixbuf, File, "png", @*err)
	Else
		MessageRequester("", "Screenshot isn't stored!")
	EndIf
EndProcedure

Procedure Screen_GetScreenshot()
	Protected   *pixbuf
	Protected   *GdkWindow= gdk_get_default_root_window_()
	Protected.i wX, wY, wWidth, wHeight
	
	;Gdk inner size ...
	wWidth = gdk_window_get_width(*GdkWindow)
	wHeight= gdk_window_get_height(*GdkWindow)
	gdk_window_get_origin_(*GdkWindow, @wX, @wY)
	*pixbuf= gdk_pixbuf_get_from_window(gdk_get_default_root_window_(), wX, wY, wWidth, wHeight)
	
	If *pixbuf
		Pixbuf_Save(*pixbuf)
		g_object_unref_(*pixbuf)
	EndIf
EndProcedure

Procedure Create_WinMain()
	If OpenWindow(#Win_Main, 300, 200, 400, 100, "Screen screenshot", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
		ButtonGadget(0, 5,  5, 250, 26, "Screenshot from whole screen")
	EndIf
EndProcedure

Create_WinMain()

Repeat
	gEvent= WaitWindowEvent()
	
	Select gEvent
			
		Case #PB_Event_CloseWindow
			gQuit= #True
			
		Case #PB_Event_Gadget
			
			Select EventGadget()
					
				Case 0
					Screen_GetScreenshot()
					
			EndSelect
			
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.42 LTS (Linux - x86)
; CursorPosition = 39
; FirstLine = 22
; Folding = -
; EnableUnicode
; EnableXP