﻿; Module/File:     System_KeyStateMonitor_Gdk.pb
; Function:        Monitoring 'state' keys with gdk  - Linux gtk3
; Author:          Omi
; Date:            Sep. 10, 2015
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gdk_keymap_get_caps_lock_state(*keymap.GdkKeymap)
	gdk_keymap_get_num_lock_state(*keymap.GdkKeymap);     gtk3
	gdk_keymap_get_modifier_state(*keymap.GdkKeymap);     gtk3 (3.4)
	g_signal_connect(*instance, detailed_signal.p-utf8, *c_handler, *pdata, destroy= 0, flags= 0) As "g_signal_connect_data"
EndImport

; Object constants
#Win_Main = 0
#Strg1    = 0

Global.i gEvent, gEventWin, gQuit

ProcedureC Callback_KeyboardStateChange(*keymap.GdkKeymap, user_data)
	Debug "CapsLock      : " + Str(gdk_keymap_get_caps_lock_state(*keymap))
	Debug "NumLock       : " + Str(gdk_keymap_get_num_lock_state(*keymap))
	Debug "Modifier State: " + Str(gdk_keymap_get_modifier_state(*keymap))
	Debug " ---"
EndProcedure


If OpenWindow(#Win_Main, -1, -1, 400, 100, "Monitoring state keys", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	StringGadget(#Strg1, 5, 5, 390, 26, "press Caps-, NumLock, Shift, Ctrl, Alt (Gr), Super")
	
	g_signal_connect(gdk_keymap_get_default_(), "state-changed", @Callback_KeyboardStateChange(), 0)
	
	Repeat
		gEvent= WaitWindowEvent()
		gEventWin= EventWindow()
		
		If gEventWin = #Win_Main
			
			Select gEvent
					
				Case #PB_Event_CloseWindow
					gQuit= #True
					
			EndSelect
			
		EndIf
		
	Until gQuit
	
EndIf
; IDE Options = PureBasic 5.40 LTS Beta 9 (Linux - x86)
; CursorPosition = 8
; Folding = -
; EnableUnicode
; EnableXP