﻿; Module/File:     OptionGadget_GetGroupSelectionPBId.pb
; Function:        Get selected OptionGadget-PureBasic-Id in group - Linux
; Author:          Omi
; Date:            Nov. 19, 2016 ☑
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.4x
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	atk_object_get_role(*accessible)
	atk_object_get_description(*accessible)
	atk_object_set_description(*accessible, description.p-utf8)
EndImport

; Object constants
#Win_Main  = 0

Global.i gEvent,  gQuit
Global.i gEventGadget

Enumeration
	#OpG1
	#OpG2
	#OpG3
	#OpG4
	#OpG5
	#OpG6
EndEnumeration

Enumeration AtkRole
; 	#ATK_ROLE_INVALID
; 	#ATK_ROLE_ACCEL_LABEL;      /*<nick=accelerator-label>*/
; 	#ATK_ROLE_ALERT
; 	#ATK_ROLE_ANIMATION
; 	#ATK_ROLE_ARROW
; 	#ATK_ROLE_CALENDAR
; 	#ATK_ROLE_CANVAS
; 	#ATK_ROLE_CHECK_BOX
; 	#ATK_ROLE_CHECK_MENU_ITEM
; 	#ATK_ROLE_COLOR_CHOOSER
; 	#ATK_ROLE_COLUMN_HEADER
; 	#ATK_ROLE_COMBO_BOX
; 	#ATK_ROLE_DATE_EDITOR
; 	#ATK_ROLE_DESKTOP_ICON
; 	#ATK_ROLE_DESKTOP_FRAME
; 	#ATK_ROLE_DIAL
; 	#ATK_ROLE_DIALOG
; 	#ATK_ROLE_DIRECTORY_PANE
; 	#ATK_ROLE_DRAWING_AREA
; 	#ATK_ROLE_FILE_CHOOSER
; 	#ATK_ROLE_FILLER
; 	#ATK_ROLE_FONT_CHOOSER
; 	#ATK_ROLE_FRAME
; 	#ATK_ROLE_GLASS_PANE
; 	#ATK_ROLE_HTML_CONTAINER
; 	#ATK_ROLE_ICON
; 	#ATK_ROLE_IMAGE
; 	#ATK_ROLE_INTERNAL_FRAME
; 	#ATK_ROLE_LABEL
; 	#ATK_ROLE_LAYERED_PANE
; 	#ATK_ROLE_LIST
; 	#ATK_ROLE_LIST_ITEM
; 	#ATK_ROLE_MENU
; 	#ATK_ROLE_MENU_BAR
; 	#ATK_ROLE_MENU_ITEM
; 	#ATK_ROLE_OPTION_PANE
; 	#ATK_ROLE_PAGE_TAB
; 	#ATK_ROLE_PAGE_TAB_LIST
; 	#ATK_ROLE_PANEL
; 	#ATK_ROLE_PASSWORD_TEXT
; 	#ATK_ROLE_POPUP_MENU
; 	#ATK_ROLE_PROGRESS_BAR
; 	#ATK_ROLE_PUSH_BUTTON
	#ATK_ROLE_RADIO_BUTTON           = 43
; 	#ATK_ROLE_RADIO_MENU_ITEM
; 	#ATK_ROLE_ROOT_PANE
; 	#ATK_ROLE_ROW_HEADER
; 	#ATK_ROLE_SCROLL_BAR
; 	#ATK_ROLE_SCROLL_PANE
; 	#ATK_ROLE_SEPARATOR
; 	#ATK_ROLE_SLIDER
; 	#ATK_ROLE_SPLIT_PANE
; 	#ATK_ROLE_SPIN_BUTTON
; 	#ATK_ROLE_STATUSBAR
; 	#ATK_ROLE_TABLE
; 	#ATK_ROLE_TABLE_CELL
; 	#ATK_ROLE_TABLE_COLUMN_HEADER
; 	#ATK_ROLE_TABLE_ROW_HEADER
; 	#ATK_ROLE_TEAR_OFF_MENU_ITEM
; 	#ATK_ROLE_TERMINAL
; 	#ATK_ROLE_TEXT
; 	#ATK_ROLE_TOGGLE_BUTTON
; 	#ATK_ROLE_TOOL_BAR
; 	#ATK_ROLE_TOOL_TIP
; 	#ATK_ROLE_TREE
; 	#ATK_ROLE_TREE_TABLE
; 	#ATK_ROLE_UNKNOWN
; 	#ATK_ROLE_VIEWPORT
; 	#ATK_ROLE_WINDOW
; 	#ATK_ROLE_HEADER
; 	#ATK_ROLE_FOOTER
; 	#ATK_ROLE_PARAGRAPH
; 	#ATK_ROLE_RULER
; 	#ATK_ROLE_APPLICATION
; 	#ATK_ROLE_AUTOCOMPLETE
; 	#ATK_ROLE_EDITBAR;          /*<nick=edit-bar>*/
; 	#ATK_ROLE_EMBEDDED
; 	#ATK_ROLE_ENTRY
; 	#ATK_ROLE_CHART
; 	#ATK_ROLE_CAPTION
; 	#ATK_ROLE_DOCUMENT_FRAME
; 	#ATK_ROLE_HEADING
; 	#ATK_ROLE_PAGE
; 	#ATK_ROLE_SECTION
; 	#ATK_ROLE_REDUNDANT_OBJECT
; 	#ATK_ROLE_FORM
; 	#ATK_ROLE_LINK
; 	#ATK_ROLE_INPUT_METHOD_WINDOW
; 	#ATK_ROLE_TABLE_ROW
; 	#ATK_ROLE_TREE_ITEM
; 	#ATK_ROLE_DOCUMENT_SPREADSHEET
; 	#ATK_ROLE_DOCUMENT_PRESENTATION
; 	#ATK_ROLE_DOCUMENT_TEXT
; 	#ATK_ROLE_DOCUMENT_WEB
; 	#ATK_ROLE_DOCUMENT_EMAIL
; 	#ATK_ROLE_COMMENT
; 	#ATK_ROLE_LIST_BOX
; 	#ATK_ROLE_GROUPING
; 	#ATK_ROLE_IMAGE_MAP
; 	#ATK_ROLE_NOTIFICATION
; 	#ATK_ROLE_INFO_BAR
; 	#ATK_ROLE_LEVEL_BAR
; 	#ATK_ROLE_LAST_DEFINED
EndEnumeration

Procedure OptionGadget_LinkPpId(Gadget)
	Protected AtkAccessible= gtk_widget_get_accessible_(GadgetID(Gadget))
	
	If AtkAccessible
		If atk_object_get_role(AtkAccessible) = #ATK_ROLE_RADIO_BUTTON
			atk_object_set_description(AtkAccessible, Str(Gadget));        store PB-Id in AtkDescription. Problematic ???
		Else
			Debug "PB-Id not saved! Not a #ATK_ROLE_RADIO_BUTTON."
		EndIf
	Else
		Debug "PB-Id not saved! Not a AtkAccessible."
	EndIf
EndProcedure

Procedure OptionGadget_GetGroup(Gadget)
	ProcedureReturn gtk_radio_button_get_group_(GadgetID(Gadget));     must not be freed!
EndProcedure

Procedure.i OptionGadget_GetGroupSelectionPBID(Gadget)
	Protected.i I, MemberId      = GadgetID(Gadget)
	Protected.i Active
	Protected   AtkAccessible, AtkDescription
	Protected   *gsList0.GList   = gtk_radio_button_get_group_(MemberId)
	Protected   *gsList.GList    = *gsList0, *widget.GtkWidget
	
	If *gsList
		Repeat
			*widget= *gsList\data
			If gtk_toggle_button_get_active_(*widget)
				AtkAccessible= gtk_widget_get_accessible_(*widget)
				If AtkAccessible
					AtkDescription= atk_object_get_description(AtkAccessible)
					If AtkDescription
						Active= Val(PeekS(AtkDescription, -1, #PB_UTF8))
					EndIf
				EndIf
			EndIf
			*gsList= *gsList\next
		Until *gsList = 0;                                               must not be freed!
	EndIf
	ProcedureReturn Active
EndProcedure

Procedure Create_WinMain()
	If OpenWindow(#Win_Main, 300, 200, 400, 100, "OptionGadget (Selection from group)", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
		OptionGadget(#OpG1,   5,  5, 190, 26, "Choose me")   : OptionGadget_LinkPpId(#OpG1);    Also save the PB-IDs in widget-data
		OptionGadget(#OpG2,   5, 30, 190, 26, "or me")       : OptionGadget_LinkPpId(#OpG2)
		OptionGadget(#OpG3,   5, 55, 190, 26, "or maybe me") : OptionGadget_LinkPpId(#OpG3)
		TextGadget  (#PB_Any, 0,  0,  10, 22, "");                       pseudo - for new RadioButtonGroup ...
		OptionGadget(#OpG4, 205,  5, 190, 26, "Click me")    : OptionGadget_LinkPpId(#OpG4)
		OptionGadget(#OpG5, 205, 30, 190, 26, "or click me") : OptionGadget_LinkPpId(#OpG5)
		OptionGadget(#OpG6, 205, 55, 190, 26, "me, me, me")  : OptionGadget_LinkPpId(#OpG6)
	EndIf
EndProcedure

Create_WinMain()

Repeat
	gEvent= WaitWindowEvent()
	
	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
			
		Case #PB_Event_Gadget
			gEventGadget= EventGadget()
			Debug "Selected OptionGadget-(RadioButton-) " + Str(gEventGadget)
			Debug " is in group         : " + Str(OptionGadget_GetGroup(gEventGadget))
			Debug " active (PB-ID)      : " + Str(OptionGadget_GetGroupSelectionPBID(gEventGadget))
			Debug "---"
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.42 LTS (Linux - x86)
; Folding = -
; EnableUnicode
; EnableXP