﻿; Module/File:     Panel_SetSystemIcon.pb
; Function:        Set system icon on PanelGadget tabs (empty place, till it's fixed) - Linux gtk2/gtk3
; Author:          Omi
; Date:            Dec. 16, 2016 ☑
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.4x
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gtk_icon_theme_load_icon(*icon_theme.GtkIconTheme, icon_name.p-utf8, size, flags, *error.GError); gtk2.4
EndImport

Enumeration GtkIconLookupFlags
	#GTK_ICON_LOOKUP_ALL              = 0; Not gtk-defined, own constant to clearify
	#GTK_ICON_LOOKUP_NO_SVG           = 1
	#GTK_ICON_LOOKUP_FORCE_SVG        = 2
	#GTK_ICON_LOOKUP_USE_BUILTIN      = 4
	#GTK_ICON_LOOKUP_GENERIC_FALLBACK = 8
	#GTK_ICON_LOOKUP_FORCE_SIZE       = 16
EndEnumeration

; Object constants
#MainWin= 0

#Panel1 = 0

Global.i gEvent, gQuit
Global.i I, O, gRiders= 4
Global.s gTempStockImage
Global   *widget.GtkWidget, *hbox.GtkHBox
Global   *gList.GList

Procedure IconTheme_LoadIconFromName(icon_name.s, icon_size, flags)
	Protected *pixbuf
	Protected *error.GError
	
	*pixbuf= gtk_icon_theme_load_icon(gtk_icon_theme_get_default_(), icon_name, icon_size, flags, @*error)
	
	If *error : Debug icon_name + ": " + PeekS(*error\message, -1, #PB_UTF8) : EndIf
	ProcedureReturn *pixbuf
EndProcedure

If OpenWindow(#MainWin, 300, 200, 350, 290, "gtk3 PanelGadget: w. StockImages", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	PanelGadget(#Panel1, 0, 10, 350, 270)
	For I=0 To gRiders- 1
		AddGadgetItem(#Panel1, -1, " Tab "+Str(I))
		TextGadget(#PB_Any, 5, 5, 200, 20, "Panel "+Str(I))
	Next I
	
	gRiders= gtk_notebook_get_n_pages_(GadgetID(#Panel1))
	For I= 0 To gRiders- 1
		*widget= gtk_notebook_get_nth_page_(GadgetID(#Panel1), I);                   panel widget
		*hbox  = gtk_notebook_get_tab_label_(GadgetID(#Panel1), *widget);            hbox from tab for panel
		If *hbox
			*gList= gtk_container_get_children_(*hbox)
			For O= 1 To g_list_length_(*gList)
				If PeekS(gtk_widget_get_name_(g_list_nth_data_(*gList, O-1)), -1, #PB_UTF8) = "GtkImage"
					Select I
						Case 0  : gTempStockImage= "help-about"
						Case 1  : gTempStockImage= "document-print"
						Case 2  : gTempStockImage= "document-properties"
						Default : gTempStockImage= "help-browser"
					EndSelect
					gtk_image_set_from_pixbuf_(g_list_nth_data_(*gList, O-1), IconTheme_LoadIconFromName(gTempStockImage, 16, #GTK_ICON_LOOKUP_ALL))
				EndIf
			Next O
		EndIf
	Next I
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
		EndSelect
		
	Until gQuit
	
EndIf
; IDE Options = PureBasic 5.42 LTS (Linux - x64)
; CursorPosition = 44
; Folding = -
; EnableUnicode
; EnableXP