﻿; Module/File:     Panel_TabMenu.pb
; Function:        Add a popup-call-button to PanelGadget-Tab - Linux gtk2/gtk3
; Author:          Omi
; Date:            Jul. 09, 2016 ☑
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.4x
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

ImportC ""
	g_signal_connect(*instance, detailed_signal.p-utf8, *c_handler, *pdata, destroy= 0, flags= 0) As "g_signal_connect_data"
EndImport

EnableExplicit

; Object constants
#Win_Main= 0

#Panel1 = 0

;- - Popups
Enumeration
	#Popup1
	#PU_Item1
	#PU_Item2
	#PU_Item3
EndEnumeration

Global.i gEvent, gQuit
Global.i I, gNTabs= 4
Global.i gLastActionTab= -1
Global   *widget.GtkWidget, *hbox.GtkHBox, *button.GtkButton, *arrow.GtkWidget

CreatePopupMenu(#Popup1)
MenuItem(#PU_Item1, "Close tab")
MenuItem(#PU_Item2, "New tab")
MenuItem(#PU_Item3, "Save tab")


ProcedureC Callback_P1TabButton(*button, user_signal)
	Debug "Signal: Open popup " + Str(user_signal)
	gLastActionTab= user_signal
	DisplayPopupMenu(#Popup1, WindowID(#Win_Main))
EndProcedure


If OpenWindow(#Win_Main, 300, 200, 360, 310, "PanelGadget: w. MenuButton", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	PanelGadget(#Panel1, 0, 30, 360, 270)
	For I=0 To gNTabs- 1
		AddGadgetItem(#Panel1, -1, " Tab "+Str(I))
		TextGadget(#PB_Any, 5, 5, 200, 20, "Panel "+Str(I))
	Next I
	
	gNTabs= gtk_notebook_get_n_pages_(GadgetID(#Panel1))
	For i= 0 To gNTabs- 1
		*widget= gtk_notebook_get_nth_page_(GadgetID(#Panel1), I);                   panel widget
		*button= gtk_button_new_();                                                  create empty button
		*arrow = gtk_arrow_new_(#GTK_ARROW_DOWN, #GTK_SHADOW_OUT);                   create arrow down
		gtk_button_set_focus_on_click_(*button, #False);                             no focus indicator
		gtk_button_set_relief_(*button, #GTK_RELIEF_NONE);                           button frame off
		gtk_container_add_(*button, *arrow);                                         add arrow to button
		*hbox= gtk_notebook_get_tab_label_(GadgetID(#Panel1), *widget);              hbox from tab for panel
		gtk_box_pack_end_(*hbox, *button, #False, #False, 2);                        Add button at right tab side
		g_signal_connect (*button, "clicked", @Callback_P1TabButton(), I);           callback for click
		gtk_widget_show_all_(*hbox)
	Next I
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
				
			Case #PB_Event_Menu
				Select EventMenu()
					Case #PU_Item1
						Debug "Close for tab " + Str(gLastActionTab); global for demo
					Case #PU_Item2
						Debug "New from tab " + Str(gLastActionTab)
					Case #PU_Item3
						Debug "Save for tab " + Str(gLastActionTab)
				EndSelect
				
		EndSelect
		
	Until gQuit
	
EndIf

End  
; IDE Options = PureBasic 5.42 LTS (Linux - x86)
; CursorPosition = 8
; Folding = -
; EnableUnicode
; EnableXP