﻿; Module/File:     Printer_GtkAPI_Demo.pb
; Function:        Get gtk printer infos - Linux
; Author:          Omi
; Date:            Mar. 16, 2016
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------
;no installations required
; printer- and detail-infos queried in callback
;
;need pdf-printer-driver?
; sudo apt-get install cups-pdf

EnableExplicit

UsePNGImageDecoder()

ImportC ""
	g_signal_connect(*instance, detailed_signal.p-utf8, *c_handler, *pdata, destroy= 0, flags= 0) As "g_signal_connect_data"
	gtk_enumerate_printers(func, _data, destroy, wait)
	gtk_page_setup_get_bottom_margin.d(*setup, unit)
	gtk_page_setup_get_left_margin.d(*setup, unit)
	gtk_page_setup_get_orientation(*setup)
	gtk_page_setup_get_page_height.d(*setup, unit)
	gtk_page_setup_get_page_width.d(*setup, unit)
	gtk_page_setup_get_paper_height.d(*setup, unit)
	gtk_page_setup_get_paper_size(*setup)
	gtk_page_setup_get_paper_width.d(*setup, unit)
	gtk_page_setup_get_right_margin.d(*setup, unit)
	gtk_page_setup_get_top_margin.d(*setup, unit)
	
	gtk_print_operation_new()
	gtk_print_operation_get_print_settings(*op)
	gtk_print_operation_cancel(*op)
	gtk_print_settings_new()
	gtk_print_settings_get_printer(*settings)
	gtk_print_settings_get_orientation(*settings)
	gtk_print_settings_get_paper_size(*settings)
	gtk_print_settings_get_paper_width.d(*settings, unit)
	gtk_print_settings_get_paper_height.d(*settings, unit)
	gtk_print_settings_get_use_color(*settings)
	gtk_print_settings_get_collate(*settings)
	gtk_print_settings_get_reverse(*settings)
	gtk_print_settings_get_duplex(*settings)
	gtk_print_settings_get_quality(*settings)
	gtk_print_settings_get_n_copies(*settings)
	gtk_print_settings_get_number_up(*settings)
	gtk_print_settings_get_number_up_layout(*settings)
	gtk_print_settings_get_resolution(*settings)
	gtk_print_settings_get_resolution_x(*settings)
	gtk_print_settings_get_resolution_y(*settings)
	gtk_print_settings_get_printer_lpi(*settings)
	gtk_print_settings_get_scale.d(*settings)
	gtk_print_settings_get_print_pages(*settings)
	gtk_print_settings_get_page_ranges(*settings, *num_ranges)
	gtk_print_settings_get_page_set(*settings)
	gtk_print_settings_get_default_source(*settings)
	gtk_print_settings_get_media_type(*settings)
	gtk_print_settings_get_dither(*settings)
	gtk_print_settings_get_finishings(*settings)
	gtk_print_settings_get_output_bin(*settings)
	
	gtk_paper_size_get_default()
	gtk_paper_size_get_default_bottom_margin.d(*size, unit)
	gtk_paper_size_get_default_left_margin.d(*size, unit)
	gtk_paper_size_get_default_right_margin.d(*size, unit)
	gtk_paper_size_get_default_top_margin.d(*size, unit)
	gtk_paper_size_get_display_name(*size)
	gtk_paper_size_get_height.d(*size, unit)
	gtk_paper_size_get_name(*size)
	gtk_paper_size_get_ppd_name(*size)
	gtk_paper_size_get_paper_sizes(include_custom)
	gtk_paper_size_get_width.d(*size, unit)
	gtk_paper_size_is_custom(*size)
; 	gtk_paper_size_is_ipp(*size);    needs gtk3 3.16+
	gtk_paper_size_free(*size)
	gtk_printer_accepts_pdf(*printer)
	gtk_printer_accepts_ps(*printer)
	gtk_printer_get_capabilities(*printer)
	gtk_printer_get_default_page_size(*printer)
	gtk_printer_get_description(*printer)
	gtk_printer_get_hard_margins(*printer, *top, *bottom, *left, *right)
	gtk_printer_get_icon_name(*printer)
	gtk_printer_get_job_count(*printer)
	gtk_printer_get_location(*printer)
	gtk_printer_get_name(*printer)
	gtk_printer_get_state_message(*printer)
	gtk_printer_has_details(*printer)
	gtk_printer_is_accepting_jobs(*printer)
	gtk_printer_is_active(*printer)
	gtk_printer_is_default(*printer)
	gtk_printer_is_paused(*printer)
	gtk_printer_is_virtual(*printer)
	gtk_printer_request_details(*printer)
	
	gtk_icon_theme_lookup_icon(*icon_theme.GtkIconTheme, icon_name.p-utf8, size, flags)
EndImport

; Object constants
#Win_Main    = 0
#Win_PrintSet= 1

Enumeration
	#Prt_Name
	#Prt_Name_lbl
	#Prt_State
	#Prt_IconName
	#Prt_Icon
	#Prt_UserDefault
	#Prt_Virtual
	#Prt_Active
	#Prt_Paused
	#Prt_Jobs
	#Prt_Details
	#Prt_AcceptJobs
	#Prt_AcceptPS
	#Prt_AcceptPDF
	#Prt_Description
	#Prt_Location
	#Prt_SAG
	#Prt_OpenSettings
	
	#PrtD_Caps_lbl
	#PrtD_Cap_PageSet
	#PrtD_Cap_Copies
	#PrtD_Cap_Collate
	#PrtD_Cap_Reverse
	#PrtD_Cap_Scale
	#PrtD_Cap_GenPDF
	#PrtD_Cap_GenPS
	#PrtD_Cap_Preview
	#PrtD_Cap_NumberUp
	#PrtD_Cap_NumberUpLo
	
	#PrtD_Hw_lbl
	#PrtD_HwMarginTop
	#PrtD_HwMarginBot
	#PrtD_HwMarginLeft
	#PrtD_HwMarginRight
	
	#PrtD_PSuI_lbl
	#PrtD_SuOrientation
	#PrtD_SuMarginTop
	#PrtD_SuMarginBot
	#PrtD_SuMarginLeft
	#PrtD_SuMarginRight
	#PrtD_SuPapWwoMarg
	#PrtD_SuPapHwoMarg
	#PrtD_SuPapWwMarg
	#PrtD_SuPapHwMarg
	
	#PrtS_PSI_lbl
	#PrtS_NameCurr
	#PrtS_NameDispCurr
	#PrtS_NameDef
	#PrtS_NamePPD
	#PrtS_Width
	#PrtS_Height
	#PrtS_Custom
	#PrtS_IPP
	#PrtS_MarginTop
	#PrtS_MarginBot
	#PrtS_MarginLeft
	#PrtS_MarginRight
	#PrtS_SL_lbl
	#PrtS_SizeList
EndEnumeration

Enumeration #PB_Compiler_EnumerationValue
	#PJ_
EndEnumeration

;-----------------------
Enumeration GtkIconLookupFlags
	#GTK_ICON_LOOKUP_NO_SVG           = 1
	#GTK_ICON_LOOKUP_FORCE_SVG        = 2
	#GTK_ICON_LOOKUP_USE_BUILTIN      = 4
	#GTK_ICON_LOOKUP_GENERIC_FALLBACK = 8
	#GTK_ICON_LOOKUP_FORCE_SIZE       = 16
EndEnumeration
;-----------------------

Enumeration GtkPrintCapabilities
	#GTK_PRINT_CAPABILITY_PAGE_SET        = 1 << 0
	#GTK_PRINT_CAPABILITY_COPIES          = 1 << 1
	#GTK_PRINT_CAPABILITY_COLLATE         = 1 << 2
	#GTK_PRINT_CAPABILITY_REVERSE         = 1 << 3
	#GTK_PRINT_CAPABILITY_SCALE           = 1 << 4
	#GTK_PRINT_CAPABILITY_GENERATE_PDF    = 1 << 5
	#GTK_PRINT_CAPABILITY_GENERATE_PS     = 1 << 6
	#GTK_PRINT_CAPABILITY_PREVIEW         = 1 << 7
	#GTK_PRINT_CAPABILITY_NUMBER_UP       = 1 << 8
	#GTK_PRINT_CAPABILITY_NUMBER_UP_LAYOUT= 1 << 9
EndEnumeration

Enumeration GtkUnit
	#GTK_UNIT_NONE
	#GTK_UNIT_POINTS
	#GTK_UNIT_INCH
	#GTK_UNIT_MM
EndEnumeration

Enumeration GtkPageOrientation
	#GTK_PAGE_ORIENTATION_PORTRAIT
	#GTK_PAGE_ORIENTATION_LANDSCAPE
	#GTK_PAGE_ORIENTATION_REVERSE_PORTRAIT
	#GTK_PAGE_ORIENTATION_REVERSE_LANDSCAPE
EndEnumeration

Structure GTKPRINTERENUM
	*printer
	Name.s
EndStructure


Global.i gEvent, gEventWin, gQuit
Global.i gPrintersNum
Global.i gIconSize= 32, gIconFlags= 0
Global.s gIconName= "image-missing"
Global NewList GtkPrinters.GTKPRINTERENUM()


;-IMAGES
Enumeration
	#ImgPrinter
EndEnumeration

;-FONTS ...
#FontBold= 0
LoadFont(#FontBold, "SansSerif bold", 10)

; search icon name in system and return filename
Procedure.s IconDefaultTheme_FilenameFromNameSize(icon_name.s, icon_size, flags)
	Protected   *icon_info= gtk_icon_theme_lookup_icon(gtk_icon_theme_get_default_(), icon_name, icon_size, flags)
	Protected.s S= ""

	If *icon_info
		S= PeekS(gtk_icon_info_get_filename_(*icon_info), -1, #PB_UTF8)
	EndIf
	ProcedureReturn S
EndProcedure

;------------------------------
Procedure Printer_GetCapabilities(*printer)
	Protected.i Capabilities
	
	If *printer
		Capabilities= gtk_printer_get_capabilities(*printer)
	Else
		Capabilities= 0
	EndIf
	If Capabilities & #GTK_PRINT_CAPABILITY_PAGE_SET         : SetGadgetState(#PrtD_Cap_PageSet, #PB_Checkbox_Checked)    : Else : SetGadgetState(#PrtD_Cap_PageSet, #PB_Checkbox_Unchecked)    : EndIf
	If Capabilities & #GTK_PRINT_CAPABILITY_COPIES           : SetGadgetState(#PrtD_Cap_Copies, #PB_Checkbox_Checked)     : Else : SetGadgetState(#PrtD_Cap_Copies, #PB_Checkbox_Unchecked)     : EndIf
	If Capabilities & #GTK_PRINT_CAPABILITY_COLLATE          : SetGadgetState(#PrtD_Cap_Collate, #PB_Checkbox_Checked)    : Else : SetGadgetState(#PrtD_Cap_Collate, #PB_Checkbox_Unchecked)    : EndIf
	If Capabilities & #GTK_PRINT_CAPABILITY_REVERSE          : SetGadgetState(#PrtD_Cap_Reverse, #PB_Checkbox_Checked)    : Else : SetGadgetState(#PrtD_Cap_Reverse, #PB_Checkbox_Unchecked)    : EndIf
	If Capabilities & #GTK_PRINT_CAPABILITY_SCALE            : SetGadgetState(#PrtD_Cap_Scale, #PB_Checkbox_Checked)      : Else : SetGadgetState(#PrtD_Cap_Scale, #PB_Checkbox_Unchecked)      : EndIf
	If Capabilities & #GTK_PRINT_CAPABILITY_GENERATE_PDF     : SetGadgetState(#PrtD_Cap_GenPDF, #PB_Checkbox_Checked)     : Else : SetGadgetState(#PrtD_Cap_GenPDF, #PB_Checkbox_Unchecked)     : EndIf
	If Capabilities & #GTK_PRINT_CAPABILITY_GENERATE_PS      : SetGadgetState(#PrtD_Cap_GenPS, #PB_Checkbox_Checked)      : Else : SetGadgetState(#PrtD_Cap_GenPS, #PB_Checkbox_Unchecked)      : EndIf
	If Capabilities & #GTK_PRINT_CAPABILITY_PREVIEW          : SetGadgetState(#PrtD_Cap_Preview, #PB_Checkbox_Checked)    : Else : SetGadgetState(#PrtD_Cap_Preview, #PB_Checkbox_Unchecked)    : EndIf
	If Capabilities & #GTK_PRINT_CAPABILITY_NUMBER_UP        : SetGadgetState(#PrtD_Cap_NumberUp, #PB_Checkbox_Checked)   : Else : SetGadgetState(#PrtD_Cap_NumberUp, #PB_Checkbox_Unchecked)   : EndIf
	If Capabilities & #GTK_PRINT_CAPABILITY_NUMBER_UP_LAYOUT : SetGadgetState(#PrtD_Cap_NumberUpLo, #PB_Checkbox_Checked) : Else : SetGadgetState(#PrtD_Cap_NumberUpLo, #PB_Checkbox_Unchecked) : EndIf
EndProcedure

Procedure.s Page_GetOrientation(Orientation)
	Protected.s S
	
	Select Orientation
		Case #GTK_PAGE_ORIENTATION_PORTRAIT          : S= "GTK_PAGE_ORIENTATION_PORTRAIT"
		Case #GTK_PAGE_ORIENTATION_LANDSCAPE         : S= "GTK_PAGE_ORIENTATION_LANDSCAPE"
		Case #GTK_PAGE_ORIENTATION_REVERSE_PORTRAIT  : S= "GTK_PAGE_ORIENTATION_REVERSE_PORTRAIT"
		Case #GTK_PAGE_ORIENTATION_REVERSE_LANDSCAPE : S= "GTK_PAGE_ORIENTATION_REVERSE_LANDSCAPE"
	EndSelect
	ProcedureReturn S
EndProcedure

;only called once ...
ProcedureC Callback_RequestPrinterDetail(*printer, success, user_data)
	Protected.i n
	Protected.d top, bottom, left, right
	Protected.s ppd_name
	Protected   *printerpage, *papersize, *sizelist.GList, *size, *ppd

	If success
		SetGadgetState(#Prt_Details,         gtk_printer_has_details(*printer))
		Printer_GetCapabilities(*printer)
		If gtk_printer_get_hard_margins(*printer, @top, @bottom, @left, @right)
			SetGadgetText(#PrtD_HwMarginTop,   StrD(top, 3))
			SetGadgetText(#PrtD_HwMarginBot,   StrD(bottom, 3))
			SetGadgetText(#PrtD_HwMarginLeft,  StrD(left, 3))
			SetGadgetText(#PrtD_HwMarginRight, StrD(right, 3))
		EndIf
		
		*printerpage= gtk_printer_get_default_page_size(*printer)
		If *printerpage
			SetGadgetText(#PrtD_SuOrientation, Page_GetOrientation(gtk_page_setup_get_orientation(*printerpage)))
			SetGadgetText(#PrtD_SuMarginTop,   StrD(gtk_page_setup_get_top_margin(*printerpage, #GTK_UNIT_MM), 3))
			SetGadgetText(#PrtD_SuMarginBot,   StrD(gtk_page_setup_get_bottom_margin(*printerpage, #GTK_UNIT_MM), 3))
			SetGadgetText(#PrtD_SuMarginLeft,  StrD(gtk_page_setup_get_left_margin(*printerpage, #GTK_UNIT_MM), 3))
			SetGadgetText(#PrtD_SuMarginRight, StrD(gtk_page_setup_get_right_margin(*printerpage, #GTK_UNIT_MM), 3))
			SetGadgetText(#PrtD_SuPapWwoMarg,  StrD(gtk_page_setup_get_paper_width(*printerpage, #GTK_UNIT_MM), 3))
			SetGadgetText(#PrtD_SuPapHwoMarg,  StrD(gtk_page_setup_get_paper_height(*printerpage, #GTK_UNIT_MM), 3))
			SetGadgetText(#PrtD_SuPapWwMarg,   StrD(gtk_page_setup_get_page_width(*printerpage, #GTK_UNIT_MM), 3))
			SetGadgetText(#PrtD_SuPapHwMarg,   StrD(gtk_page_setup_get_page_height(*printerpage, #GTK_UNIT_MM), 3))
			
			*papersize= gtk_page_setup_get_paper_size(*printerpage)
			If *papersize
				SetGadgetText(#PrtS_NameCurr,     PeekS(gtk_paper_size_get_name(*papersize), -1, #PB_UTF8))
				SetGadgetText(#PrtS_NameDispCurr, PeekS(gtk_paper_size_get_display_name(*papersize), -1, #PB_UTF8))
				SetGadgetText(#PrtS_NameDef,      PeekS(gtk_paper_size_get_default(), -1, #PB_UTF8))
				*ppd = gtk_paper_size_get_ppd_name(*papersize)
				If *ppd
					ppd_name= PeekS(*ppd, -1, #PB_UTF8)
				Else
					ppd_name= ""
				EndIf
				SetGadgetText(#PrtS_NamePPD,      ppd_name)
				SetGadgetText(#PrtS_Width,        StrD(gtk_paper_size_get_width(*papersize, #GTK_UNIT_MM), 3))
				SetGadgetText(#PrtS_Height,       StrD(gtk_paper_size_get_height(*papersize, #GTK_UNIT_MM), 3))
				SetGadgetState(#PrtS_Custom,      gtk_paper_size_is_custom(*papersize))
; 				SetGadgetState(#PrtS_IPP,         gtk_paper_size_is_ipp(*printersize))
				SetGadgetText(#PrtS_MarginTop,    StrD(gtk_paper_size_get_default_top_margin(*papersize, #GTK_UNIT_MM), 3))
				SetGadgetText(#PrtS_MarginBot,    StrD(gtk_paper_size_get_default_bottom_margin(*papersize, #GTK_UNIT_MM), 3))
				SetGadgetText(#PrtS_MarginLeft,   StrD(gtk_paper_size_get_default_left_margin(*papersize, #GTK_UNIT_MM), 3))
				SetGadgetText(#PrtS_MarginRight,  StrD(gtk_paper_size_get_default_right_margin(*papersize, #GTK_UNIT_MM), 3))
			EndIf
			gtk_paper_size_free(*papersize)
		EndIf
		
		*sizelist= gtk_paper_size_get_paper_sizes(#True)
		If *sizelist
			ClearGadgetItems(#PrtS_SizeList)
			Repeat
				*size= *sizelist\data
				*ppd = gtk_paper_size_get_ppd_name(*size)
				If *ppd
					ppd_name= PeekS(*ppd, -1, #PB_UTF8)
				Else
					ppd_name= ""
				EndIf
				AddGadgetItem(#PrtS_SizeList, -1, Str(n+1) + "." + #LF$ + PeekS(gtk_paper_size_get_name(*size), -1, #PB_UTF8) + #LF$ + 
				                                  PeekS(gtk_paper_size_get_display_name(*size), -1, #PB_UTF8) + #LF$ + 
				                                  ppd_name + #LF$ + 
				                                  StrD(gtk_paper_size_get_width(*size, #GTK_UNIT_MM), 1) + #LF$ + 
				                                  StrD(gtk_paper_size_get_height(*size, #GTK_UNIT_MM), 1) + #LF$ + 
				                                  "-" + #LF$ + 
; 				                                  Str(gtk_paper_size_is_ipp(*size)) + #LF$ + ; needs gtk3 3.16+
				                                  Str(gtk_paper_size_is_custom(*size)) + #LF$ + 
				                                  StrD(gtk_paper_size_get_default_top_margin(*size, #GTK_UNIT_MM), 1) + #LF$ + 
				                                  StrD(gtk_paper_size_get_default_bottom_margin(*size, #GTK_UNIT_MM), 1) + #LF$ + 
				                                  StrD(gtk_paper_size_get_default_left_margin(*size, #GTK_UNIT_MM), 1) + #LF$ + 
				                                  StrD(gtk_paper_size_get_default_right_margin(*size, #GTK_UNIT_MM), 1) )
				*sizelist= *sizelist\next
				n+ 1
			Until *sizelist = 0
			g_list_free_(*sizelist)
		EndIf
	EndIf
EndProcedure

ProcedureC Callback_AssumePrinters(*printer, user_data)
	If *printer
		AddElement(GtkPrinters())
		GtkPrinters()\printer= *printer
		GtkPrinters()\Name   = PeekS(gtk_printer_get_name(*printer), -1, #PB_UTF8)
		g_object_ref_(*printer);                                         necessary for repetitive detail calls, otherwise IMA, *printer no longer valid!
		g_signal_connect(*printer, "details-acquired", @Callback_RequestPrinterDetail(), #Null)
	EndIf
EndProcedure

Procedure PrinterList_Create()
	ForEach GtkPrinters()
		AddGadgetItem(#Prt_Name, -1, GtkPrinters()\Name)
	Next GtkPrinters()
EndProcedure

Procedure Printer_Call(Idx.i)
	Protected *Printer
	
	If Idx > -1
		Protected.s S= GetGadgetItemText(#Prt_Name, Idx)
		If S <> ""
			ForEach GtkPrinters()
				If gtkprinters()\Name <> ""
					If S = PeekS(gtk_printer_get_name(gtkprinters()\printer), -1, #PB_UTF8)
						*Printer= GtkPrinters()\printer
						Break
					EndIf
				EndIf
			Next GtkPrinters()
		EndIf
		
		If *Printer
			gtk_printer_request_details(*printer);                         request details for this printer
			
			If gtk_printer_get_state_message(*printer)
				SetGadgetText(#Prt_State, PeekS(gtk_printer_get_state_message(*printer), -1, #PB_UTF8))
			Else
				SetGadgetText(#Prt_State, "")
			EndIf
			
			If gtk_printer_get_icon_name(*printer)
				SetGadgetText(#Prt_IconName, PeekS(gtk_printer_get_icon_name(*printer), -1, #PB_UTF8))
				If GetGadgetText(#Prt_IconName) <> ""
					If IconDefaultTheme_FilenameFromNameSize(GetGadgetText(#Prt_IconName), gIconSize, gIconFlags)
						LoadImage(#ImgPrinter, IconDefaultTheme_FilenameFromNameSize(GetGadgetText(#Prt_IconName), gIconSize, gIconFlags))
						SetGadgetState(#Prt_Icon, ImageID(#ImgPrinter))
					Else
						If IconDefaultTheme_FilenameFromNameSize("image-missing", gIconSize, gIconFlags)
							LoadImage(#ImgPrinter, IconDefaultTheme_FilenameFromNameSize("image-missing", gIconSize, gIconFlags))
							SetGadgetState(#Prt_Icon, ImageID(#ImgPrinter))
						EndIf
					EndIf
				EndIf
			Else
				SetGadgetText(#Prt_IconName, "")
			EndIf
			
			SetGadgetState(#Prt_UserDefault,  gtk_printer_is_default(*printer))
			SetGadgetState(#Prt_Virtual,      gtk_printer_is_virtual(*printer))
			SetGadgetState(#Prt_Active,       gtk_printer_is_active(*printer))
			SetGadgetState(#Prt_Paused,       gtk_printer_is_paused(*printer))
			SetGadgetText(#Prt_Jobs,          Str(gtk_printer_get_job_count(*printer)))
			SetGadgetState(#Prt_Details,      0);         in callback
			SetGadgetState(#Prt_AcceptJobs,   gtk_printer_is_accepting_jobs(*printer))
			SetGadgetState(#Prt_AcceptPS,     gtk_printer_accepts_ps(*printer))
			SetGadgetState(#Prt_AcceptPDF,    gtk_printer_accepts_pdf(*printer))
			If gtk_printer_get_description(*printer)
				SetGadgetText(#Prt_Description, PeekS(gtk_printer_get_description(*printer), -1, #PB_UTF8))
			Else
				SetGadgetText(#Prt_Description, "")
			EndIf
			If gtk_printer_get_location(*printer)
				SetGadgetText(#Prt_Location,    PeekS(gtk_printer_get_location(*printer), -1, #PB_UTF8))
			Else
				SetGadgetText(#Prt_Location,    "")
			EndIf
			If gtk_printer_has_details(*printer);                          Detail query completed?
				Callback_RequestPrinterDetail(*printer, 1, 1);               direct call, otherwise wait on Callback
			EndIf
		EndIf
	EndIf
EndProcedure

Procedure Create_WinMain()
	If OpenWindow(#Win_Main, 300, 200, 855, 500, "Printers: Gtk-API demo", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_SizeGadget)
		
		TextGadget(#Prt_Name_lbl,              5,  12, 100, 22, "Printer: ")
		TextGadget(#PB_Any,                    5,  44, 100,  22, "State: ", #PB_Text_Right)
		TextGadget(#PB_Any,                    5,  74, 100,  22, "Icon name: ", #PB_Text_Right)
		TextGadget(#PB_Any,                    5, 224, 100,  22, "Curr. Jobs: ", #PB_Text_Right)
		TextGadget(#PB_Any,                    5, 374, 100,  22, "Description: ", #PB_Text_Right)
		TextGadget(#PB_Any,                    5, 404, 100,  22, "Location: ", #PB_Text_Right)
		ComboBoxGadget(#Prt_Name,            105,   6, 200,  28)
		StringGadget(#Prt_State,             105,  40, 200,  26, "", #PB_String_ReadOnly)
		StringGadget(#Prt_IconName,          105,  70, 200,  26, "", #PB_String_ReadOnly)
		
		If LoadImage(#ImgPrinter, IconDefaultTheme_FilenameFromNameSize(gIconName, gIconSize, gIconFlags))
			ImageGadget(#Prt_Icon,               5,  90,  32,  32, ImageID(#ImgPrinter))
		EndIf
		
		CheckBoxGadget(#Prt_UserDefault,     105, 100, 100,  26, "User default")
		CheckBoxGadget(#Prt_Virtual,         105, 130, 100,  26, "Virtual")
		CheckBoxGadget(#Prt_Active,          105, 160, 100,  26, "Active")
		CheckBoxGadget(#Prt_Paused,          105, 190, 100,  26, "Paused")
		StringGadget(#Prt_Jobs,              105, 220,  60,  26, "", #PB_String_ReadOnly)
		CheckBoxGadget(#Prt_Details,         105, 250, 100,  26, "Details available")
		CheckBoxGadget(#Prt_AcceptJobs,      105, 280, 100,  26, "Accept Jobs")
		CheckBoxGadget(#Prt_AcceptPS,        105, 310, 100,  26, "Accept PS")
		CheckBoxGadget(#Prt_AcceptPDF,       105, 340, 100,  26, "Accept PDF")
		StringGadget(#Prt_Description,       105, 370, 200,  26, "", #PB_String_ReadOnly)
		StringGadget(#Prt_Location,          105, 400, 200,  26, "", #PB_String_ReadOnly)
		
		ScrollAreaGadget(#Prt_SAG,           310,   5, 540, 490, 515, 950, #PB_ScrollArea_Flat)
		
		TextGadget(#PrtD_Caps_lbl,             5,   5, 300,  22, "Capabilities:")
		CheckBoxGadget(#PrtD_Cap_PageSet,     10,  30, 150,  22, "Page set: odd/even")
		CheckBoxGadget(#PrtD_Cap_Copies,      10,  55, 150,  22, "Copies")
		CheckBoxGadget(#PrtD_Cap_Collate,     10,  80, 150,  22, "Collate copies")
		CheckBoxGadget(#PrtD_Cap_Reverse,     10, 105, 150,  22, "Reverse order")
		CheckBoxGadget(#PrtD_Cap_Scale,       10, 130, 150,  22, "Scale output")
		CheckBoxGadget(#PrtD_Cap_GenPDF,     280,  30, 150,  22, "Send PDF")
		CheckBoxGadget(#PrtD_Cap_GenPS,      280,  55, 150,  22, "Send PS")
		CheckBoxGadget(#PrtD_Cap_Preview,    280,  80, 150,  22, "Offer preview")
		CheckBoxGadget(#PrtD_Cap_NumberUp,   280, 105, 150,  22, "Multi pages")
		CheckBoxGadget(#PrtD_Cap_NumberUpLo, 280, 130, 150,  22, "Multi pages w. layout")
		
		TextGadget(#PrtD_Hw_lbl,               5, 165, 300,  22, "Hard printer margins:")
		TextGadget(#PB_Any,                   15, 195, 240,  22, "Top / Bottom:")
		TextGadget(#PB_Any,                   15, 225, 240,  22, "Left / Right:")
		
		StringGadget(#PrtD_HwMarginTop,      280, 191, 100,  26, "", #PB_String_ReadOnly)
		StringGadget(#PrtD_HwMarginBot,      385, 191, 100,  26, "", #PB_String_ReadOnly)
		StringGadget(#PrtD_HwMarginLeft,     280, 221, 100,  26, "", #PB_String_ReadOnly)
		StringGadget(#PrtD_HwMarginRight,    385, 221, 100,  26, "", #PB_String_ReadOnly)
		
		TextGadget(#PrtD_PSuI_lbl,             5, 265, 400,  22, "Default page setup information for printer:")
		TextGadget(#PB_Any,                   15, 290, 160,  22, "Orientation:")
		TextGadget(#PB_Any,                   15, 320, 260,  22, "Margin Top / Bottom [mm]:")
		TextGadget(#PB_Any,                   15, 350, 260,  22, "Margin Left / Right [mm]:")
		TextGadget(#PB_Any,                   15, 380, 260,  22, "Paper width / height w/o margins [mm]:")
		TextGadget(#PB_Any,                   15, 410, 260,  22, "Paper width / height with margins [mm]:")
		
		StringGadget(#PrtD_SuOrientation,    210, 286, 275,  26, "", #PB_String_ReadOnly)
		StringGadget(#PrtD_SuMarginTop,      280, 316, 100,  26, "", #PB_String_ReadOnly)
		StringGadget(#PrtD_SuMarginBot,      385, 316, 100,  26, "", #PB_String_ReadOnly)
		StringGadget(#PrtD_SuMarginLeft,     280, 346, 100,  26, "", #PB_String_ReadOnly)
		StringGadget(#PrtD_SuMarginRight,    385, 346, 100,  26, "", #PB_String_ReadOnly)
		StringGadget(#PrtD_SuPapWwoMarg,     280, 376, 100,  26, "", #PB_String_ReadOnly)
		StringGadget(#PrtD_SuPapHwoMarg,     385, 376, 100,  26, "", #PB_String_ReadOnly)
		StringGadget(#PrtD_SuPapWwMarg,      280, 406, 100,  26, "", #PB_String_ReadOnly)
		StringGadget(#PrtD_SuPapHwMarg,      385, 406, 100,  26, "", #PB_String_ReadOnly)
		
		TextGadget(#PrtS_PSI_lbl,              5, 450, 400,  22, "Paper size informationd for page:")
		TextGadget(#PB_Any,                   15, 475, 230,  22, "Size name (curr.):")
		TextGadget(#PB_Any,                   15, 505, 230,  22, "Size display name (curr.):")
		TextGadget(#PB_Any,                   15, 535, 230,  22, "Size name (default):")
		TextGadget(#PB_Any,                   15, 565, 230,  22, "Size PPD name:")
		TextGadget(#PB_Any,                   15, 625, 230,  22, "Size width /height (curr.):")
		TextGadget(#PB_Any,                   15, 655, 230,  22, "Size margin Top / Bottom:")
		TextGadget(#PB_Any,                   15, 685, 230,  22, "Size margin Left / Right:")
		
		StringGadget(#PrtS_NameCurr,         280, 471, 100,  26, "", #PB_String_ReadOnly)
		StringGadget(#PrtS_NameDispCurr,     280, 501, 100,  26, "", #PB_String_ReadOnly)
		StringGadget(#PrtS_NameDef,          280, 531, 100,  26, "", #PB_String_ReadOnly)
		StringGadget(#PrtS_NamePPD,          280, 561, 100,  26, "", #PB_String_ReadOnly)
		CheckBoxGadget(#PrtS_Custom,          15, 591, 190,  22, "Size customformat?")
		CheckBoxGadget(#PrtS_IPP,            280, 591, 190,  22, "Size IPP standard?")
		StringGadget(#PrtS_Width,            280, 621, 100,  26, "", #PB_String_ReadOnly)
		StringGadget(#PrtS_Height,           385, 621, 100,  26, "", #PB_String_ReadOnly)
		StringGadget(#PrtS_MarginTop,        280, 651, 100,  26, "", #PB_String_ReadOnly)
		StringGadget(#PrtS_MarginBot,        385, 651, 100,  26, "", #PB_String_ReadOnly)
		StringGadget(#PrtS_MarginLeft,       280, 681, 100,  26, "", #PB_String_ReadOnly)
		StringGadget(#PrtS_MarginRight,      385, 681, 100,  26, "", #PB_String_ReadOnly)
		
		TextGadget(#PrtS_SL_lbl,               5, 720, 300,  22, "Paper size list:")
		ListIconGadget(#PrtS_SizeList,        15, 745, 500, 200, "#", 35)
		AddGadgetColumn(#PrtS_SizeList,  1, "Size name", 120)
		AddGadgetColumn(#PrtS_SizeList,  2, "Disp. name", 120)
		AddGadgetColumn(#PrtS_SizeList,  3, "PPD name", 110)
		AddGadgetColumn(#PrtS_SizeList,  4, "width", 60)
		AddGadgetColumn(#PrtS_SizeList,  5, "height", 60)
		AddGadgetColumn(#PrtS_SizeList,  6, "IPP", 40)
		AddGadgetColumn(#PrtS_SizeList,  7, "Custom", 40)
		AddGadgetColumn(#PrtS_SizeList,  8, "T-marg.", 50)
		AddGadgetColumn(#PrtS_SizeList,  9, "B-marg.", 50)
		AddGadgetColumn(#PrtS_SizeList, 10, "L-marg.", 50)
		AddGadgetColumn(#PrtS_SizeList, 11, "R-marg.", 50)
		gtk_tree_selection_set_mode_(gtk_tree_view_get_selection_(GadgetID(#PrtS_SizeList)), #GTK_SELECTION_NONE); not selectable
		
		SetGadgetFont(#Prt_Name_lbl,  FontID(#FontBold))
		SetGadgetFont(#PrtD_Caps_lbl, FontID(#FontBold))
		SetGadgetFont(#PrtD_Hw_lbl,   FontID(#FontBold))
		SetGadgetFont(#PrtD_PSuI_lbl, FontID(#FontBold))
		SetGadgetFont(#PrtS_PSI_lbl,  FontID(#FontBold))
		SetGadgetFont(#PrtS_SL_lbl,   FontID(#FontBold))
		DisableGadget(#PrtS_IPP, #True)
		
		
		gtk_enumerate_printers(@Callback_AssumePrinters(), #Null, #Null, #True); forced to query infos for *printer on 'gtk_printer_request_details(*printer)' and wait (=, #True)
		PrinterList_Create()
	EndIf
EndProcedure

Create_WinMain()

Repeat
	gEvent= WaitWindowEvent()
	gEventWin= EventWindow()
	
	Select gEventWin
			
		Case #Win_Main
			
			Select gEvent
				Case #PB_Event_CloseWindow
					gQuit= #True
					
				Case #PB_Event_SizeWindow
					ResizeGadget(#Prt_SAG,       #PB_Ignore, #PB_Ignore, WindowWidth(#Win_Main)-315, WindowHeight(#Win_Main)-10)
					ResizeGadget(#PrtS_SizeList, #PB_Ignore, #PB_Ignore, WindowWidth(#Win_Main)-355, WindowHeight(#Win_Main)-300)
					
				Case #PB_Event_Gadget
					
					Select EventGadget()
							
						Case #Prt_Name
							Printer_GetCapabilities(#Null)
							Printer_Call(GetGadgetState(#Prt_Name))
							
						Case #Prt_OpenSettings
; 							Create_WinPrintSet()
							
					EndSelect
					
			EndSelect
			
; 		Case #Win_PrintSet
; 			
; 			Select gEvent
; 					
; 				Case #PB_Event_CloseWindow
; 					CloseWindow(#Win_PrintSet)
; 					
; 			EndSelect
	EndSelect
	
Until gQuit

ForEach GtkPrinters()
	If GtkPrinters()\printer
		g_object_unref_(GtkPrinters()\printer)
	EndIf
Next GtkPrinters()
; IDE Options = PureBasic 5.42 LTS (Linux - x86)
; CursorPosition = 17
; Folding = --
; EnableUnicode
; EnableXP