﻿; Module/File:     MessageRequester_Icon_Modal_Title.pb
; Function:        MessageRequester with window-title, OS-Icon, modal - Linux
; Author:          Omi
; Date:            Jan. 10, 2015
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

;MessageBox-Icons ...
; MbIcon= #GTK_MESSAGE_ERROR
; MbIcon= #GTK_MESSAGE_INFO
; MbIcon= #GTK_MESSAGE_QUESTION
; MbIcon= #GTK_MESSAGE_WARNING

;MessageBox-Standard-Buttons (gtk-constants) ...
; #GTK_BUTTONS_NONE                = 0
; #GTK_BUTTONS_OK                  = 1
; #GTK_BUTTONS_CLOSE               = 2
; #GTK_BUTTONS_CANCEL              = 3
; #GTK_BUTTONS_YES_NO              = 4
; #GTK_BUTTONS_OK_CANCEL           = 5

;MessageBox-Response ...
; #GTK_RESPONSE_DELETE_EVENT=  MessageBox closed via Window-Close
; #GTK_RESPONSE_OK          =  MessageBox OK
; #GTK_RESPONSE_CANCEL      =  MessageBox Cancel
; #GTK_RESPONSE_YES         =  MessageBox Yes
; #GTK_RESPONSE_NO          =  MessageBox No

EnableExplicit

ImportC ""
	gtk_message_dialog_new(*parent.GtkWindow, flags, type, buttons, message_format.p-utf8, arguments.p-utf8, stop)
	gtk_window_set_title(*window.GtkWindow, title.p-utf8)
EndImport

; Object constants
#MainWin=0
#But1= 0

#WinX=300
#WinY=200
#WinW=360
#WinH=100

Global.i gEvent, gQuit

Procedure.l MessageBoxWTitle(ParentWin, MbTitle.s, MbString.s, MbIcon, MbButtons);  Type .l fpr 64-Bit!
	Protected *dialog.GtkDialog
	Protected *window.GtkWindow
	Protected.l MbRet; type .l for 64-Bit
	;modal ...
	*dialog = gtk_message_dialog_new(WindowID(ParentWin), #GTK_DIALOG_DESTROY_WITH_PARENT, MbIcon, MbButtons, MbString, "", 0)
	*window= *dialog\window
	gtk_window_set_title(*window, MbTitle)
	
	MbRet= gtk_dialog_run_(*dialog)
	gtk_widget_destroy_(*dialog)
	ProcedureReturn MbRet
EndProcedure

;-
;- Main ...
If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "native MessageRequester w. Title", #PB_Window_SystemMenu)
	ButtonGadget(#But1, 5, 5, 350, 26,  "MessageRequester modal, w. Icon & Window-Title")
	
	Repeat
		gEvent= WaitWindowEvent()

		Select gEvent

			Case #PB_Event_CloseWindow
				gQuit= #True

			Case #PB_Event_Gadget

				Select EventGadget()

					Case #But1
						Debug MessageBoxWTitle(#MainWin, "Finally a window-title", 
						                       "Here's the message-text," + #LF$ + 
						                       "with a 2. Line", 
						                       #GTK_MESSAGE_INFO, 
						                       #GTK_BUTTONS_OK_CANCEL)
						
				EndSelect

		EndSelect

	Until gQuit
EndIf
; IDE Options = PureBasic 5.40 LTS Beta 8 (Linux - x86)
; CursorPosition = 8
; Folding = -
; EnableUnicode
; EnableXP