﻿; Module/File:     MessageRequester_MultiFunction.pb
; Function:        MessageRequester with OS-Icon, formatet Markuptext, Std. or own Buttons, modal - Linux
; Author:          Omi
; Date:            Jan. 10, 2015
; Version:         0.2, x64-Bug-fixed
; Target Compiler: PureBasic 5.22/5.31
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

;MessageBox-Icons ...
; MbIcon= #GTK_MESSAGE_ERROR      = MB_ICONSTOP | MB_ICONERROR | MB_ICONHAND = ($10)
; MbIcon= #GTK_MESSAGE_INFO       = MB_ICONINFORMATION | MB_ICONASTERISK     = ($40)
; MbIcon= #GTK_MESSAGE_QUESTION   = MB_ICONQUESTION                          = ($20)
; MbIcon= #GTK_MESSAGE_WARNING    = MB_ICONWARNING | MB_ICONEXCLAMATION      = ($30)

;MessageBox-Standard-Buttons (PB-constants with errors) ...
; #PB_MessageRequester_Ok          = 0
; #PB_MessageRequester_YesNo       = 1
; #PB_MessageRequester_YesNoCancel = 2
; #PB_MessageRequester_Cancel      = 2
; #PB_MessageRequester_Yes         = 6
; #PB_MessageRequester_No          = 7

;MessageBox-Standard-Buttons (gtk-constants) ...
; #GTK_BUTTONS_NONE                = 0
; #GTK_BUTTONS_OK                  = 1
; #GTK_BUTTONS_CLOSE               = 2
; #GTK_BUTTONS_CANCEL              = 3
; #GTK_BUTTONS_YES_NO              = 4
; #GTK_BUTTONS_OK_CANCEL           = 5

;MessageBox-Response ...
; #GTK_RESPONSE_NONE        = -1   Close Window
; #GTK_RESPONSE_REJECT      = -2
; #GTK_RESPONSE_ACCEPT      = -3
; #GTK_RESPONSE_DELETE_EVENT= -4
; #GTK_RESPONSE_OK          = -5
; #GTK_RESPONSE_CANCEL      = -6   #PB_MessageRequester_Cancel = 2
; #GTK_RESPONSE_CLOSE       = -7   MessageBox Close
; #GTK_RESPONSE_YES         = -8   #PB_MessageRequester_Yes    = 6
; #GTK_RESPONSE_NO          = -9   #PB_MessageRequester_No     = 7
; #GTK_RESPONSE_APPLY       = -10
; #GTK_RESPONSE_HELP        = -11

;MessageBox-Parameter ...
; ParentWin   = Basic window which call the MessageRequester. use number, NOT the id
; MbBody      = Main text, with 'UseMarkup'= #True formated text is possible
; MbSecText   = Secondary text (on new paragraph) with 'UseMarkup'= #True
; MbIcon      = Icon, see above
; *MbButtons  = Button-Standard-Set OR pointer to Text on Own-Buttons (stock ID with text also allowed), 
;               Textes separated with '|' AND own Returnvalues begins with -1001 in same order as buttons, see below.
; UseMarkup   = '#True' if you want to use Markup & secondary_text
; Return      = PB-Returns on Std.-Buttons or -1001, -1002, ... from left to right button

EnableExplicit

ImportC ""
	gtk_message_dialog_new_with_markup(*parent.GtkWindow, flags, type, buttons, message_format.p-utf8, markup.p-utf8, stop)
	gtk_message_dialog_new(*parent.GtkWindow, flags, type, buttons, message_format.p-utf8, arguments.p-utf8, stop)
	gtk_message_dialog_format_secondary_text(*message_dialog.GtkMessageDialog, message_format.p-utf8, arguments.p-utf8, stop)
	gtk_dialog_add_button(*dialog.GtkDialog, first_button_text.p-utf8, response)
EndImport

; Object constants
#MainWin=0
#But1= 0
#But2= 1
#But3= 2
#But4= 3

#WinX=300
#WinY=200
#WinW=400
#WinH=200

Global.i gEvent, gQuit


;- Functions ...
Procedure.l MessageMultiBox(ParentWin, MbBody.s, MbSecText.s, MbIcon, *MbButtons, UseMarkup.b= #False); modal,  Type .l fpr 64-Bit! ...
	Protected *dialog.GtkDialog
	Protected.l I, MbRet, MbButtonsNativ; Type .l for 64-Bit
	Protected.s ButtonSingle
	
	If *MbButtons< $FF
		MbButtonsNativ= *MbButtons
	Else
		MbButtonsNativ= #GTK_BUTTONS_NONE
	EndIf
	
	If UseMarkup
		*dialog = gtk_message_dialog_new_with_markup(WindowID(ParentWin), 
		                                             #GTK_DIALOG_DESTROY_WITH_PARENT, 
		                                             MbIcon, 
		                                             MbButtonsNativ, 
		                                             MbBody, 
		                                             "", 
		                                             0)
		gtk_message_dialog_format_secondary_text(*dialog, MbSecText, "", 0)
	Else
		*dialog = gtk_message_dialog_new(WindowID(ParentWin), 
		                                 #GTK_DIALOG_DESTROY_WITH_PARENT, 
		                                 MbIcon, 
		                                 MbButtonsNativ, 
		                                 MbBody, 
		                                 "", 
		                                 0)
	EndIf
	
	If *MbButtons> $FF
		For I= 1 To CountString(PeekS(*MbButtons), "|")+ 1
			ButtonSingle= StringField(PeekS(*MbButtons), I, "|")
			gtk_dialog_add_button(*dialog, ButtonSingle, I);-1000- I)
		Next I
	EndIf
	
	MbRet= gtk_dialog_run_(*dialog)
	gtk_widget_destroy_(*dialog)
	ProcedureReturn MbRet
EndProcedure

;-
;- Main ...
If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "native MessageRequester", #PB_Window_SystemMenu)
	ButtonGadget(#But1, 5, 5, 390, 25, "MessageRequester, Icon, modal")
	ButtonGadget(#But2, 5, 35, 390, 25,  "MessageRequester, Icon, Markup, modal")
	ButtonGadget(#But3, 5, 75, 390, 25, "MessageRequester, Icon, Own Buttons, modal")
	ButtonGadget(#But4, 5, 105, 390, 25,  "MessageRequester, Icon, Markup, Own Buttons, modal")
	
	Repeat
		gEvent= WaitWindowEvent()

		Select gEvent

			Case #PB_Event_CloseWindow
				gQuit= #True

			Case #PB_Event_Gadget

				Select EventGadget()
						
					Case #But1
						Debug MessageMultiBox(#MainWin, "Test-MessageBox" + #LF$ + "mit 2. Zeile und Standard-Buttons.", 
						                      "",
						                      #GTK_MESSAGE_INFO, 
						                      #GTK_BUTTONS_OK_CANCEL)
							
					Case #But2
						Debug MessageMultiBox(#MainWin, "<b>Test-MessageBox w. Markups</b>" + #LF$ + #LF$ + "mit 2. Zeile" + #LF$ + "und 3. Zeile", 
						                      "Hier noch ein 2. Absatz" + #LF$ + "per 'gtk_message_dialog_format_secondary_text()'" + #LF$ + "mit Standard-Buttons.", 
						                      #GTK_MESSAGE_INFO, 
						                      #GTK_BUTTONS_YES_NO, 
						                      #True)
						
					Case #But3
						Debug MessageMultiBox(#MainWin, "Test-MessageBox" + #LF$ + "mit 2. Zeile und eigenen Buttons.", 
						                      "", 
						                      #GTK_MESSAGE_INFO, 
						                      @"gtk-help|Übernehmen|gtk-info"); 'gtk-...' are stock-IDs
						
					Case #But4
						Debug MessageMultiBox(#MainWin, "<big><b>Test-MessageBox w. Markups</b></big>" + #LF$ + #LF$ + "<u>mit 2. Zeile</u>" + #LF$ + "<i>und 3. Zeile</i>", 
						                      "Hier noch ein 2. Absatz" + #LF$ + "per 'gtk_message_dialog_format_secondary_text()'" + #LF$ + "mit eigenen-Buttons.", 
						                      #GTK_MESSAGE_INFO, 
						                      @"Zurück|Übernehmen|gtk-save", 
						                      #True); 'gtk-...' are stock-IDs
						
				EndSelect

		EndSelect

	Until gQuit
EndIf
; IDE Options = PureBasic 5.40 LTS Beta 8 (Linux - x86)
; CursorPosition = 8
; Folding = -
; EnableUnicode
; EnableXP
; CurrentDirectory = /home/charly-xubuntu/Programming/PureBasic/purebasic/