﻿; Module/File:     MessageRequester_SimpleNonModal.pb
; Function:        Simple MessageRequester with OS-Icon, non modal - Linux
; Author:          Omi
; Date:            Sep. 10, 2015
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

;MessageBox-Icons ...
; MbIcon= #GTK_MESSAGE_ERROR
; MbIcon= #GTK_MESSAGE_INFO
; MbIcon= #GTK_MESSAGE_QUESTION
; MbIcon= #GTK_MESSAGE_WARNING

;MessageBox-Standard-Buttons (gtk-constants) ...
; #GTK_BUTTONS_NONE                = 0
; #GTK_BUTTONS_OK                  = 1
; #GTK_BUTTONS_CLOSE               = 2
; #GTK_BUTTONS_CANCEL              = 3
; #GTK_BUTTONS_YES_NO              = 4
; #GTK_BUTTONS_OK_CANCEL           = 5

;MessageBox-Response ...
; #GTK_RESPONSE_DELETE_EVENT=  MessageBox closed via Window-Close
; #GTK_RESPONSE_OK          =  MessageBox OK
; #GTK_RESPONSE_CANCEL      =  MessageBox Cancel
; #GTK_RESPONSE_YES         =  MessageBox Yes
; #GTK_RESPONSE_NO          =  MessageBox No

EnableExplicit

ImportC ""
	gtk_message_dialog_new(*parent.GtkWindow, flags, type, buttons, message_format.p-utf8, arguments.p-utf8, stop)
	gtk_window_set_title(*window.GtkWindow, title.p-utf8)
	g_signal_connect(*instance, detailed_signal.p-ascii, *c_handler, *data, destroy= 0, flags= 0) As "g_signal_connect_data"
	g_object_set_string(*object.GObject, property_name.p-utf8, data_.p-utf8, v= 0) As "g_object_set"
EndImport

; Object constants
#MainWin=0
#But1= 0
#But2= 1

#WinX=300
#WinY=200
#WinW=360
#WinH=100

Global.i gEvent, gQuit
Global   *gMessageRequester.GtkDialog


ProcedureC Callback_MessageBox(*widget.GtkWidget, user_data.l)
	Debug user_data;                               here's the close signal
	If user_data = #GTK_RESPONSE_DELETE_EVENT
		gtk_widget_destroy_(*widget);                close & destroy. Also possible is gtk_widget_hide(), gtk_widget_show()
		*gMessageRequester= #Null
	EndIf
EndProcedure

Procedure MessageBoxSimple(ParentWin, MbTitle.s, MbString.s, MbIcon, MbButtons)
	Protected *window.GtkWindow
	
	;non modal ...
	*gMessageRequester = gtk_message_dialog_new(WindowID(ParentWin), #GTK_DIALOG_DESTROY_WITH_PARENT, MbIcon, MbButtons, MbString, "", 0)
	*window= *gMessageRequester\window
	gtk_window_set_title(*window, MbTitle)
	
	g_signal_connect(*gMessageRequester, "response", @Callback_MessageBox(), *gMessageRequester)
	gtk_widget_show_all_(*gMessageRequester)
EndProcedure

;-
;- Main ...
If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "A simple non modal MessageRequester", #PB_Window_SystemMenu)
	ButtonGadget(#But1, 5,  5, 350, 26, "Open MessageRequester non modal with Icon")
	ButtonGadget(#But2, 5, 40, 350, 26, "Update Requester text ...")
	
	Repeat
		gEvent= WaitWindowEvent()

		Select gEvent

			Case #PB_Event_CloseWindow
				gQuit= #True
				If *gMessageRequester
					gtk_widget_destroy_(*gMessageRequester)
					Debug "'Requester' destroyed by closing parent window!"
				EndIf
			Case #PB_Event_Gadget

				Select EventGadget()

					Case #But1
						If Not *gMessageRequester
							MessageBoxSimple(#MainWin, "MessageRequester non modal", 
							                 "This MessageRequester can stay open and the contents kept up to date." + #LF$ + 
							                 "You can switch to the parent window." + #LF$ + 
							                 "Close it with the window closer!", 
							                 #GTK_MESSAGE_INFO, 
							                 #GTK_BUTTONS_OK_CANCEL)
						Else
							RunProgram("beep")
						EndIf
						
					Case #But2
						If *gMessageRequester
							g_object_set_string(*gMessageRequester, "text", "A new text for the Requester.")
						EndIf
				EndSelect

		EndSelect

	Until gQuit
EndIf
; IDE Options = PureBasic 5.40 LTS (Linux - x64)
; CursorPosition = 72
; FirstLine = 68
; Folding = -
; EnableUnicode
; EnableXP