﻿; Module/File:     StatusBar_AddButton.pb
; Function:        Adds Button to existing statusbar - Linux
; Author:          Omi, example from walker
; Date:            Sep. 14, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gtk_button_new_with_label(label.p-utf8)
	g_signal_connect(*instance, detailed_signal.p-ascii, *c_handler, *data, destroy= 0, flags= 0) As "g_signal_connect_data"
EndImport

; Object constants
#MainWin  = 0
#StatusBar = 0

#WinX=300
#WinY=200
#WinW=300
#WinH=200

Global.i gEvent, gQuit
Global *StatusBar, *SB_Button1.GtkWidget

ProcedureC Callback_NotifyEvent(*widget, *event.GdkEventCrossing, user_data); just 4 fun, not nesessary
	If *widget= *SB_Button1
		If user_data= 1
			Debug "New Statusbar-Button touched"
		EndIf
	EndIf
EndProcedure

ProcedureC Callback_ClickEvent(*widget, signal, user_data)
	If *widget= *SB_Button1
		Debug "New Statusbar-Button clicked, signal: " + Str(signal)
	EndIf
EndProcedure

If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "Statusbar add button", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	
	If CreateStatusBar(#StatusBar, WindowID(#MainWin))
		AddStatusBarField(150)
		StatusBarText(#StatusBar, 0, "StatusBar-Text")
		*StatusBar= StatusBarID(#StatusBar)
		
		*SB_Button1 = gtk_button_new_with_label("add gtk-button")
		gtk_button_set_relief_(*SB_Button1, #GTK_RELIEF_NONE);                     no border
		gtk_box_pack_start_(*StatusBar, *SB_Button1, #False, #False, 0)
		gtk_widget_show_(*SB_Button1)
		
		g_signal_connect(*SB_Button1, "enter-notify-event", @Callback_NotifyEvent(), 1, #Null, #Null); not nesessary
		g_signal_connect(*SB_Button1, "clicked", @Callback_ClickEvent(), #GDK_BUTTON_PRESS, #Null, #Null)
	EndIf
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
		EndSelect
		
	Until gQuit
EndIf
; IDE Options = PureBasic 5.40 LTS (Linux - x86)
; CursorPosition = 5
; Folding = -
; EnableUnicode
; EnableXP