﻿; Module/File:     StatusBar_AddButtonWithStockIcon.pb
; Function:        Adds button with stockicon to existing statusbar - Linux
; Author:          Omi/walker
; Date:            Dec. 19, 2014
; Version:         0.2; 64-Bit-Prob. fixed
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gtk_button_set_image(*button.GtkWidget, *image.GtkWidget)
	gtk_image_new_from_stock(stock_id.p-utf8, size); till gtk3.1
; 	gtk_image_new_from_icon_name(stock_id.p-utf8, size); replaces 'gtk_image_new_from_stock()', 2.6 up
	gtk_button_new_with_label(label.p-utf8)
	gtk_image_clear(*image.GtkWidget)
	g_signal_connect(*instance, detailed_signal.p-ascii, *c_handler, *data, destroy= 0, flags= 0) As "g_signal_connect_data"
EndImport


; Object constants
#MainWin  = 0
#StatusBar = 0

#WinX=300
#WinY=200
#WinW=350
#WinH=200

Global.i gEvent, gQuit
Global *StatusBar
Global *SB_Button1.GtkWidget, *image1.GtkWidget

ProcedureC Callback_ClickEvent(*Widget, signal, user_data)
	If *widget= *SB_Button1
		Debug "New Statusbar-Button clicked, signal: " + Str(signal)
	EndIf
EndProcedure

If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "Statusbar add button with stockicon", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	
	If CreateStatusBar(#StatusBar, WindowID(#MainWin))
		AddStatusBarField(150)
		StatusBarText(#StatusBar, 0, "StatusBar-Text")
		*StatusBar= StatusBarID(#StatusBar)
		
		*SB_Button1= gtk_button_new_with_label("gtk-find");                        new button
		gtk_box_pack_start_(*StatusBar, *SB_Button1, #False, #False, 0);           pack in statusbar
		gtk_button_set_relief_(*SB_Button1, #GTK_RELIEF_NONE);                     no border
		gtk_widget_show_(*SB_Button1);                                             show
		
		*image1= gtk_image_new_from_stock("gtk-find", #GTK_ICON_SIZE_MENU);        new stockicon  till gtk3.1
; 		*image1= gtk_image_new_from_icon_name("edit-find", #GTK_ICON_SIZE_MENU); new stockicon  from gtk2.6
		gtk_button_set_image(*SB_Button1, *image1)
		
		g_signal_connect(*SB_Button1, "clicked", @Callback_ClickEvent(), #GDK_BUTTON_PRESS, #Null, #Null); add signal
	EndIf
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
		EndSelect
		
	Until gQuit
EndIf

;free image-memory...
gtk_image_clear(*image1)
; IDE Options = PureBasic 5.40 LTS (Linux - x86)
; CursorPosition = 19
; Folding = -
; EnableUnicode
; EnableXP