﻿; Module/File:     StatusBar_AddStockImage.pb
; Function:        Adds stock-image to existing statusbar - Linux
; Author:          Omi/walker
; Date:            Sep. 14, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gtk_image_new_from_stock(stock_id.p-utf8, size); till gtk3.1
; 	gtk_image_new_from_icon_name(stock_id.p-utf8, size); replaces 'gtk_image_new_from_stock()', 2.6 up
	gtk_widget_set_visible(*widget.GtkWidget, visible)
	gtk_widget_get_visible(*widget.GtkWidget)
	gtk_image_clear(*image.GtkWidget)
EndImport

; Object constants
#MainWin  = 0
#StatusBar = 0

#WinX=300
#WinY=200
#WinW=350
#WinH=200

Global.i gEvent, gQuit
Global *StatusBar, *SB_Image1

If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "Statusbar show 'capslock-warning' w/o function", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	
	If CreateStatusBar(#StatusBar, WindowID(#MainWin))
		AddStatusBarField(150)
		StatusBarText(#StatusBar, 0, "StatusBar-Text")
		*StatusBar= StatusBarID(#StatusBar)
		
		*SB_Image1= gtk_image_new_from_stock("gtk-caps-lock-warning", #GTK_ICON_SIZE_MENU)
; 		*SB_Image1= gtk_image_new_from_icon_name("dialog-warning-symbolic", #GTK_ICON_SIZE_MENU)
		gtk_box_pack_start_(*StatusBar, *SB_Image1, #False, #False, 0)
		gtk_widget_show_(*SB_Image1)
		
		;no signal-connection -> displaywidget
	EndIf
	
	AddWindowTimer(#MainWin, 0, 1000)
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
				
			Case #PB_Event_Timer
				gtk_widget_set_visible(*SB_Image1, gtk_widget_get_visible(*SB_Image1) !1);                   blink on caps-lock-warning
		EndSelect
		
	Until gQuit
EndIf

RemoveWindowTimer(#MainWin, 0)

;free image-memory...
gtk_image_clear(*SB_Image1)
; IDE Options = PureBasic 5.40 LTS (Linux - x86)
; CursorPosition = 8
; EnableUnicode
; EnableXP