﻿; Module/File:     EditField_AsSearchEntry.pb
; Function:        Use a StringGadget as SearchEntry (higher Gtk2 too) - Linux
; Author:          Omi
; Date:            Feb. 14, 2016 ☑
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gtk_entry_set_icon_activatable(*entry.GtkEntry, icon_pos, activatable)
	gtk_entry_set_icon_from_icon_name(*entry.GtkEntry, icon_pos, icon_name.p-utf8)
	gtk_entry_set_icon_sensitive(*entry.GtkEntry, icon_pos, sensitive)
	g_signal_connect(*instance, detailed_signal.p-ascii, *c_handler, *pdata, destroy= 0, flags= 0) As "g_signal_connect_data"
	g_signal_emit_by_name(*instance, detailed_signal.p-utf8, signal, *callback, Null=0)
EndImport

Enumeration GtkEntryIconPosition
	#GTK_ENTRY_ICON_PRIMARY
	#GTK_ENTRY_ICON_SECONDARY
EndEnumeration

; Object constants
#Win_Main  = 0

#Main_Find = 0


Global.i gEvent, gEventWin, gQuit

ProcedureC Callback_EntrySearch(*widget.GtkWidget, signal, user_data)
	If *widget= GadgetID(#Main_Find)
		If signal = #GTK_ENTRY_ICON_PRIMARY
			Debug "Start search"
			;your search code ...
		ElseIf signal = #GTK_ENTRY_ICON_SECONDARY
			Debug "Delete search string (system function blocked, do it yourself ;-))"
			;your search string delete code ...
		EndIf
	EndIf
EndProcedure

Procedure Create_WinMain()
	If OpenWindow(#Win_Main, 300, 200, 430, 200, "StringGadget as SearchEntry", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
		
		TextGadget(#PB_Any,        5, 9, 210, 22, "StringGadget as SearchEntry:")
		;___
		StringGadget(#Main_Find, 220, 5, 200, 24, "")
		;add primary (left) icons to search-StringGadget ...
		gtk_entry_set_icon_from_icon_name(GadgetID(#Main_Find), #GTK_ENTRY_ICON_PRIMARY, "gtk-find")
		gtk_entry_set_icon_activatable(GadgetID(#Main_Find),    #GTK_ENTRY_ICON_PRIMARY, #True)
		gtk_entry_set_icon_sensitive(GadgetID(#Main_Find),      #GTK_ENTRY_ICON_PRIMARY, #True)
		;add secondary (right) icons to search-StringGadget ...
		gtk_entry_set_icon_from_icon_name(GadgetID(#Main_Find), #GTK_ENTRY_ICON_SECONDARY, "edit-delete")
		gtk_entry_set_icon_activatable(GadgetID(#Main_Find),    #GTK_ENTRY_ICON_SECONDARY, #True)
		gtk_entry_set_icon_sensitive(GadgetID(#Main_Find),      #GTK_ENTRY_ICON_SECONDARY, #True)
		
		g_signal_connect(GadgetID(#Main_Find), "icon_press", @Callback_EntrySearch(), #Null)
		;¯¯¯
		
		TextGadget(#PB_Any,        5, 35, 420, 40, "Try [Return] for Search and [Ctrl][Backsp.] for Delete too, if StringGadget is focussed.")
		
		AddKeyboardShortcut(#Win_Main, #PB_Shortcut_Return, #PB_Key_Return)
		AddKeyboardShortcut(#Win_Main, #PB_Shortcut_Control | #PB_Shortcut_Back, #PB_Key_Back); deactivate to activate keycode ;-)
	EndIf
EndProcedure

Create_WinMain()

Repeat
	gEvent= WaitWindowEvent()
	gEventWin= EventWindow()
	
	If gEventWin = #Win_Main
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
				
			Case #PB_Event_Menu
				
				Select EventMenu()
				
					Case #PB_Key_Return
						If GetActiveGadget() = #Main_Find
; 							Callback_EntrySearch(GadgetID(#Main_Find), 0, 0)
							g_signal_emit_by_name(GadgetID(#Main_Find), "icon_press", #GTK_ENTRY_ICON_PRIMARY, @Callback_EntrySearch())
						EndIf
						
					Case #PB_Key_Back
						If GetActiveGadget() = #Main_Find
; 							Callback_EntrySearch(GadgetID(#Main_Find), 1, 0)
							g_signal_emit_by_name(GadgetID(#Main_Find), "icon_press", #GTK_ENTRY_ICON_SECONDARY, @Callback_EntrySearch())
						EndIf
						
				EndSelect
				
		EndSelect
		
	EndIf
	
Until gQuit
; IDE Options = PureBasic 5.42 LTS (Linux - x86)
; CursorPosition = 65
; FirstLine = 48
; Folding = -
; EnableUnicode
; EnableXP