﻿; Module/File:     EditField_Completion.pb
; Function:        StringGadget InputCompleting - Linux
; Author:          Omi
; Date:            Oct. 12, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gtk_list_store_set(*list_store.GtkListStore, *iter.GtkTreeIter, column, value.p-utf8, term= -1)
EndImport

; Object constants
#MainWin= 0
#But1   = 0
#But2   = 1
#But3   = 2
#Txt1   = 3
#Strg1  = 4

#WinX= 300
#WinY= 200
#WinW= 300
#WinH= 120

Global.i gEvent, gQuit
Global.i gCounter


Procedure StringGadgetRemoveCompletion(*entry.GtkWidget)
	Protected *completion.GtkEntryCompletion= gtk_entry_get_completion_(*entry)
	;Protected *completion_model.GtkListStore= gtk_entry_completion_get_model_(*completion); #G_TYPE_STRING);
	gtk_entry_completion_set_model_(*completion, #Null)
EndProcedure

Procedure StringGadgetAddCompletion(*entry.GtkWidget, cList.s)
	Protected.i I
	Protected.s sEntry
	Protected   iter.GtkTreeIter
	If gtk_entry_get_completion_(*entry)
		StringGadgetRemoveCompletion(*entry)
	EndIf
	Protected   *completion.GtkEntryCompletion= gtk_entry_completion_new_();    Create the completion object
	Protected   *completion_model.GtkListStore= gtk_list_store_new_(1, 16 << 2); #G_TYPE_STRING);
	
	gtk_entry_set_completion_(*entry, *completion);                              Assign the completion To the entry
	g_object_unref_(*completion)
	
	For I= 1 To CountString(cList, "|")+ 1;                                      Create a tree model and use it as the completion model
		gtk_list_store_append_(*completion_model, @iter);
		gtk_list_store_set(*completion_model, @iter, 0, StringField(cList, I, "|")); Append one word
	Next I
	
	gtk_entry_completion_set_model_(*completion, *completion_model)
	g_object_unref_(*completion_model)
	
	gtk_entry_completion_set_text_column_(*completion, 0);                       Use model column 0 As the text column
EndProcedure


If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "Entry Completion", #PB_Window_SystemMenu |#PB_Window_ScreenCentered)
	OptionGadget(#But1, 5, 5, 200, 25, "Completion 1")
	OptionGadget(#But2, 5, 32, 200, 25, "Completion 2")
	OptionGadget(#But3, 5, 59, 200, 25, "no Completion")
	SetGadgetState(#But1, 1)
	
	TextGadget(#Txt1, 5, 89, 110, 25, "Write 'PureBasic'")
	StringGadget(#Strg1, 120, 85, 150, 25, "")
	
	StringGadgetAddCompletion(GadgetID(#Strg1), "PureBasic|PurePascal|PureC|PureAssembler"); Add String-Completion
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
			Case #PB_Event_Gadget
				Select EventGadget()
					Case #But1
						SetGadgetText(#Txt1, "Write 'PureBasic'")
						SetGadgetText(#Strg1, "")
						StringGadgetAddCompletion(GadgetID(#Strg1), "PureBasic|PurePascal|PureC|PureAssembler")
						SetActiveGadget(#Strg1)
					Case #But2
						SetGadgetText(#Txt1, "Write 'Meier'")
						SetGadgetText(#Strg1, "")
						StringGadgetAddCompletion(GadgetID(#Strg1), "Maier|Mair|Meier|Meyer")
						SetActiveGadget(#Strg1)
					Case #But3
						SetGadgetText(#Strg1, "")
						StringGadgetRemoveCompletion(GadgetID(#Strg1))
						SetActiveGadget(#Strg1)
				EndSelect
		EndSelect
		
	Until gQuit
EndIf
; IDE Options = PureBasic 5.40 LTS (Linux - x64)
; CursorPosition = 61
; FirstLine = 22
; Folding = -
; EnableUnicode
; EnableXP