﻿; Module/File:     EditField_CursorposSet&Get.pb
; Function:        StringGadget: get & set cursor position - Linux
; Author:          Omi
; Date:            Oct. 31, 2014
; Version:         0.3 changed demo
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	g_object_set(*object.GObject, property_name.p-utf8, *data, v= 0)
EndImport

; Object constants
#Win_Main = 0
#Button1  = 0
#Button2  = 1
#SpG      = 2
#String   = 3

Global.i gEvent, gQuit

Procedure Entry_SetCursor(Gadget, Pos)
	Debug "Prev. cursor pos: " + Str(gtk_editable_get_position_(GadgetID(Gadget)))
	gtk_editable_set_position_(GadgetID(Gadget), Pos)
EndProcedure

If OpenWindow(#Win_Main, 300, 200, 370, 200, "StringGadget-Cursorpos", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	TextGadget(#PB_Any,     10,  5, 200, 20, "set cursor to ...")
	ButtonGadget(#Button1,   5, 30, 100, 26, "Start")
	ButtonGadget(#Button2, 110, 30, 100, 26, "End")
	TextGadget(#PB_Any,    220, 35,  50, 20, "pos.:", #PB_Text_Right)
	SpinGadget(#SpG,       275, 30,  80, 26, -1, 50, #PB_Spin_Numeric)
	StringGadget(#String,   10, 70, 150, 25, "1234567890 ÄÖÜ")

	gtk_button_set_focus_on_click_(GadgetID(#Button1), #False);                      no focus for demo
	gtk_button_set_focus_on_click_(GadgetID(#Button2), #False);                       "
	g_object_set(gtk_settings_get_default_(), "gtk-entry-select-on-focus", #False);  no selection for demo
	SetActiveGadget(#String)
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
				
			Case #PB_Event_CloseWindow
				gQuit= #True
				
			Case #PB_Event_Gadget
				Select EventGadget()
						
					Case #Button1
						Entry_SetCursor(#String, 0);                      cursor before first char
						
					Case #Button2
						Entry_SetCursor(#String, -1);                     cursor after last char
						
					Case #SpG
						If EventType() = #PB_EventType_Change
							Entry_SetCursor(#String, GetGadgetState(#SpG)); cursor after char #
						EndIf
						
				EndSelect
				
		EndSelect
		
	Until gQuit
EndIf

; IDE Options = PureBasic 5.40 LTS (Linux - x86)
; CursorPosition = 59
; FirstLine = 24
; Folding = -
; EnableUnicode
; EnableXP