﻿; Module/File:     EditField_SysPopupReplacement.pb
; Function:        Replaces a rightclick-syspopup in StringGadget - Linux
; Author:          Omi
; Date:            Sep. 03, 2016 ☑
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

Enumeration #PB_Event_FirstCustomValue
	#Event_Rightclick
	#Event_Rightrelease
EndEnumeration

ImportC ""
	g_signal_connect(*instance, detailed_signal.p-ascii, *c_handler, *data, destroy= 0, flags= 0) As "g_signal_connect_data"
	g_signal_handler_find(*instance, mask, signal_id, detail, *closure, func, data_)
EndImport

; Object constants
#Win_Main= 0

#Bt1    = 0
#StG1   = 1

If CreatePopupMenu(0)
  MenuItem(1, "Cut")
  MenuItem(2, "Copy")
  MenuItem(3, "Paste")
  MenuBar()
  OpenSubMenu("Options")
    MenuItem(4, "Window...")
    MenuItem(5, "Gadget...")
  CloseSubMenu()
  MenuBar()
  MenuItem( 6, "Quit")
EndIf

Global.i gEvent, gQuit


ProcedureC Callback_EntryRSclick(*widget.GtkWidget, *Event.GdkEventButton, user_data)
	If user_data = #StG1
		If *Event\button = 3
			If *Event\type = #GDK_BUTTON_PRESS
				PostEvent(#Event_Rightclick, GetActiveWindow(), user_data)
				ProcedureReturn #True
			EndIf
		EndIf
	EndIf
EndProcedure
ProcedureC Callback_EntryRSrelease(*widget.GtkWidget, *Event.GdkEventButton, user_data)
	If user_data = #StG1
		If *Event\button = 3
			If *Event\type = #GDK_BUTTON_RELEASE
				PostEvent(#Event_Rightrelease, GetActiveWindow(), user_data)
				ProcedureReturn #True
			EndIf
		EndIf
	EndIf
EndProcedure

Procedure Entry_ConnectHandler(Gadget, *Callback)
	g_signal_connect(GadgetID(Gadget), "button-press-event", *Callback, Gadget, #Null, #Null)
	g_signal_connect(GadgetID(Gadget), "button-release-event", *Callback, Gadget, #Null, #Null)
EndProcedure

Procedure Entry_DisconnectHandler(Gadget, *Callback)
	Protected HandlerId
	Protected *text_view= GadgetID(Gadget)
	
	; find signalhandler for widget with callback ...
	HandlerId= g_signal_handler_find(*text_view, #G_SIGNAL_MATCH_FUNC, 0, 0, 0, *Callback, 0)
	If HandlerId
		g_signal_handler_disconnect_(*text_view, HandlerId);                             disconnect handler
	EndIf
EndProcedure

If OpenWindow(#Win_Main, 300, 200, 400, 200, "StringGadget-Popup-Replacement", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	ButtonGadget(#Bt1,  5,  5, 390,  28, "Replaces the RClick-popup in StringGadget", #PB_Button_Toggle)
	StringGadget(#StG1, 5, 35, 390, 26, "Rightclick me")
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
				
			Case #PB_Event_Gadget
				If EventGadget() = #Bt1
					If GetGadgetState(#Bt1)
						Entry_ConnectHandler(#StG1, @Callback_EntryRSclick());    Kills editor-sys-popup on rightclick
						Entry_ConnectHandler(#StG1, @Callback_EntryRSrelease());    Kills editor-sys-popup on rightrelease
					Else
						Entry_DisconnectHandler(#StG1, @Callback_EntryRSclick()); reinstalls editor-sys-popup on rightclick
						Entry_DisconnectHandler(#StG1, @Callback_EntryRSrelease()); reinstalls editor-sys-popup on rightrelease
					EndIf
				EndIf
				
			Case #Event_Rightclick
				If EventGadget() = #StG1
					Debug "Right singleclick in Editor " + Str(#StG1) + " w/o or w. own popup"
				EndIf
				
			Case #Event_Rightrelease
				If EventGadget() = #StG1
					DisplayPopupMenu(0, WindowID(#Win_Main))
				EndIf
				
		EndSelect
		
	Until gQuit
EndIf
; IDE Options = PureBasic 5.42 LTS (Linux - x86)
; CursorPosition = 57
; FirstLine = 51
; Folding = -
; EnableUnicode
; EnableXP