﻿; Module/File:     Editfield_SysPopupAttachment2.pb
; Function:        Extends or removes StringGadget-System-Popup on Rightclick with own MenuItems - Linux
; Author:          Omi
; Date:            Nov. 03, 2015
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	g_signal_connect(*instance, detailed_signal.p-ascii, *c_handler, *data, destroy= 0, flags= 0) As "g_signal_connect_data"
	gtk_menu_item_new_with_label(label.p-utf8)
	g_signal_handler_find(*instance, mask, signal_id, detail, *closure, func, data_)
EndImport

; Object constants
#MainWin= 0
#Bt1    = 0
; #Bt2    = 1
#Strg1  = 2

Global.i gEvent, gQuit

ProcedureC Callback_EntryPopupCall(*menuitem, user_data)
	Debug "Called attached PureBasic item " + Str(user_data)
EndProcedure

ProcedureC Callback_EntryAddPopupAppend(*entry, *popup, user_data)
	Protected *MenuItem1= gtk_menu_item_new_with_label("Attached PureBasic item 1")
	Protected *MenuItem2= gtk_menu_item_new_with_label("Attached PureBasic item 2")
	
	gtk_menu_shell_append_(*popup,  gtk_separator_menu_item_new_());                  MenuBar @ last Pos.
	gtk_menu_shell_append_(*popup, *MenuItem1);                                       MenuItem @ last Pos.
	gtk_menu_shell_append_(*popup, *MenuItem2)
	
	;link signals for every new item ...
	g_signal_connect(*MenuItem1, "activate", @Callback_EntryPopupCall(), 1)
	g_signal_connect(*MenuItem2, "activate", @Callback_EntryPopupCall(), 2)
	
	gtk_widget_show_all_(*popup)
EndProcedure

Procedure Entry_ConnectPopupAppend(Gadget, *Callback)
	g_signal_connect(GadgetID(Gadget), "populate-popup", *Callback, Gadget, #Null, #Null)
EndProcedure

Procedure Entry_DisconnectPopupAppend(Gadget, *Callback)
	Protected HandlerId
	Protected *entry= GadgetID(Gadget)
	
	;find signalhandler for widget with callback ...
	HandlerId= g_signal_handler_find(*entry, #G_SIGNAL_MATCH_FUNC, 0, 0, 0, *Callback, 0)
	If HandlerId
		g_signal_handler_disconnect_(*entry, HandlerId);                                disconnect handler
	EndIf
EndProcedure

If OpenWindow(#MainWin, 300, 200, 400, 150, "StringGadget w. extended popup", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	ButtonGadget(#Bt1,   5,   5, 390, 26, "Expand/disconnect StringGadgets system popup", #PB_Button_Toggle)
	TextGadget(#PB_Any,  5,  35, 390, 60, "A RightClick in the StringGadget calls the System-Entry-Popup." + #LF$ + "A Separator And 2 MenuItems should be attached" + #LF$ + "if Button is pressed." + " :-)")
	StringGadget(#Strg1, 5, 100, 390, 26, "rightclick me", #PB_String_ReadOnly)
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
				
			Case #PB_Event_Gadget
				Select EventGadget()
						
					Case #Bt1
						If GetGadgetState(#Bt1)
							Entry_ConnectPopupAppend(#Strg1, @Callback_EntryAddPopupAppend());    Add popup attachments
						Else
							Entry_DisconnectPopupAppend(#Strg1, @Callback_EntryAddPopupAppend()); Remove popup attachments
						EndIf
						
				EndSelect

		EndSelect
		
	Until gQuit
EndIf
; IDE Options = PureBasic 5.40 LTS (Linux - x64)
; CursorPosition = 8
; FirstLine = 9
; Folding = -
; EnableUnicode
; EnableXP