﻿; Module/File:     TG_AddClickEvent.pb
; Function:        Add click event on TextGadget, single, double, left, mid, right  - Linux
; Author:          Omi
; Date:            Sept. 22, 2014
; Version:         0.2
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	g_signal_connect(*instance, detailed_signal.p-ascii, *c_handler, *data, destroy= 0, flags= 0) As "g_signal_connect_data"
EndImport

; Object constants
#MainWin = 1
#Txt1    = 0
#Txt2    = 1

Global.i gEvent, gQuit
Global *gEventBox.GtkEventBox

ProcedureC Callback_LabelPressed(*widget.GtkWidget, *signal.GdkEventButton);                  callback for click on label
	If *widget= #Txt1
		If PeekI(*signal)= #GDK_BUTTON_PRESS
			Debug "clicked #1"
			Debug "Button: " + Str(*signal\button)
		EndIf
		If PeekI(*signal)= #GDK_2BUTTON_PRESS
			Debug "doubleclicked #1"
			Debug "Button: " + Str(*signal\button)
		EndIf
	EndIf
	If *widget= #Txt2
		If PeekI(*signal)= #GDK_BUTTON_PRESS
			Debug "clicked #2"
			Debug "Button: " + Str(*signal\button)
		EndIf
		If PeekI(*signal)= #GDK_2BUTTON_PRESS
			Debug "doubleclicked #2"
			Debug "Button: " + Str(*signal\button)
		EndIf
	EndIf
EndProcedure

If OpenWindow(#MainWin, 300, 200, 250, 200, "TextGadget click-signal", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	
	TextGadget(#Txt1, 5, 5, 190, 25, "click or doubleclick me #1")
	TextGadget(#Txt2, 5, 30, 190, 25, "click or doubleclick me #2")
	
	*gEventBox= gtk_widget_get_parent_(GadgetID(#Txt1));                     get TextGadget-EventBox
	gtk_widget_add_events_(*gEventBox, #GDK_BUTTON_PRESS_MASK);              add click event
	g_signal_connect(*gEventBox, "button-press-event", @Callback_LabelPressed(), #Txt1, #Null, #G_CONNECT_SWAPPED)
	
	*gEventBox= gtk_widget_get_parent_(GadgetID(#Txt2));                     get TextGadget-EventBox
	gtk_widget_add_events_(*gEventBox, #GDK_BUTTON_PRESS_MASK);              add click event
	g_signal_connect(*gEventBox, "button-press-event", @Callback_LabelPressed(), #Txt2, #Null, #G_CONNECT_SWAPPED)
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True

		EndSelect
		
	Until gQuit
EndIf
; IDE Options = PureBasic 5.42 LTS (Linux - x86)
; CursorPosition = 22
; FirstLine = 19
; Folding = -
; EnableUnicode
; EnableXP