﻿; Module/File:     TG_AddNotifyEvent.pb
; Function:        Add notify event on TextGadget - Linux
; Author:          Omi
; Date:            Oct. 14, 2014
; Version:         0.2
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	g_signal_connect(*instance, detailed_signal.p-ascii, *c_handler, *data, destroy= 0, flags= 0) As "g_signal_connect_data"
EndImport

; Object constants
#MainWin = 1
#Txt1    = 0
#Txt2    = 1

Global.i gEvent, gQuit
Global *eventbox.GtkEventBox

ProcedureC Callback_LabelNotify(*widget, *signal);                                callback for notify on label
	If *widget= #Txt1
		If PeekI(*signal)= #GDK_ENTER_NOTIFY
			Debug "notify #1"
		EndIf
	EndIf
	If *widget= #Txt2
		If PeekI(*signal)= #GDK_ENTER_NOTIFY
			Debug "notify #2"
		EndIf
	EndIf
EndProcedure

If OpenWindow(#MainWin, 300, 200, 250, 200, "TextGadget notify-signal", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	
	TextGadget(#Txt1, 5, 5, 190, 25, "Try Mouseover #1")
	TextGadget(#Txt2, 5, 30, 190, 25, "Try Mouseover #2")
	
	*eventbox= gtk_widget_get_parent_(GadgetID(#Txt1));                     get TextGadget-EventBox
	gtk_widget_add_events_(*eventbox, #GDK_ENTER_NOTIFY_MASK);              add notify event
	g_signal_connect(*eventbox, "enter-notify-event", @Callback_LabelNotify(), #Txt1, #Null, #G_CONNECT_SWAPPED)
	
	*eventbox= gtk_widget_get_parent_(GadgetID(#Txt2));                     get TextGadget-EventBox
	gtk_widget_add_events_(*eventbox, #GDK_ENTER_NOTIFY_MASK);              add notify event
	g_signal_connect(*eventbox, "enter-notify-event", @Callback_LabelNotify(), #Txt2, #Null, #G_CONNECT_SWAPPED)
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True

		EndSelect
		
	Until gQuit
EndIf
; IDE Options = PureBasic 5.40 LTS (Linux - x86)
; CursorPosition = 5
; Folding = -
; EnableUnicode
; EnableXP