﻿; Module/File:     TG_LabelAddLink_2.pb
; Function:        Add web and other links to TextGadget - Linux
; Author:          Omi
; Date:            Dec. 29, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	g_signal_connect(*instance, detailed_signal.p-ascii, *c_handler, *data, destroy= 0, flags= 0) As "g_signal_connect_data"
	gtk_label_set_markup(*label.GtkWidget, markup.p-utf8)
	gtk_widget_set_tooltip_text(*widget.GtkWidget, text.p-utf8)
EndImport

; Object constants
#MainWin= 0
#Text1   = 0
#Text2   = 1
#Text3   = 2
#Text4   = 3


#WinX=300
#WinY=200
#WinW=300
#WinH=200

Global.i gEvent, gQuit

ProcedureC Callback_TextGadgetLink(*gadget, *uri, user_data)
	Protected.s S= PeekS(*uri, -1, #PB_UTF8)

	If S= "http://www.chabba.de/"
		Debug "open URI"
	ElseIf S= "open_msgbox"
		MessageRequester("Label-link-demo", "Here you can call any function!")
	EndIf
EndProcedure


Procedure.s TextGadgetAddLink(Gadget, Link.s, Text.s)
	Protected *widget.GtkText= GadgetID(Gadget)
	Protected.s S= "<a href=" + #DQUOTE$ + Link + #DQUOTE$ + ">" + Text + "</a>"
	ProcedureReturn S
EndProcedure

Procedure TextGadgetActivateLink(Gadget, Link.s)
	Protected *widget.GtkText= GadgetID(Gadget)
	gtk_label_set_use_markup_(*widget, #True)
	If Link<> ""
		gtk_widget_set_tooltip_text(*widget, Link)
	EndIf
	g_signal_connect(*widget, "activate-link", @Callback_TextGadgetLink(), 0)
EndProcedure

If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "TextGadget - with link ", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	TextGadget(#Text1, 5, 5, 290, 80, "")
	SetGadgetText(#Text1, "Hier ein etwas längeres TextGadget mit Zeilenumbruch und einem " + 
	                      TextGadgetAddLink(#Text1, "http://www.chabba.de/", "URI-Link") + 
	                      " innerhalb des Textes! Die URI kann als Tooltip gesetzt falls nur " + 
	                      "1 Link angelegt wird. Zusätzlich könnte ein " + TextGadgetAddLink(#Text1, "open_msgbox", "other-link") + 
	                      " gesetzt werden.")
	TextGadgetActivateLink(#Text1, "");          activate without tooltip (=""), because of 2 links can't get different tooltips. Otherwise take your URI
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
		EndSelect
		
	Until gQuit
EndIf
; IDE Options = PureBasic 5.40 LTS (Linux - x86)
; CursorPosition = 41
; FirstLine = 31
; Folding = -
; EnableUnicode
; EnableXP