﻿; Module/File:     TG_MultiLineJustify_.pb
; Function:        Correct multiline justification for textgadgets - Linux
; Author:          Omi
; Date:            Mar. 17, 2015
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

; #PB_Text_Center kill auto-line-wrapping
; without #PB_Text_Center -> auto-line-wrapping is ok
; additional API-line-wrapping and ...set_justify centers at right border (only relativ)
; + additional '...set_width_chars' correct centering in allocated width

EnableExplicit

ImportC ""
; 	gtk_misc_set_alignment ( *misc.GtkMisc, xalign.f, yalign.f)
; 	gtk_widget_set_hexpand ( *widget.GtkWidget,  expand)
; 	gtk_widget_set_allocation ( *widget.GtkWidget, *allocation.GtkAllocation)
; 	gtk_widget_get_allocation (*widget.GtkWidget, *allocation.GtkAllocation)
	gtk_label_set_line_wrap_mode(*label.GtkLabel, wrap_mode)
	gtk_label_set_width_chars ( *label.GtkLabel, n_chars)
EndImport

; Object constants
#Win_Main = 0

#Text1    = 0
#Text2    = 1
#Text3    = 2
#Text4    = 3
#Text5    = 4
#Text6    = 5

#WinX= 300
#WinY= 200
#WinW= 240
#WinH= 280


Enumeration PangoWrapMode
	#PANGO_WRAP_WORD
	#PANGO_WRAP_CHAR
	#PANGO_WRAP_WORD_CHAR
EndEnumeration

Global.i gEvent, gEventWin, gQuit


If OpenWindow(#Win_Main, #WinX, #WinY, #WinW, #WinH, "TextGadget justify", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	
	TextGadget(#Text1, 5,   5, 230, 22, "A centered short text in one line.", #PB_Text_Center | #PB_Text_Border);                                singleline okay
	TextGadget(#Text2, 5,  30, 230, 42, "A longer centered text in more lines with auto. PB line wrapping.", #PB_Text_Center | #PB_Text_Border);  no centering, no wrapping
	TextGadget(#Text3, 5,  75, 230, 42, "A longer left justified text in more lines with auto. PB line wrapping.", #PB_Text_Border);              left alignment okay
	TextGadget(#Text4, 5, 120, 230, 42, "A longer centered text in more lines with API-line-wrapping.", #PB_Text_Center | #PB_Text_Border);       only relative centering
	TextGadget(#Text5, 5, 165, 230, 42, "A longer centered text in more lines with API-line wrapping and API-Help.", #PB_Text_Center | #PB_Text_Border); ok for 1 and more lines
	TextGadget(#Text6, 5, 215, 230, 42, "A longer right justified text in more lines with API-line wrapping and API-Help.", #PB_Text_Right | #PB_Text_Border); ok for 1 and more lines
	
	;gtk_label_set_justify_(GadgetID(#Text3), #GTK_JUSTIFY_CENTER)
	gtk_label_set_justify_(GadgetID(#Text4), #GTK_JUSTIFY_CENTER)
	gtk_label_set_line_wrap_(GadgetID(#Text4), #True)
	gtk_label_set_line_wrap_mode(GadgetID(#Text4), #PANGO_WRAP_WORD)
	
	;*** workaround for multiline abs. centered text within room, not only relative ...
	gtk_label_set_justify_(GadgetID(#Text5), #GTK_JUSTIFY_CENTER)
	gtk_label_set_line_wrap_(GadgetID(#Text5), #True)
	gtk_label_set_line_wrap_mode(GadgetID(#Text5), #PANGO_WRAP_WORD)
	gtk_label_set_width_chars (GadgetID(#Text5), 32)
	
	;*** workaround for multiline abs. right justified text within room, not only relative ...
	gtk_label_set_justify_(GadgetID(#Text6), #GTK_JUSTIFY_RIGHT)
	gtk_label_set_line_wrap_(GadgetID(#Text6), #True)
	gtk_label_set_line_wrap_mode(GadgetID(#Text6), #PANGO_WRAP_WORD)
	gtk_label_set_width_chars (GadgetID(#Text6), 32)
	
	Repeat
		gEvent= WaitWindowEvent()
		gEventWin= EventWindow()
		
		If gEventWin = #Win_Main
			
			Select gEvent
					
				Case #PB_Event_CloseWindow
					gQuit= #True
					
				Case #PB_Event_Gadget
					
			EndSelect
			
		EndIf
		
	Until gQuit
	
EndIf
; IDE Options = PureBasic 5.41 LTS (Linux - x64)
; CursorPosition = 15
; FirstLine = 6
; EnableUnicode
; EnableXP