﻿; Module/File:     TG_PathDepthMax.pb
; Function:        Get max. depth of TreeGadget - Linux gtk2/gtk3
; Author:          Omi
; Date:            Mar. 17, 2015
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

; Object constants
#MainWin= 0
#TG1= 0
#SG1= 1

#WinX= 200
#WinY= 200
#WinW= 450
#WinH= 330

Global.i gEvent, gQuit

Structure TREEVIEWDATA
	Path.l
	ItemIndex.l
	PathString.s
	DepthMax.l
	Pathes.l
EndStructure
Global TreeForEach_Data.TREEVIEWDATA

ProcedureC Callback_TreeForEachDepth(*Model, *Path, *Iter, *userdata.TREEVIEWDATA)
	Protected.l Depth= gtk_tree_path_get_depth_(*Path)
	If *userdata\ItemIndex < *userdata\Pathes
		*userdata\ItemIndex + 1
		If Depth> *userdata\DepthMax
			*userdata\DepthMax= Depth
		EndIf
		ProcedureReturn #False
	Else
		ProcedureReturn #True
	EndIf
EndProcedure

Procedure.i TV_MaxPathDepth(Gadget)
	Protected iter.GtkTreeIter
	Protected tPath
	Protected *tModel= gtk_tree_view_get_model_(GadgetID(Gadget))
	
	gtk_tree_model_get_iter_first_(*tModel, @iter)
	tPath= gtk_tree_model_get_path_(*tModel, iter)
	If tPath
		TreeForEach_Data\ItemIndex   = 0
		TreeForEach_Data\Path        = tPath
		TreeForEach_Data\Pathes      = CountGadgetItems(Gadget)
		gtk_tree_model_foreach_(*tModel, @Callback_TreeForEachDepth(), @TreeForEach_Data)
		gtk_tree_path_free_(tPath)
	EndIf
	ProcedureReturn TreeForEach_Data\DepthMax
EndProcedure

; *****

Procedure CreateWindow_Main()
	Protected.i I
	
	If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "TreeGadget - get max. depth", #PB_Window_SystemMenu)
		TreeGadget(#TG1, 10, 30, 430, 280)
		
		For I = 0 To 10
			AddGadgetItem (#TG1, -1, "Normal Item "+Str(I), 0, 0)
			AddGadgetItem(#TG1, -1, "Sub-Item 0", 0, 1)
			AddGadgetItem(#TG1, -1, "Sub-Item 1", 0, 1)
			AddGadgetItem(#TG1, -1, "Sub-Item 2", 0, 1)
			AddGadgetItem(#TG1, -1, "Sub-Item 3", 0, 1)
			If I= 2
				AddGadgetItem(#TG1, -1, "Sub-Item 30", 0, 2)
				AddGadgetItem(#TG1, -1, "Sub-Item 31", 0, 2)
					AddGadgetItem(#TG1, -1, "Sub-Item 310", 0, 3)
					AddGadgetItem(#TG1, -1, "Sub-Item 311", 0, 3)
						AddGadgetItem(#TG1, -1, "Sub-Item 3110", 0, 4)
						AddGadgetItem(#TG1, -1, "Sub-Item 3111", 0, 4)
			EndIf
		Next I
	EndIf
	gtk_tree_view_expand_all_(GadgetID(#TG1))
EndProcedure

CreateWindow_Main()

Debug "max. Path-Depth: " + Str(TV_MaxPathDepth(#TG1))

Repeat
	gEvent= WaitWindowEvent()
	
	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
			
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.40 LTS (Linux - x86)
; CursorPosition = 1
; Folding = -
; EnableUnicode
; EnableXP