﻿; Module/File:     TV_PathString2ItemIndex.pb
; Function:        Get TreeGadget-PB-Item-Index from TreeView-PathString - Linux gtk2/gtk3
; Author:          Omi
; Date:            Mar. 17, 2015
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gtk_tree_model_get_iter_from_string(*tree_model, *iter.GtkTreeIter, path_string.p-utf8)
EndImport

; Object constants
#MainWin= 0
#TG1= 0
#SG1= 1

#WinX= 200
#WinY= 200
#WinW= 450
#WinH= 330

Global.i gEvent, gQuit
Global.i gPathIndex
Global.s gPathString

Structure TREEVIEWDATA
	Path.l
	SearchIndex.l
	ItemIndex.l
	PathString.s
EndStructure
Global TreeForEach_Data.TREEVIEWDATA


ProcedureC Callback_TreeForEach2Index(*Model, *Path, *Iter, *userdata.TREEVIEWDATA);!
	If PeekS(gtk_tree_path_to_string_(*Path), -1 ,#PB_UTF8)= *userdata\PathString
		ProcedureReturn #True
	Else
		*userdata\ItemIndex + 1
		ProcedureReturn #False   
	EndIf
EndProcedure

Procedure.i TV_ItemIndexFromPathString(Gadget, PathString.s);!
	Protected iter.GtkTreeIter
	Protected tPath
	Protected *tModel= gtk_tree_view_get_model_(GadgetID(Gadget))

	gtk_tree_model_get_iter_first_(*tModel, @iter)
	tPath= gtk_tree_model_get_path_(*tModel, iter)
	If tPath
		TreeForEach_Data\ItemIndex  = 0
		TreeForEach_Data\Path       = tPath
		TreeForEach_Data\PathString = PathString
		gtk_tree_model_foreach_(*tModel, @Callback_TreeForEach2Index(), TreeForEach_Data)
		gtk_tree_path_free_(tPath); ???
	EndIf
	If TreeForEach_Data\ItemIndex>= CountGadgetItems(Gadget)
		TreeForEach_Data\ItemIndex= -1
	EndIf
	ProcedureReturn TreeForEach_Data\ItemIndex
EndProcedure

; *****

Procedure CreateWindow_Main()
	Protected.i I
	
	If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "TreeGadget - ItemIndex from PathString", #PB_Window_SystemMenu)
		TreeGadget(#TG1, 10, 30, 430, 280)
		
		For I = 0 To 10
			AddGadgetItem (#TG1, -1, "Main Item "+Str(I), 0, 0)
			AddGadgetItem(#TG1, -1, "Sub-Item 0", 0, 1)
			AddGadgetItem(#TG1, -1, "Sub-Item 1", 0, 1)
			AddGadgetItem(#TG1, -1, "Sub-Item 2", 0, 1)
			AddGadgetItem(#TG1, -1, "Sub-Item 3", 0, 1)
			If I= 2
				AddGadgetItem(#TG1, -1, "Sub-Item 30", 0, 2)
				AddGadgetItem(#TG1, -1, "Sub-Item 31", 0, 2)
					AddGadgetItem(#TG1, -1, "Sub-Item 310", 0, 3)
					AddGadgetItem(#TG1, -1, "Sub-Item 311", 0, 3)
			EndIf
		Next I
	EndIf
EndProcedure

CreateWindow_Main()

gPathString= "2:3:1:1"; "10:3"
gPathIndex= TV_ItemIndexFromPathString(#TG1, gPathString)
SetGadgetState(#TG1, gPathIndex)
Debug "PB-Index '2:3:1:1' is item: " + Str(gPathIndex)

Repeat
	gEvent= WaitWindowEvent()
	
	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
			
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.40 LTS (Linux - x86)
; CursorPosition = 8
; Folding = -
; EnableUnicode
; EnableXP