﻿; Module/File:     TV_SelectItemFromPathString.pb
; Function:        Select TreeView-Item from Path-String - Linux gtk2/gtk3
; Author:          Omi
; Date:            Mar. 17, 2015
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gtk_tree_model_get_iter_from_string(*tree_model, *iter.GtkTreeIter, path_string.p-utf8)
EndImport

; Object constants
#MainWin= 0
#TG1= 0
#SG1= 1

#WinX= 200
#WinY= 200
#WinW= 450
#WinH= 330

Global.i gEvent, gQuit
Global.s gPathString


Procedure TV_SelectItemFromPathString(Gadget, PathString.s)
	Protected iter.GtkTreeIter
	Protected tPath
	Protected *tModel= gtk_tree_view_get_model_(GadgetID(Gadget))
	Protected *tSelection

	If gtk_tree_model_get_iter_from_string(*tModel, @iter, PathString)
		tPath= gtk_tree_model_get_path_(*tModel, @iter)
		If Not gtk_tree_view_row_expanded_(GadgetID(Gadget), tPath)
			gtk_tree_view_expand_to_path_(GadgetID(Gadget), tPath)
		EndIf
		
		*tSelection= gtk_tree_view_get_selection_(GadgetID(Gadget))
		gtk_tree_selection_select_path_(*tSelection, tPath)
		;gtk_tree_view_set_cursor_(GadgetID(Gadget), tPath, #Null, #False);        activate: scroll to selection
		;gtk_tree_selection_select_iter_(*tSelection, @iter)
		gtk_tree_path_free_(tPath); ???
	EndIf
EndProcedure


Procedure CreateWindow_Main()
	Protected.i I
	
	If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "TreeGadget - Selection from PathString", #PB_Window_SystemMenu)
		TextGadget(#PB_Any, 5, 5, 200, 22, "Select 2:3:1:1")
		TreeGadget(#TG1, 10, 30, 430, 280)
		
		For I = 0 To 10
			AddGadgetItem (#TG1, -1, "Normal Item "+Str(I), 0, 0)
			AddGadgetItem(#TG1, -1, "Sub-Item 0", 0, 1)
			AddGadgetItem(#TG1, -1, "Sub-Item 1", 0, 1)
			AddGadgetItem(#TG1, -1, "Sub-Item 2", 0, 1)
			AddGadgetItem(#TG1, -1, "Sub-Item 3", 0, 1)
			If I= 2
				AddGadgetItem(#TG1, -1, "Sub-Item 30", 0, 2)
				AddGadgetItem(#TG1, -1, "Sub-Item 31", 0, 2)
					AddGadgetItem(#TG1, -1, "Sub-Item 310", 0, 3)
					AddGadgetItem(#TG1, -1, "Sub-Item 311", 0, 3)
			EndIf
		Next I
	EndIf
EndProcedure

CreateWindow_Main()

gPathString= "2:3:1:1"; "10:3"; 
TV_SelectItemFromPathString(#TG1, gPathString)


Repeat
	gEvent= WaitWindowEvent()
	
	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
			
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.40 LTS (Linux - x86)
; CursorPosition = 8
; Folding = -
; EnableUnicode
; EnableXP