﻿; Module/File:     TG_SelectMultiple.pb
; Function:        Multiple selections in TreeViews - Linux gtk2/gtk3
; Author:          Omi
; Date:            Jan. 30, 2016 ☑
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

; Object constants
#MainWin= 0
#TG1= 0
#Bt= 1

#WinX= 200
#WinY= 200
#WinW= 300
#WinH= 400

Global.i gEvent, gQuit
Global.s Dim Zeile(20)


Procedure TV_SetSelectionMode(Gadget, Mode)
	gtk_tree_selection_set_mode_(gtk_tree_view_get_selection_(GadgetID(Gadget)), Mode)
EndProcedure

Procedure CreateWindow_Main()
	Protected.i I, O
	Protected.s S

	If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "TreeGadget select mode", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
		TreeGadget(#TG1, 5, 35, 290, 355, #PB_ListIcon_AlwaysShowSelection)
		ButtonGadget(#Bt, 5, 5, 290, 20, "Multi Select", #PB_Button_Toggle)
		
		Restore FamilyMembers
		For I= 0 To 4
			Read.s S
			AddGadgetItem(#TG1, -1, S, #Null, 0)
			For O= 0 To 2
				Read.s S
				AddGadgetItem(#TG1, -1, S, #Null, 1)
			Next O
		Next I
		
		GadgetToolTip(#Bt, "Use [Ctrl] with leftclick!")
		gtk_tree_view_expand_all_(GadgetID(#TG1))
	EndIf
EndProcedure

CreateWindow_Main()

Repeat
	gEvent= WaitWindowEvent()
	
	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
			
		Case #PB_Event_Gadget
			If EventGadget() = #Bt
				If GetGadgetState(#Bt)
					TV_SetSelectionMode(#TG1, #GTK_SELECTION_MULTIPLE)
				Else
					TV_SetSelectionMode(#TG1, #GTK_SELECTION_SINGLE)
				EndIf
			EndIf
	EndSelect
	
Until gQuit
End

DataSection
	FamilyMembers:
	Data.s "Bauer", "Adam", "Bert", "David",
	       "Müller", "Ernst", "Franz", "Georg", 
	       "Groß", "Herrmann", "Josef", "Klaus",
	       "König", "Ludwig", "Manfred", "Norbert",
	       "Schneider", "Otto", "Paul", "Bärbel"
EndDataSection
; IDE Options = PureBasic 5.42 LTS (Linux - x86)
; CursorPosition = 46
; FirstLine = 24
; Folding = -
; EnableUnicode
; EnableXP