﻿; Module/File:     TV_SelectionIsNode.pb
; Function:        Query whether selected item is a 'node' - Linux gtk2/gtk3
; Author:          Omi
; Date:            Jan. 30, 2016 ☑
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

; Object constants
#MainWin= 0
#TG1= 0

Global.i gEvent, gQuit

Procedure.i TV_SelectionIsNode(Gadget);                        path-string from TV-item, native
	Protected iter.GtkTreeIter
	Protected tModel
	Protected *tSelection= gtk_tree_view_get_selection_(GadgetID(Gadget))
	
	gtk_tree_selection_get_selected_(*tSelection, @tModel, @iter)
	ProcedureReturn gtk_tree_model_iter_has_child_(tModel, iter)
EndProcedure

; *****

Procedure CreateWindow_Main()
	Protected.i I
	
	If OpenWindow(#MainWin, 200, 200, 450, 330, "TreeGadget - Selection is node?", #PB_Window_SystemMenu)
		TextGadget(#PB_Any, 5, 5, 400, 22, "Click on items to query 'node'-state ...")
		TreeGadget(#TG1, 10, 30, 430, 280)
		
		For I = 0 To 2
			AddGadgetItem (#TG1, -1, "Node Item "+Str(I), 0, 0)
			AddGadgetItem(#TG1, -1, "Sub-Item " + Str(I) + ":0", 0, 1)
			AddGadgetItem(#TG1, -1, "Sub-Item " + Str(I) + ":1", 0, 1)
			AddGadgetItem(#TG1, -1, "Sub-Item " + Str(I) + ":2", 0, 1)
			AddGadgetItem(#TG1, -1, "Sub-node " + Str(I) + ":3", 0, 1)
			If I= 1
				AddGadgetItem(#TG1, -1, "Sub-Item 1:3:0", 0, 2)
				AddGadgetItem(#TG1, -1, "Sub-node 1:3:1", 0, 2)
					AddGadgetItem(#TG1, -1, "Sub-Item 1:3:1:0", 0, 3)
					AddGadgetItem(#TG1, -1, "Sub-Item 1:3:1:1", 0, 3)
			EndIf
		Next I
	EndIf
	gtk_tree_view_expand_all_(GadgetID(#TG1))
EndProcedure

CreateWindow_Main()

Repeat
	gEvent= WaitWindowEvent()
	
	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
			
		Case #PB_Event_Gadget
			If EventGadget() = #TG1
				If EventType() = #PB_EventType_Change;#PB_EventType_LeftClick
					Debug "Clicked item is node: " + Str(TV_SelectionIsNode(#TG1))
				EndIf
			EndIf
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.42 LTS (Linux - x86)
; CursorPosition = 10
; FirstLine = 4
; Folding = -
; EnableUnicode
; EnableXP