﻿; Module/File:     Window_GetDisplay.pb
; Function:        Show display data from current window - Linux gtk2/gtk3
; Author:          Omi
; Date:            Nov. 03, 2014
; Version:         0.2 updt. gtk3, 0.3 added functions
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gdk_window_get_display(*Window)
	gdk_display_supports_shapes(*display.GdkDisplay)
	gdk_display_get_default_cursor_size(*display.GdkDisplay)
	gdk_display_get_maximal_cursor_size(*display.GdkDisplay, *width, *height)
	gdk_display_supports_input_shapes(*display.GdkDisplay)
	gdk_display_supports_cursor_color(*display.GdkDisplay)
	gdk_display_supports_cursor_alpha(*display.GdkDisplay)
	gtk_widget_get_window(*widget.GtkWidget)
EndImport

; Object constants
#MainWin  = 0
#But1 = 0

#WinX=300
#WinY=200
#WinW=200
#WinH=200

Global.i gEvent, gQuit
Global   *display.GdkDisplay
Global.i gCWidth, gCHeight


Procedure.i GetGdkWindow(Window)
	ProcedureReturn gtk_widget_get_window(WindowID(Window))
EndProcedure

Procedure GetWindowDisplay(Window)
	ProcedureReturn gdk_window_get_display(GetGdkWindow(Window))
EndProcedure

If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "Get display data", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_MaximizeGadget | #PB_Window_MinimizeGadget)
	ButtonGadget(#But1, 5, 5, 190, 26, "Debug display data")
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
				
			Case #PB_Event_CloseWindow
				gQuit= #True
				
			Case #PB_Event_Gadget
				If EventGadget()= #But1
					*display= GetWindowDisplay(#MainWin)
					Debug "Display-adress                      : " + Str(*display)
					Debug "Display-name                        : " + PeekS(gdk_display_get_name_(*display), -1, #PB_UTF8)
					Debug "Display-number                      : " + gdk_display_get_n_screens_(*display)
					Debug "Display window shape possible       : " + gdk_display_supports_shapes(*display)
					Debug "Display window input shape possible : " + gdk_display_supports_input_shapes(*display)
					Debug "Display cursor default size (pix)   : " + gdk_display_get_default_cursor_size(*display)
					gdk_display_get_maximal_cursor_size(*display, @gCWidth, @gCHeight)
					Debug "Display cursor max size (pix)       : " + gCWidth + "x" + gCHeight
					Debug "Display multicolored cursor possible: " + gdk_display_supports_cursor_color(*display)
					Debug "Display cursor has alpha channel    : " + gdk_display_supports_cursor_alpha(*display)
				EndIf
				
		EndSelect
		
	Until gQuit
EndIf
; IDE Options = PureBasic 5.51 Beta 1 (Linux - x86)
; CursorPosition = 13
; Folding = -
; EnableXP
; EnableUnicode