﻿; Module/File:     Window_GetGdkWindowStack.pb
; Function:        Get Gdk windows stack w. X11-No - Linux gtk3
; Author:          Omi
; Date:            Mar. 17, 2016 ☑
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.4x
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gdk_screen_get_window_stack(*screen.GdkScreen)
	gdk_window_is_shaped(*window)
	gtk_widget_get_window(*widget.GtkWidget)
	gdk_x11_window_get_desktop(*window)
	gdk_x11_window_get_xid(*window)
EndImport

; Object constants
#Win_Main  = 0


Global.i gEvent, gEventWin, gQuit

Structure SCREENWINDOWS
	xid.s
	title.s
EndStructure
Global NewList ScreenWindowList.SCREENWINDOWS()

Procedure Screen_GetWindowStack()
	Protected   *gList0.GList  = gdk_screen_get_window_stack(gdk_display_get_default_screen_(gdk_display_get_default_()))
	Protected   *gList.GList   = *gList0
	Protected   *window, *decorations
	Protected.i x_orig, y_orig, width, height, rect.GdkRectangle, gpointer
	
	If *gList
		Repeat
			*window= *glist\data
			gdk_window_get_user_data_(*window, @gpointer)
			If gpointer
				Debug PeekS(gtk_window_get_title_(gpointer), -1, #PB_UTF8)
			EndIf
			gdk_window_get_frame_extents_(*window, @rect)
			gdk_window_get_decorations_(*window, @*decorations)
			Debug "XID        : " + "#"+Hex(gdk_x11_window_get_xid(*window))
			Debug "GdkWindow  : " + Str(*window)
			Debug "outer-size : " + Str(rect\x) + ", " + Str(rect\y) + ", " + Str(rect\width) + ", " + Str(rect\height)
			Debug "decorations: " + Str(*decorations)
			Debug "on monitor : " + Str(gdk_screen_get_monitor_at_window_(gdk_screen_get_default_(), *window))
			Debug "on desktop : " + Str(gdk_x11_window_get_desktop(*window))
			Debug ""
			
			*gList= *gList\next
			g_object_unref_(*window)
		Until *gList = 0
	EndIf
	g_list_free_(*gList0);      free list
EndProcedure

Procedure Create_WinMain()
	If OpenWindow(#Win_Main, 300, 200, 500, 200, "GdkWindow stack", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
		ButtonGadget(0, 5, 5, 200, 26, "List windows on screen ...")
	EndIf
EndProcedure

Create_WinMain()


Repeat
	gEvent= WaitWindowEvent()
	gEventWin= EventWindow()
	
	If gEventWin = #Win_Main
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
				
			Case #PB_Event_Gadget
				If EventGadget() = 0
					Screen_GetWindowStack()
				EndIf
				
		EndSelect
		
	EndIf
	
Until gQuit
; IDE Options = PureBasic 5.42 LTS (Linux - x86)
; CursorPosition = 8
; Folding = -
; EnableUnicode
; EnableXP