﻿; Module/File:     Window_GetScreenData.pb
; Function:        Show some screen data from current window - Linux gtk2/gtk3
; Author:          Omi
; Date:            Nov. 03, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gtk_widget_get_window(*widget.GtkWidget)
EndImport

ImportC ""
	gdk_window_get_screen(*Window)
	gdk_screen_get_monitor_height_mm(*screen.GdkScreen, monitor_num)
	gdk_screen_get_monitor_width_mm(*screen.GdkScreen, monitor_num)
	gdk_screen_get_monitor_plug_name(*screen.GdkScreen, monitor_num)
EndImport

; Object constants
#MainWin  = 0
#But1 = 0

#WinX=300
#WinY=200
#WinW=200
#WinH=200

Global.i gEvent, gQuit
Global *screen.GdkScreen


Procedure.i GetGdkWindow(Window)
	ProcedureReturn gtk_widget_get_window(WindowID(Window))
EndProcedure

Procedure GetWindowScreen(Window)
	ProcedureReturn gdk_window_get_screen(GetGdkWindow(Window))
EndProcedure

If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "Get Screen data", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_MaximizeGadget | #PB_Window_MinimizeGadget)
	ButtonGadget(#But1, 5, 5, 190, 26, "Debug screen data")
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
			Case #PB_Event_Gadget
				If EventGadget()= #But1
					*screen= GetWindowScreen(#MainWin)
					Debug "Screen-adress                  : " + Str(*screen)
					Debug "Screen-index                   : " + Str(gdk_screen_get_number_(*screen))
					Debug "Display-Adress from Screen     : " + Str(gdk_screen_get_display_(*screen))
					Debug "Screen width                   : " + Str(gdk_screen_get_width_(*screen))
					Debug "Screen height                  : " + Str(gdk_screen_get_height_(*screen))
					Debug "Screen width [mm]              : " + Str(gdk_screen_get_width_mm_(*screen))
					Debug "Screen height [mm]             : " + Str(gdk_screen_get_height_mm_(*screen))
					Debug "Monitor number from Screen     : " + Str(gdk_screen_get_n_monitors_(*screen))
					Debug "Monitor width [mm] from Screen : " + Str(gdk_screen_get_monitor_width_mm(*screen, 0))
					Debug "Monitor height [mm] from Screen: " + Str(gdk_screen_get_monitor_height_mm(*screen, 0))
					Debug "Monitor plug name from Screen  : " + PeekS(gdk_screen_get_monitor_plug_name(*screen, 0), -1, #PB_Ascii)
				EndIf
		EndSelect
		
	Until gQuit
EndIf
; IDE Options = PureBasic 5.40 LTS (Linux - x86)
; CursorPosition = 37
; FirstLine = 23
; Folding = -
; EnableUnicode
; EnableXP