﻿; Module/File:     Window_IsVisible.pb
; Function:        Gets window-visibility - Linux gtk2/gtk3
; Author:          Omi
; Date:            Sep. 20, 2014
; Version:         0.2 updt. gtk3
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------

EnableExplicit

ImportC ""
	gtk_widget_get_window(*widget.GtkWidget)
EndImport

; Object constants
#MainWin  = 0
#But1     = 0


Global.i gEvent, gQuit

Procedure.i IsWindowVisible(Window)
	Protected.i Visible= #False
	CompilerIf #PB_Compiler_OS= #PB_OS_Windows
		Visible= IsWindowVisible_(WindowID(Window))
	CompilerElseIf #PB_Compiler_OS= #PB_OS_Linux
		Visible= gdk_window_is_visible_(gtk_widget_get_window(WindowID(Window)))
	CompilerEndIf
	ProcedureReturn Visible
EndProcedure

If OpenWindow(#MainWin, 300, 200, 200, 200, "Window IsVisible()", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	
	ButtonGadget(#But1, 5, 5, 190, 25, "Hide Window and wait")
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
			Case #PB_Event_Gadget
				If EventGadget()= #But1
					HideWindow(#MainWin, #True)
					AddWindowTimer(#MainWin, 0, 2000)
					Debug "Window-visibility: " + Str(IsWindowVisible(#MainWin))
				EndIf
			Case #PB_Event_Timer
				If EventTimer()= 0
					HideWindow(#MainWin, #False)
					RemoveWindowTimer(#MainWin, 0)
					Debug "Window-visibility: " + Str(IsWindowVisible(#MainWin))
				EndIf
		EndSelect
		
	Until gQuit
EndIf
; IDE Options = PureBasic 5.40 LTS (Linux - x86)
; CursorPosition = 8
; FirstLine = 12
; Folding = -
; EnableUnicode
; EnableXP