﻿; Module/File:     Window_MoveByBgDrag.pb
; Function:        Move a window by click on empty window background - Linux
; Author:          from mestnyi-example
; Date:            Nov. 15, 2015
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------
; extensions Omi ...
; works with/without window border
; quick stop after longer movement

EnableExplicit

ImportC ""
	gtk_widget_get_window(*widget.GtkWidget)
	gdk_display_get_pointer(*display.GdkDisplay, *screen.GdkScreen, *x, *y, *mask);    gtk2.2+
	g_signal_connect(*instance, detailed_signal.p-ascii, *c_handler, *pdata, destroy= 0, flags= 0) As "g_signal_connect_data"
EndImport

; Object constants
#Win_Main = 0
#But1     = 0

Global.i gEvent, gQuit

ProcedureC Callback_ButtonMotion(*widget.GtkWindow, *event.GdkEventButton, window)
	Static.i    isPressed
	Static.i    wX, wY;                                                          pointer window relative
	Static.i    wBorderL, wBorderT;                                              left, upper window delta
	Protected.i rX, rY, rMask;                                                   pointer root relative
	
	If *event\type = #GDK_BUTTON_PRESS And *event\button= 1; 2 / 3
		wX = WindowMouseX(window)
		wY = WindowMouseY(window)
		isPressed= #True
		gdk_window_get_position_(gtk_widget_get_window(*widget), @wBorderL, @wBorderT)
		gdk_window_get_root_origin_(gtk_widget_get_window(*widget), @rX, @rY)
		wBorderL- rX : wBorderT- rY
	ElseIf *event\type = #GDK_BUTTON_RELEASE
		isPressed= #False
	EndIf

	If isPressed
		gdk_display_get_pointer(gdk_display_get_default_(), #Null, @rX, @rY, @rMask)
		gtk_window_move_(*widget, rX- wX- wBorderL, rY- wY- wBorderT)
		If Not (rMask & #GDK_BUTTON1_MASK) : isPressed= #False : EndIf;            against trailing, quick stop
	EndIf

	ProcedureReturn 1
EndProcedure

If OpenWindow(#Win_Main, 0, 0, 300, 300, "Move window w. bg-drag", #PB_Window_ScreenCentered | #PB_Window_BorderLess)
	SetWindowColor(#Win_Main, $F4FFFF)
	TextGadget(#PB_Any, 5, 100, 290, 22, "Move window by background-drag", #PB_Text_Center)
	ButtonGadget(0,     5, 120, 290, 60, "Close window")
	
; 	gtk_widget_add_events_(WindowID(#Win_Main), #GDK_BUTTON1_MOTION_MASK);     not necessary
	g_signal_connect(WindowID(#Win_Main), "event",  @Callback_ButtonMotion(), #Win_Main)
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
				
			Case #PB_Event_CloseWindow
				gQuit= #True
				
			Case #PB_Event_Gadget
				If EventGadget() = #But1
					gQuit= #True
				EndIf
				
		EndSelect
		
	Until gQuit
EndIf
; IDE Options = PureBasic 5.40 LTS (Linux - x86)
; CursorPosition = 53
; FirstLine = 24
; Folding = -
; EnableUnicode
; EnableXP