﻿; Module/File:     Window_SetKeepAboveOwns.pb
; Function:        Keep an Window above others in own stack - Linux gtk2/gtk3
; Author:          Omi
; Date:            Feb. 21, 2015
; Version:         0.1
; Target Compiler: PureBasic 5.22/5.31/5.40
; Target OS:       Linux: (X/K/L)ubuntu, Mint, 32/64, Ascii/Uni
;--------------------------------------------------------------
;Function depends on window-manager!
;see optional PB-Version ParentWindowID-Parameter (not resetable)
;for keeping above all other Windows see PB-Version StickyWindow() or API Window_SetKeepAboveAll.pb

EnableExplicit

; Object constants
#MainWin  = 0
#SecWin   = 1

#Txt1     = 0
#But1     = 1


#WinX=300
#WinY=200
#WinW=200
#WinH=200

Global.i gEvent, gWindow, gQuit

Procedure WindowKeepAboveOwn(Window, Parent, KeepAbove)
	If KeepAbove
		gtk_window_set_transient_for_(WindowID(Window), WindowID(Parent))
	Else
		gtk_window_set_transient_for_(WindowID(Window), #Null)
	EndIf
EndProcedure

If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "Main Window", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	TextGadget(#Txt1, 5, 5, 190, 42, "Function depends on window-manager!")
	;PureBasic-possibility - not resetable ...
	;OpenWindow(#SecWin, #WinX, #WinY, #WinW- 20, #WinH- 20, "2. Window", #PB_Window_SystemMenu | #PB_Window_ScreenCentered, WindowID(#MainWin))
	OpenWindow(#SecWin, #WinX, #WinY, #WinW- 20, #WinH- 20, "2. Window", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	ButtonGadget(#But1, 5, 5, 170, 26, "Keep above own", #PB_Button_Toggle)
EndIf
	
Repeat
	gEvent = WaitWindowEvent()
	gWindow= EventWindow()
	
	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
		Case #PB_Event_Gadget
			If gWindow= #SecWin
				If EventGadget()= #But1
					If GetGadgetState(#But1)
						WindowKeepAboveOwn(#SecWin, #MainWin, #True)
					Else
						WindowKeepAboveOwn(#SecWin, #MainWin, #False)
					EndIf
				EndIf
					
			EndIf
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.40 LTS (Linux - x86)
; CursorPosition = 7
; Folding = -
; EnableUnicode
; EnableXP
; Executable = ../../PureBasic-Linux-API-Viewer/LAV005c
; DisableCompileCount = 557